--[[	Copyright (c) 2015 Kzisor/Ysovuka	]]

local function MakeThirstBadge( self, badge_name, bank, build, background_build)

		local ThirstBadge = require "widgets/thirstbadge"
		self[badge_name] = self:AddChild(ThirstBadge(self.owner, bank, build, background_build))

		
		if TUNING.THIRST_CUSTOM_HUD == 0 then
			self.brain:SetPosition(40,-50,0)
			self[badge_name]:SetPosition(-40,-50,0)
			if self.beaverness ~= nil then
				self.beaverness:SetPosition(-120, 20, 0)
			end
		else
			self[badge_name]:SetPosition(-55*TUNING.THIRST_BADGE_POSITION2,-90*TUNING.THIRST_BADGE_POSITION1,0)
		end
		
		
		local function thirstdelta( data )
			
			self[badge_name]:SetPercent( data.newpercent, data.currentthirst, data.maxthirst, data.penaltythirst )

		end

		local function OnSetPlayerMode( self )
			if self["onthirstdelta"] == nil then
				self["onthirstdelta"] = function( owner, data ) thirstdelta( data ) end
				self.inst:ListenForEvent( "thirstdelta", self["onthirstdelta"], self.owner )
				if self.owner.replica.thirst then
					thirstdelta( 
					  { newpercent = self.owner.replica.thirst:GetPercent(),
						currentthirst = self.owner.replica.thirst:GetCurrent(),
						maxthirst = self.owner.replica.thirst:Max(),
						penaltythirst = self.owner.replica.thirst:GetPenalty() })
				end
			end
		end

		local function OnSetGhostMode( self )

			if self["onthirstdelta"] ~= nil then

				self.inst:RemoveEventCallback( "thirstdelta", self["onthirstdelta"], self.owner )

				self["onthirstdelta"] = nil

			end

		end

		self.__SetGhostMode = self.SetGhostMode

		function self:SetGhostMode( ghostmode )
			self.__SetGhostMode( self, ghostmode )
			if ghostmode then
				self[badge_name]:Hide()
				OnSetGhostMode( self )
			else
				self[badge_name]:Show()
				OnSetPlayerMode( self )
			end
		end

		OnSetPlayerMode( self )



	return self

end

local function StatusDisplaysPostInit( self )
	MakeThirstBadge( self, "thirst", "thirst", "thirst", "thirst", true, true)
end

AddClassPostConstruct( "widgets/statusdisplays", StatusDisplaysPostInit)