local cwater = Class(function(self, inst)
    self.inst = inst
	
    self.waterperdrink = TUNING.THIRST_WATER_PER_SIP
    self.healthperdrink = 0
    self.hungerperdrink = 0
	self.sanityperdrink = 0
	
	self.poisoned = false
    self.period = 2*TUNING.DES_THIRST_LAG_FACTOR
	
    self.watergainspeed = -1

	self.current = 0
	self.max = 0
	self.salt = 0
	
	self.bad = 0
	
	self.filled = ""
	
	self.destspeed = 0
	self.cleanspeed = 0

	self.bottletempdelta = nil
	
	self.inst:AddTag("cwater")
	-------des_bottle
	self.inst:AddTag("cwater_icon")
	--self.inst:AddTag("des_cwater_third")
	self.inst:AddTag("des_cwater_full")
	
	self.special_drink = ""
	
	
	
	if self.inst:HasTag("des_bottle") then
		self.inst:AddTag("cwater_des_bottle")
	end
	
    self.task = self.inst:DoPeriodicTask(self.period, function() self:DoDec(self.period) end)
	
end)


function cwater:LongUpdate(dt)
	self:DoDec(dt, true)
end




function cwater:OnSave()
	if self.special_drink == "" then
		self.special_drink = "water"
	end
--[[
	if self.inst.components.perishable then
		self.inst:RemoveComponent("perishable")
		self.inst:RemoveTag("show_spoilage")
		self.inst:DoTaskInTime(0.5, function()
			self.inst:AddComponent("perishable")
			self.inst:AddTag("show_spoilage")
			self.inst.components.perishable:SetPerishTime(TUNING.PERISH_SUPERSLOW*100)
			self.inst.components.perishable:StopPerishing()
		end)
	end--]]
	return {cwater = self.current, salt = self.salt, bad = self.bad, filled = self.filled, special_drink = self.special_drink}
end

function cwater:OnLoad(data)
    if data.cwater then
        self.current = data.cwater
		self.salt = data.salt or 0
		self.bad = data.bad or 0
		self.filled = data.filled or ""
		self.special_drink = tostring(data.special_drink) or "water"
		print("======================================")
		print("======================================")
		print("ON LOAD CWATER: ", self.special_drink)
		if self.special_drink == "water" then self.special_drink = "" end
		print("ON LOAD CWATER: ", self.special_drink)
		print("======================================")
		print("======================================")
		print("======================================")
		if self.special_drink == "water" then self.special_drink = "" end
		
		self.inst:AddTag("fresh")
		self.inst:RemoveTag("stale")
		self.inst:RemoveTag("spoiled")
        self:DoDelta(0)
		if self.inst:HasTag("water_trap_or_dest") then
			self:HasBottle()
		end
    end
end

function cwater:LongUpdate(dt)
end

function cwater:Pause()
    self.burning = false
end

function cwater:Resume()
    self.burning = true
end

function cwater:GetDebugString()
    return string.format("%2.2f / %2.2f", self.current, self.max)
end

function cwater:SetMax(amount)
    self.max = amount
    self.current = amount
end


function cwater:IsStarving() 
    return self.current <= 0
end


function cwater:Poison()
	self:DoDelta(0, nil, 0, self.current)
end
function cwater:ClearPoison()
	self:DoDelta(0, nil, 0, -(self.current))
end
function cwater:ClearSalt()
	self:DoDelta(0, nil, -250, 0)
end



function cwater:givenewbottle(bottle,owner,waterleft,finituses, salt, nopickup, filled, bad)
	
	local numberofslot = bottle.components.inventoryitem:GetSlotNum() or 5
	if numberofslot then
	end
	
	if finituses > 0 then
	local delta = waterleft-TUNING.THIRST_WATER_PER_SIP
	
	local newbottleprefab = bottle.prefab
	if newbottleprefab == "bottleswglass_dummy" then
		newbottleprefab = "bottleswglass"
	end
	
	local newbottle = SpawnPrefab(newbottleprefab)
	
	local slt = salt -TUNING.THIRST_WATER_PER_SIP
	local baddy = bad
	local fill = filled
	
	owner:DoTaskInTime(0.01, function()
		newbottle.Transform:SetPosition(owner.Transform:GetWorldPosition())
		newbottle.components.edible.foodtype = ""

		if not nopickup then
			owner.components.inventory:GiveItem(newbottle, numberofslot, nil, true)
		end
	end)
	newbottle.components.cwater:DoDelta(-900,newbottle)
	newbottle.components.cwater:DoDelta(delta, newbottle, slt, baddy, fill)
--	newbottle.components.cwater.salt = salt

	newbottle.components.finiteuses:SetUses(finituses)
	--local prc = newbottle.components.cwater.current/newbottle.components.cwater.max+0.01
	

	return newbottle
	end
end






function cwater:GetSaltPercent()
	--if self.inst.components.cwater.current == 0 then
	--	return 0
	--end
	return	(self.inst.components.cwater.salt/(self.inst.components.cwater.current+1))-0.1
end

function cwater:GetBadPercent()
	--if self.inst.components.cwater.current == 0 then
	--	return 0
	--end
	return	(self.inst.components.cwater.bad/(self.inst.components.cwater.current+1))-0.05
end


function cwater:GetRealSaltPercent()
	--if self.inst.components.cwater.current == 0 then
	--	return 0
	--end
	return	(self.inst.components.cwater.salt/(self.inst.components.cwater.current+1))
end

function cwater:GetRealBadPercent()
	--if self.inst.components.cwater.current == 0 then
	--	return 0
	--end
	return	(self.inst.components.cwater.bad/(self.inst.components.cwater.current+1))
end

----------------------------------------------------------------
----------------------------------------------------------------
----------------------------------------------------------------
----------------------------------------------------------------

function cwater:GetDisc(nst, drks)
	local inst = nst or self.inst
	local discr = ""
	local drinks = drks or math.ceil(self.inst.components.cwater.current/TUNING.THIRST_WATER_PER_SIP)
	local saltpercent = self:GetSaltPercent()
	local badpercent = self:GetBadPercent()
	local nameofdrink = ""
	local finite_fix_klei_retarded_fuckers = 0
	local finite_fix_klei_retarded_fuckers_max = 0
	local finite_fix_klei_retarded_fuckckers_to_show = ""
	

	
	if drinks ==1 then
		discr = "它几乎是空的"
	elseif drinks>1 then
		discr = "我可以喝它 "..drinks.."次"
	else
		discr = "它是空的!"
	end
	
	
	local sip = TUNING.THIRST_WATER_PER_SIP
	local maxdrinks = math.ceil(inst.components.cwater.max/sip)
	local numrinks = math.ceil(inst.components.cwater.current/sip)
	local partofdrinks = "可饮用次数："..numrinks.."/"..maxdrinks.."\n 水量: "..math.floor(inst.components.cwater.current)
	
	local badstring = ""
	local spoilment = ""
	local special_drink = inst.components.cwater.special_drink
	local name_show = ""
	
	if special_drink == "water" then
		inst.components.cwater.special_drink = ""
		special_drink = ""
	end
	
	if special_drink ~= "" and TUNING.BOTTLE_DRINKS_TYPE[special_drink] and TUNING.BOTTLE_DRINKS_TYPE[special_drink]["name_show"] then
		name_show = TUNING.BOTTLE_DRINKS_TYPE[special_drink]["name_show"]
		name_show = name_show.."\n"
	elseif special_drink ~= "" then
		print("-----============-----")
		print("-----============-----")		
		print("-----============-----")
		print("-----============-----")
		print("-----============-----")		
		print("-----============-----")
		print(" cwater:GetDisc(nst, drks) something is wrong")
		print(special_drink, "array is missing")
		print("-----============-----")
		print("-----============-----")		
		print("-----============-----")
		print("-----============-----")
		print("-----============-----")		
		print("-----============-----")
	end
	
	
	if self.inst.components.finiteuses then
		finite_fix_klei_retarded_fuckers = math.floor(self.inst.components.finiteuses.current)
		finite_fix_klei_retarded_fuckers_max = math.floor(self.inst.components.finiteuses.total)
	end
	
	partofdrinks = name_show..partofdrinks
	discr = name_show..discr
	
	if self.inst:HasTag("bottle") then
		if badpercent>0 then 		
			partofdrinks = partofdrinks.." \n "..math.floor(self.inst.components.cwater.bad).." 污染浓度"
		end	
		if badpercent>0.99 then
			badstring = ""
			discr = discr.."\n 这是毒药！"
		elseif badpercent>0.7 then
			badstring = ""
			discr = discr.."\n 这是坏的！"
		elseif badpercent>0.55 then
			badstring = ""
			discr = discr.."\n 这不新鲜了!"
		elseif badpercent>0.45 then
			badstring = "死水"
			discr = discr.."\n 这个是静止的"
		elseif badpercent>0.25 then
			badstring = "混浊的水"
			discr = discr.."\n 这水已经很混浊了"
		elseif badpercent>=0 then
		--	discr = discr.."\n It's good."
		end
	
	
		if saltpercent>0 then 
			partofdrinks = partofdrinks.." \n "..math.floor(self.inst.components.cwater.salt).." 盐浓度"
		end
		if saltpercent>0.6 then
			discr = discr.."\n 盐太多了!"
		elseif saltpercent>0.3 then
			discr = discr.."\n 仍然咸"
		elseif saltpercent>0.1 then
			discr = discr.."\n 几乎不咸"
		elseif saltpercent>=0 then
			discr = discr.."\n 一点都不咸"
		end
		
		
		
		finite_fix_klei_retarded_fuckckers_to_show = "\n 可使用次数: \n"..finite_fix_klei_retarded_fuckers.."/"..finite_fix_klei_retarded_fuckers_max
	
		
		partofdrinks = badstring.." "..nameofdrink.." \n "..partofdrinks..""..finite_fix_klei_retarded_fuckckers_to_show
	end
	
	if numrinks==0 then partofdrinks = "Empty" end

	if numrinks==0 and self.inst:HasTag("bottle") then
		finite_fix_klei_retarded_fuckckers_to_show = "空的 \n 可使用次数: \n"..finite_fix_klei_retarded_fuckers.."/"..finite_fix_klei_retarded_fuckers_max
		partofdrinks = finite_fix_klei_retarded_fuckckers_to_show
	end
	
	inst.components.inspectable:SetDescription(discr)
	inst.components.named:SetName(partofdrinks)

	return discr
end


function cwater:GetDiscDest(drks)
	local discr = ""
	local bottledisc = ""
	local drinks = drks or math.ceil(self.inst.components.cwater.current/TUNING.THIRST_WATER_PER_SIP)
	

	if drinks ==1 then
		discr = "它几乎是空的"
	elseif drinks>1 then
		discr = "我可以喝它 "..drinks.."次"
	else
		discr = "它是空的!"
	end


	if self:HasBottle() then
		bottledisc = self.addedbottle.components.cwater:GetDisc(self.addedbottle)
		discr = discr.." \n 里面有一个瓶子... \n"..bottledisc
	elseif self.inst.components.cwater:GetPercent()>0.1 and self.inst:HasTag("water_dest_coal") then
		discr = discr.." \n 水流到地上了!"
	end

	
	self.inst.components.inspectable:SetDescription(discr)
	
end


function cwater:GetDiscCatcher(drks)
	local discr = ""
	local bottledisc = ""
	local drinks = drks or math.ceil(self.inst.components.cwater.current/TUNING.THIRST_WATER_PER_SIP)
	local frozen_barrel = ""
	local current = math.ceil(self.inst.components.cwater.current)
	
	if self.inst:HasTag("des_chainik_update_discr") and self.inst.components.des_chainik_c and self.inst.components.des_chainik_c.boiling then
		drinks = math.ceil(self.inst.components.des_chainik_c.cooked_ready/TUNING.THIRST_WATER_PER_SIP)
	end
	
	if drinks ==1 then
		discr = "它几乎是空的"
	elseif drinks>1 then
		discr = "我可以喝它 "..drinks.."次"
	else
		discr = "它是空的!"
	end
	
	if self.special_drink == "water" then self.special_drink = "" end

	
--	local partofdrinks = numrinks.."/"..maxdrinks.." drinks \n "..inst.components.cwater.current.." water"

	if self.inst:HasTag("water_dest_barrel") and self.inst.frozen == true then
		frozen_barrel = "它结冰了！ \n"
	end
	if self.inst:HasTag("des_watercatcher_update_fakedrop") and self.inst.des_fakedrop then
		local des_fakedrop_name = "可饮用次数:"..drinks.."\n 水量："..tostring(self.current).."/"..tostring(self.max)
		
		if self.inst:HasTag("water_dest_barrel") or self.inst:HasTag("des_chainik_update_discr") then
			if self.inst.components.cwater.bad>0 then des_fakedrop_name = des_fakedrop_name.." \n "..math.floor(self.inst.components.cwater.bad).." 污染度" end
			if self.inst.components.cwater.salt>0 then des_fakedrop_name = des_fakedrop_name.." \n "..math.floor(self.inst.components.cwater.salt).."盐度" end
		end
		
		
		if  self.inst.components.des_chainik_c and self.inst.components.des_chainik_c.boiling then
			
			local current1 = math.ceil(self.inst.components.cwater.current)
			local cooked_ready = math.ceil(self.inst.components.des_chainik_c.cooked_ready)
			local max_cook_drinks = math.ceil(self.inst.components.des_chainik_c.maximum_drink_output/TUNING.THIRST_WATER_PER_SIP)
			
			
			des_fakedrop_name = drinks.." 份 \n 开水量: \n"..tostring(cooked_ready).."/"..tostring(current1)
		end
		
		self.inst.des_fakedrop.components.named:SetName(des_fakedrop_name)
		---self.inst.components.inspectable:SetDescription("")
		if drinks <= 1 then
			---self.inst.des_fakedrop:RemoveComponent("stackable")----:SetStackSize(math.ceil(drinks))
			--self.inst.des_fakedrop.components.inventoryitem.atlasname = "images/inventoryimages/des_waterdrop_fake_empty.xml"
			self.inst.des_fakedrop.components.stackable:SetStackSize(1)

		elseif drinks ~= self.inst.des_fakedrop.components.stackable:StackSize() then
			self.inst.des_fakedrop.components.inventoryitem.atlasname = "images/inventoryimages/des_waterdrop_fake.xml"
			self.inst.des_fakedrop.components.stackable:SetStackSize(math.ceil(drinks))
		end
	end


	
	if self.inst:HasTag("des_update_waterdrop_fake_chai") and self.inst.des_fakedrop_chainik then
		local drink_name = "Water"
		
		if self.special_drink == "" then
		elseif TUNING.BOTTLE_DRINKS_TYPE[self.special_drink] then
			local array = TUNING.BOTTLE_DRINKS_TYPE[self.special_drink]
			drink_name = array["name_show"]
			
			if array["health"] ~= 0 then
				drink_name = drink_name.."\n"..tostring(array["health"]).." 血量"
			end
			if array["hunger"] ~= 0 then
				drink_name = drink_name.."\n"..tostring(array["hunger"]).." 饥饿"
			end			
			if array["sanity"] ~= 0 then
				drink_name = drink_name.."\n"..tostring(array["sanity"]).." 理智"
			end
			if array["thirst"] ~= 0 then
				drink_name = drink_name.."\n"..tostring(array["thirst"]+50).." 饥渴度"
			end

					
			if drinks ==1 then
				discr = "有一小口"..array["name_show"].." 在里面."
			elseif drinks>1 then
				discr = "它里面的 "..array["name_show"].." 还可以饮用 "..drinks.." 次"
			else
				discr = "它是空的!"
			end

		
		end

		
		
		
		self.inst.des_fakedrop_chainik.components.named:SetName(drink_name)
	end	
	
	
	
	
	if self.inst:HasTag("des_chainik_update_discr") and self.inst.components.des_chainik_c and self.inst.components.des_chainik_c.boiling then
		local current1 = math.ceil(self.inst.components.cwater.current)
		local cooked_ready = math.ceil(self.inst.components.des_chainik_c.cooked_ready)
		local max_cook_drinks = math.ceil(self.inst.components.des_chainik_c.maximum_drink_output/TUNING.THIRST_WATER_PER_SIP)
		
		discr = "它沸腾"..drinks.." 份 准备好了 "..max_cook_drinks.."!"
		discr = discr.."\n 开水量: \n"..tostring(cooked_ready).."/"..tostring(current1)
		
	end
	
	
	if self.inst:HasTag("water_dest_new") then
		if self:HasBottle() then
			bottledisc = self.addedbottle.components.cwater:GetDisc(self.addedbottle)
			discr = discr.." \n 里面有一个瓶子... \n"..bottledisc
		elseif self.inst.components.cwater:GetPercent()>0.1 and self.inst:HasTag("water_dest_coal") then
			discr = discr.." \n 水流到地上了!"
		end
	end
	
	self.inst.components.inspectable:SetDescription(frozen_barrel..discr)
	
end



----------------------------------------------------------------
----------------------------------------------------------------
----------------------------------------------------------------








function cwater:ConvertFillerToName(filler)
	if not TUNING.BOTTLE_DRINKS_TYPE[filler] then return "Water000" end
	
	return TUNING.BOTTLE_DRINKS_TYPE[name]["nameof"]
end




function cwater:AddBottle(inst)

	if self.inst:HasTag("water_dest_new") then 

		--print
	end
		
		
	--if self.addedbottle then print(self.inst.prefab, self.addedbottle.prefab) end
	if self.addedbottle then return self.addedbottle end
	
	if inst and inst==self.addedbottle then return end
	---self.addedbottle = inst or FindEntity(self.inst, 0.25, function(guy) return guy:HasTag("bottle") end)

	if self.inst:HasTag("water_trap_or_dest") then 

		local bottle = self.inst.components.container:GetItemInSlot(self.inst.fakedrop_slot+1)
		if bottle and bottle:HasTag("des_fillable_on_catcher") then
			self.addedbottle = bottle

		end
	end
	
	
	if self.addedbottle then
		--if self.inst.components.activatable then self.inst.components.activatable.inactive = nil end
		
		
		if self.inst.components.inventoryitem then
			self.inst.components.inventoryitem.canbepickedup = nil
		--	self.inst:RemoveComponent("inventoryitem")
		end	
	end
	return self.addedbottle
end

function cwater:HasBottle(inst)
	
	if self.addedbottle then
		self:RemoveBottle()
	end
	self:AddBottle(inst)

	return self.addedbottle
	
end

function cwater:RemoveBottle()

	self.addedbottle = nil
	
	if TUNING.MOVETRAPS==false then
		self.inst.components.inventoryitem.canbepickedup = nil
	else---if self.inst.
		self.inst.components.inventoryitem.canbepickedup = nil
	end
	--if self.inst.components.activatable then self.inst.components.activatable.inactive = true end
end


local function TemperatureDeltaFix(target, delta)
	local temp = target.components.temperature
	local dlt = delta/6
	temp:DoDelta(delta)
	
	target:DoTaskInTime(0.3, function() 
		temp:DoDelta(dlt)
	end)	
	target:DoTaskInTime(0.6, function() 
		temp:DoDelta(dlt)
	end)		
	target:DoTaskInTime(0.9, function() 
		temp:DoDelta(dlt)
	end)		
	target:DoTaskInTime(1.2, function() 
		temp:DoDelta(dlt)
	end)		
	target:DoTaskInTime(1.5, function() 
		temp:DoDelta(dlt)
	end)	
end

---------------------------------------------------------
--------------------On eaten BUFFS-----------------------
---------------------------------------------------------
local function HealBoost(inst,data)

	if (data.oldpercent >= data.newpercent) or inst:HasTag("des_thirsthealboost_stopoverflow") then
		return
	end

	local max_hp = inst.components.health.maxhealth
	local bonus_percent = data.newpercent - data.oldpercent
	local bonus = max_hp*bonus_percent * TUNING.DES_THIRST_HEAL_BOOST_POWER
	
	inst:AddTag("des_thirsthealboost_stopoverflow")
	if inst.components.health.currenthealth > 0 then
		print("HealBoost "..bonus)
		
		inst:DoTaskInTime(0.1, function()
			inst:RemoveTag("des_thirsthealboost_stopoverflow")
		end)		
		
		inst.components.health:DoDelta(bonus, true)
		if inst.components.des_hurts then
			inst.components.des_hurts:Heal(bonus*4)
		end
	end
end

local function SanityBoost(inst,data)

	if (data.oldpercent >= data.newpercent) or inst:HasTag("des_thirstsanityboost_stopoverflow") then
		return
	end

	local max_sanity = inst.components.sanity.max
	local bonus_percent = data.newpercent - data.oldpercent
	local bonus = max_sanity*bonus_percent * TUNING.DES_THIRST_SANITY_BOOST_POWER
	
	inst:AddTag("des_thirstsanityboost_stopoverflow")
	if inst.components.health.currenthealth > 0 then
		print("Sanity Boost "..bonus)
		
		inst:DoTaskInTime(0.1, function()
			inst:RemoveTag("des_thirstsanityboost_stopoverflow")
		end)		
		
		inst.components.sanity:DoDelta(bonus, true)

	end
end

local function HungerBoost(inst,data)

	if (data.oldpercent >= data.newpercent) or inst:HasTag("des_thirsthungerboost_stopoverflow") then
		return
	end

	local max_hunger = inst.components.hunger.max
	local bonus_percent = data.newpercent - data.oldpercent
	local bonus = max_hunger*bonus_percent * TUNING.DES_THIRST_HUNGER_BOOST_POWER
	
	inst:AddTag("des_thirsthungerboost_stopoverflow")
	if inst.components.health.currenthealth > 0 then
		print("SanityBoost "..bonus)
		
		inst:DoTaskInTime(0.1, function()
			inst:RemoveTag("des_thirsthungerboost_stopoverflow")
		end)		
		
		inst.components.hunger:DoDelta(bonus, true)

	end
end



function cwater:GiveBonusFromSpecial(eater, cup, des_special_ask)
	local spacial_bonus = ""
	if des_special_ask then
		spacial_bonus = des_special_ask
	elseif cup then
		spacial_bonus = cup.spacial_bonus
	end
	
	if spacial_bonus and spacial_bonus ~= "" then
		if spacial_bonus == "shadow" then 
			---fix for drinking new brew---
			---before old one end----------		
			if eater.des_shadow_task then
				eater:RemoveComponent("transparentonsanity")
				eater.des_shadow_task:Cancel()
				eater.des_shadow_task = nil
				
				eater.AnimState:OverrideMultColour(1, 1, 1, 1)
				if eater.SoundEmitter ~= nil then
					eater.SoundEmitter:OverrideVolumeMultiplier(1)
				end
			end
			if eater.des_shadow_task_wearoff then
				eater.des_shadow_task_wearoff:Cancel()
				eater.des_shadow_task_wearoff = nil
			end
			------------------------
			-----this adds bonus----
			local shadow_give_up_timer = 1	
			eater.components.talker:Say("我觉得自己像一个影子")
			eater:AddComponent("transparentonsanity")
			eater.des_shadow_task = eater:DoPeriodicTask(shadow_give_up_timer, function()
				local enemy = FindEntity(eater, 15, function(fire)
					if fire:HasTag("shadowcreature") and fire:HasTag("notraptrigger") and fire:HasTag("shadow")
						and fire.components.combat and fire.components.combat.target and fire.components.combat.target == eater
					then
						return fire
						
					end
				end)
				if enemy then
					enemy.components.combat:GiveUp()
				end
			end)
			------------------------
			---this removes bonus---
			eater.des_shadow_task_wearoff = eater:DoTaskInTime(TUNING.DES_THIRST_SHADOW_BREW_TIME, 
			function()
				if eater.des_shadow_task then
					eater.des_shadow_task:Cancel()
					eater.des_shadow_task = nil
					
					if eater.des_shadow_task_wearoff then
						eater.des_shadow_task_wearoff:Cancel()
						eater.des_shadow_task_wearoff = nil
					end
					
					eater.AnimState:OverrideMultColour(1, 1, 1, 1)
					if eater.SoundEmitter ~= nil then
						eater.SoundEmitter:OverrideVolumeMultiplier(1)
					end

					
					eater:RemoveComponent("transparentonsanity")

					eater.components.talker:Say("我又觉得自己像个人了")
						
				end
			end)
			------------------------
		elseif spacial_bonus == "beebrew" then
			---fix for drinking new brew---
			---before old one end----------		
			if eater.des_bee_task then
				eater.des_bee_task:Cancel()
				eater.des_bee_task = nil
			end
			if eater.des_bee_task_wearoff then
				eater.des_bee_task_wearoff:Cancel()
				eater.des_bee_task_wearoff = nil
			end
			------------------------
			-----this adds bonus----
			local bee_give_up_timer = 1
			eater.components.talker:Say("我觉得自己像个蜜蜂！")
			eater.des_bee_task = eater:DoPeriodicTask(bee_give_up_timer, function()
				local enemy = FindEntity(eater, 10, function(fire)
					if (fire:HasTag("pollinator") and fire:HasTag("worker")) or (fire:HasTag("killer") and fire:HasTag("scarytoprey"))
						and fire.components.combat and fire.components.combat.target and fire.components.combat.target == eater					
					then
						print(fire,"敌人蜜蜂发现")
						return fire
						
					end
				end)
				
				if enemy then
					enemy.components.combat:GiveUp()
				end
				
				local enemy2 = FindEntity(eater, 5, function(fire)
					if (fire:HasTag("pollinator") and fire:HasTag("worker")) or (fire:HasTag("killer") and fire:HasTag("scarytoprey"))
						and fire.components.combat and fire.components.combat.target and fire.components.combat.target == eater					
					then
						print(fire,"敌人蜜蜂发现")
						return fire
						
					end
				end)					
				if enemy2 then
					enemy2.components.combat:GiveUp()
				end				
			end)

			------------------------
			---this removes bonus---
			eater.des_bee_task_wearoff = eater:DoTaskInTime(TUNING.DES_THIRST_BEE_BREW_TIME, 
			function()
				if eater.des_bee_task then
					eater.des_bee_task:Cancel()
					eater.des_bee_task = nil
				end
				if eater.des_bee_task_wearoff then
					eater.des_bee_task_wearoff:Cancel()
					eater.des_bee_task_wearoff = nil
				end

				eater.components.talker:Say("我又觉得自己像个人了")
			end)	
			------------------------

		elseif spacial_bonus == "healboost" then
			---fix for drinking new brew---
			---before old one end----------
			if eater.des_tea_healbooster_task then
				eater.des_tea_healbooster_task:Cancel()
				eater.des_tea_healbooster_task = nil
				eater:RemoveTag("des_tea_healbooster")
				
				eater:RemoveEventCallback("healthdelta", HealBoost)
			end
			------------------------
			-----this adds bonus----
			eater.components.talker:Say("I will heal better!")
			eater:AddTag("des_tea_healbooster")
			eater:ListenForEvent("healthdelta", HealBoost)
			------------------------
			---this removes bonus---
			eater.des_tea_healbooster_task = eater:DoTaskInTime(TUNING.DES_THIRST_HEAL_BOOST_TIME, 
			function()
				eater.des_tea_healbooster_task:Cancel()
				eater.des_tea_healbooster_task = nil
				eater:RemoveTag("des_tea_healbooster")
				eater.components.talker:Say("恢复时间已经结束了!")
				
				eater:RemoveEventCallback("healthdelta", HealBoost)
			end)
			------------------------
		elseif spacial_bonus == "hungerboost" then
			---fix for drinking new brew---
			---before old one end----------
			if eater.des_tea_hungerbooster_task then
				eater.des_tea_hungerbooster_task:Cancel()
				eater.des_tea_hungerbooster_task = nil
				eater:RemoveTag("des_tea_hungerbooster")
				
				eater:RemoveEventCallback("hungerdelta", HungerBoost)
			end
			------------------------
			-----this adds bonus----
			eater.components.talker:Say("我的腹部工作的更好了!")
			eater:AddTag("des_tea_hungerbooster")
			eater:ListenForEvent("healthdelta", HungerBoost)
			------------------------
			
			---this removes bonus---
			eater.des_tea_hungerbooster_task = eater:DoTaskInTime(TUNING.DES_THIRST_HUNGER_BOOST_TIME, 
			function()
				eater.des_tea_hungerbooster_task:Cancel()
				eater.des_tea_hungerbooster_task = nil
				eater:RemoveTag("des_tea_hungerbooster")
				eater.components.talker:Say("宴会时间已经结束!")
				
				eater:RemoveEventCallback("hungerdelta", HungerBoost)
			end)
			------------------------
			
		elseif spacial_bonus == "sanityboost" then
			---fix for drinking new brew---
			---before old one end----------
			if eater.des_tea_sanitybooster_task then
				eater.des_tea_sanitybooster_task:Cancel()
				eater.des_tea_sanitybooster_task = nil
				eater:RemoveTag("des_tea_sanitybooster")
				
				eater:RemoveEventCallback("sanitydelta", SanityBoost)
			end
			------------------------
			-----this adds bonus----
			eater.components.talker:Say("我的大脑更加灵活了!")
			eater:AddTag("des_tea_sanitybooster")
			eater:ListenForEvent("sanitydelta", SanityBoost)
			------------------------
			
			---this removes bonus---
			eater.des_tea_sanitybooster_task = eater:DoTaskInTime(TUNING.DES_THIRST_SANITY_BOOST_TIME, 
			function()
				eater.des_tea_sanitybooster_task:Cancel()
				eater.des_tea_sanitybooster_task = nil
				eater:RemoveTag("des_tea_sanitybooster")
				eater.components.talker:Say("理智正在恢复正常")
				
				eater:RemoveEventCallback("sanitydelta", SanityBoost)
			end)
			------------------------
		end
	
	
	
		if spacial_bonus == "drybrew" then
			---fix for drinking new brew---
			---before old one end----------		
			if eater.des_drytea_task then
				eater.des_drytea_task:Cancel()
				eater.des_drytea_task = nil
			end
			if eater.des_drytea_task_wearoff then
				eater.des_drytea_task_wearoff:Cancel()
				eater.des_drytea_task_wearoff = nil
			end
			------------------------
			-----this adds bonus----
			local dry_off_time = 1
			local dry_rate = -3
			eater.components.talker:Say("我不会再被淋湿了!")
			eater.des_drytea_task = eater:DoPeriodicTask(dry_off_time, function()
				if eater.components.moisture then
					eater.components.moisture:DoDelta(dry_rate)
				end
			end)

			------------------------
			---this removes bonus---
			eater.des_drytea_task_wearoff = eater:DoTaskInTime(TUNING.DES_THIRST_BEE_BREW_TIME, 
			function()
				if eater.des_drytea_task then
					eater.des_drytea_task:Cancel()
					eater.des_drytea_task = nil
				end
				if eater.des_drytea_task_wearoff then
					eater.des_drytea_task_wearoff:Cancel()
					eater.des_drytea_task_wearoff = nil
				end

				eater.components.talker:Say("干燥时间已经结束了")
			end)	
			------------------------
		end
	
	    if spacial_bonus == "bustup" then
			
			---fix for drinking new brew---
			---before old one end----------
			if eater:HasTag("insomniac") then
				eater.des_coffe_fix_insomniac = true
			end
			if eater.des_coffeespeed_task_wearoff then
					if eater.des_coffe_fix_insomniac and eater.des_coffe_fix_insomniac == true then
					else
						eater:RemoveTag("insomniac")
					end
				
					eater.components.talker:Say("我又变慢了")
					eater.components.locomotor:RemoveExternalSpeedMultiplier(eater, "des_coffe")	
					
					eater.des_coffeespeed_task_wearoff:Cancel()
					eater.des_coffeespeed_task_wearoff = nil
			end	
			------------------------
			-----this adds bonus----		
			local final_speed_mod = TUNING.DES_THIRST_COFFEE_SPEED_MULT
			eater.components.locomotor:RemoveExternalSpeedMultiplier(eater, "des_coffe")
			eater.components.locomotor:SetExternalSpeedMultiplier(eater, "des_coffe", final_speed_mod)
			eater.components.talker:Say("我爱咖啡!")
			eater:AddTag("insomniac")
			------------------------
			---this removes bonus---
	        eater.des_coffeespeed_task_wearoff = eater:DoTaskInTime(TUNING.DES_THIRST_COFFEE_TIME, 
			function()
			
				if eater.des_coffeespeed_task_wearoff then
					if eater.des_coffe_fix_insomniac and eater.des_coffe_fix_insomniac == true then
					else
						eater:RemoveTag("insomniac")
					end
				
					eater.components.talker:Say("我又变慢了")
					eater.components.locomotor:RemoveExternalSpeedMultiplier(eater, "des_coffe")	
					
					eater.des_coffeespeed_task_wearoff:Cancel()
					eater.des_coffeespeed_task_wearoff = nil
				end		
			
			

			end)
		end
		
		
		
		
		
		
        if spacial_bonus == "ghost" and eater:HasTag("player") then
		    TheNet:Announce(""..eater:GetDisplayName().." 喝了暗影茶，变成了暗影40秒!")
	        eater.components.health:DoDelta(-10000)
			eater:DoTaskInTime(40, 
			function() 
	            TheNet:Announce(""..eater:GetDisplayName().."暗影效果结束，恢复正常！")
	            eater:PushEvent("respawnfromghost")
			end)
		end
		if spacial_bonus == "alcahol" then
	        eater:PushEvent("powerdown")
	        eater:AddTag("groggy")
	        eater:DoTaskInTime(240, 
			function()
                if eater:HasTag("groggy") then
	                eater.components.talker:Say(TUNING.BEER_OFFDRINK)
	                eater:RemoveTag("groggy")
	                eater:PushEvent("powerup")
	            end
			end)
		end
		if spacial_bonus == "monster" then
            if (eater:HasTag("monster") or eater.prefab == "woodie") and eater:HasTag("player") then
		       eater.components.health:DoDelta(37)
		       eater.components.sanity:DoDelta(25)
            end
	        if not eater:HasTag("monster") and eater:HasTag("player") then
		        eater.components.health:DoDelta(-10)
		        eater.components.sanity:DoDelta(-20)
		        eater.components.hunger:DoDelta(-10)
            end
		end
		if spacial_bonus == "spider" and not eater:HasTag("monster") then
	        eater:AddTag("monster")
			eater.components.talker:Say("I feel like a monster")
	        eater:DoTaskInTime(120, 
			function()
                eater:RemoveTag("monster")
	            eater.components.talker:Say("我又觉得自己像个人了")
			end)
		end
		if spacial_bonus == "red" then
			eater:PushEvent("yawn", { grogginess = 4, knockoutduration = TUNING.TEASLEEP_TIME + math.random() })
		end
		if spacial_bonus == "strang" then
	        eater:RemoveTag("groggy")
	        eater.components.locomotor.externalspeedmultiplier = 1
		end
	end
end
---------------------------------------------------------
------------------On eaten BUFFS end---------------------
---------------------------------------------------------

function cwater:DoFillerBuffs(target, fillername, prcnt, spoil, waterdelta)
	local freshness = 1-spoil
	if prcnt > 0.95 then prcnt = 1 end
	
	print("DoFillerBuffs: ",target, fillername, prcnt, spoil, waterdelta)
	if TUNING.BOTTLE_DRINKS_TYPE[fillername] then -- target.components.thirst:DoDelta(waterdelta*freshness) return end
	
		local hp = TUNING.BOTTLE_DRINKS_TYPE[fillername]["health"]*prcnt * freshness
		local hun = TUNING.BOTTLE_DRINKS_TYPE[fillername]["hunger"]*prcnt * freshness
		local s = TUNING.BOTTLE_DRINKS_TYPE[fillername]["sanity"]*prcnt * freshness
		local th = (TUNING.BOTTLE_DRINKS_TYPE[fillername]["thirst"]*prcnt) * freshness
		
		local special = tostring(TUNING.BOTTLE_DRINKS_TYPE[fillername]["special"])
		print("---------------="..fillername.."=--------------")
		print("TUNING.BOTTLE_DRINKS_TYPE[fillername][health = ]"..hp)
		print("TUNING.BOTTLE_DRINKS_TYPE[fillername][hunger = ]"..hun)
		print("TUNING.BOTTLE_DRINKS_TYPE[fillername][sanity = ]"..s)
		print("TUNING.BOTTLE_DRINKS_TYPE[fillername][thirst = ]"..th)
		print("TUNING.BOTTLE_DRINKS_TYPE[fillername][special = ] "..special)
		if spoil > 0.5 and hp>0 then hp = 0 end 
		if spoil > 0.5 and s>0 then s = 0 end 
		
		if target.components.health then target.components.health:DoDelta(hp) end
		if target.components.hunger then target.components.hunger:DoDelta(hun) end
		if target.components.sanity then target.components.sanity:DoDelta(s) end
		if target.components.thirst then target.components.thirst:DoDelta(th) end
		
		if prcnt == 1 and special ~= "" then
			print("GiveBonusFromSpecial")
			self:GiveBonusFromSpecial(target, nil, special)
		end
	end
end




function cwater:Drink(inst,eater)


	local waterleft = inst.components.cwater.current
	local finit = inst.components.finiteuses and inst.components.finiteuses.current
	local drinked = false
	local salt = self.salt
	local baddy = self.bad
	local fill = self.filled
	
	local remember_special_drink = self.special_drink
	
	local phrase = ""
	
	local wx = nil
	local salt_harsh = 1
	if eater.prefab == "wx78" then
		wx = true
		salt_harsh = 1.33
	end
	
	local waterdelta = 0
	local saltpercent = self:GetSaltPercent() * salt_harsh
	local badpercent = self:GetBadPercent()

	if wx == true then
		badpercent = 1 - self:GetRealBadPercent()
	end

	---print("saltpercent = "..saltpercent)
  if eater and eater.components.thirst then
		finit = self.inst.components.finiteuses and inst.components.finiteuses.current
		--if self.current>1 then
		--	finit = finit-1
		--end
		
	
			local waterdelta_forced = -TUNING.THIRST_WATER_PER_SIP
			if self.current> TUNING.THIRST_WATER_PER_SIP then
				drinked = true
				waterdelta = TUNING.THIRST_WATER_PER_SIP
			elseif self.current> 1 then
			--	eater.components.thirst:DoDelta(self.current)
				drinked = true
				waterdelta = self.current
			elseif self.current< 1 then
				phrase = "它是空的!"
				waterdelta = 0
			end
			if saltpercent > 0 then
				eater.components.health:DoDelta(-waterdelta*saltpercent*TUNING.SALT_TO_DAMAGE)
				waterdelta = waterdelta - (waterdelta*saltpercent*TUNING.SALT_TO_DAMAGE)*0.75
				phrase = "咸! \n"
			end
			
			if badpercent > 0.2 then
				eater.components.hunger:DoDelta(-waterdelta*badpercent*TUNING.BAD_TO_HUNGERDAMAGE)
				eater.components.sanity:DoDelta(-waterdelta*badpercent*TUNING.BAD_TO_HUNGERDAMAGE)
				waterdelta = waterdelta - (waterdelta*badpercent*TUNING.BAD_TO_HUNGERDAMAGE)/2
				
				if not wx then
					if badpercent < 0.3 then
						phrase = phrase.."这不新鲜了!"
					elseif badpercent < 0.6 then
						phrase = phrase.."这个是静止的!"
					else
						phrase = phrase.."这是坏的！!"
					end
				else
					if badpercent < 0.3 then
						phrase = phrase.."低污染"
					elseif badpercent < 0.6 then
						phrase = phrase.."不是特别陈旧"
					else
						phrase = phrase.."太新鲜了"
					end
				end
			end

			if inst.prefab == "des_potato_cup" then
				eater.components.hunger:DoDelta(waterdelta)			
			end
			
			-------------------ERROR-----------------
			local salt_water_delta = -(waterdelta_forced * saltpercent)
			local bad_water_delta = -(waterdelta_forced * badpercent)
			----self:DoDelta(-waterdelta_forced)
			
			--self.bad = self.current*badpercent
			--self.salt = self.current*saltpercent
			-----------, self.inst, salt_water_delta, bad_water_delta)
			local z_slt = self.inst.components.cwater.salt
			local z_bad = self.inst.components.cwater.bad
			
			local per_slt = z_slt / self.inst.components.cwater.current
			local per_bad = z_bad / self.inst.components.cwater.current
			
			self:DoDelta(waterdelta_forced) ----, nil, salt_water_delta, bad_water_delta)
			
			if self.inst.components.cwater.current > 0 then
				self.inst.components.cwater.salt = math.ceil(per_slt*self.inst.components.cwater.current)
				self.inst.components.cwater.bad = math.ceil(per_bad*self.inst.components.cwater.current)
			else
				self.inst.components.cwater.salt = 0
				self.inst.components.cwater.bad = 0
			end
			
			--self:DoDelta(waterdelta_forced, self.inst, salt_water_delta, bad_water_delta)																		)
			if waterdelta>0 and self.inst.components.finiteuses then
				self.inst.components.finiteuses:Use(1)
			end
			-------------------//error----------------
			
			if remember_special_drink and remember_special_drink ~= "" and waterdelta>0 then
				self:DoFillerBuffs(eater, remember_special_drink, waterdelta/50, self:GetBadPercent(), waterdelta)
			end
			if inst:HasTag("des_bucket") and eater.components.moisture then
				eater.components.moisture:DoDelta(waterdelta*0.4)
				waterdelta = waterdelta*0.6
			end
			eater.components.thirst:DoDelta(waterdelta)
	
	
			
	if phrase ~= "" then
		eater.components.talker:Say(phrase)
	end
	
	if self.bottletempdelta then
		TemperatureDeltaFix(eater, self.bottletempdelta * waterdelta/50)
	end
	if inst:HasTag("bottle") and inst:HasTag("FUCKIT_ALL") then
		print("FUCKIT_ALL???????// givenewbottle")
		self:givenewbottle(inst, eater,waterleft,finit, salt, nil, fill, baddy)

	end
 end	

end







local function FindOceanWaterRoG(inst, dist, atm, theta_delta)
	local attemp = atm or 0
    local dst = dist or 4
	local radius = dst
	local theta = theta_delta or math.random()*2*PI
	local offset = Vector3(radius * math.cos( theta ), 0, -radius * math.sin( theta ) )
	local pt = Vector3(inst.Transform:GetWorldPosition()) + offset  
	
	
	if pt and TheWorld.Map:GetTileAtPoint(pt:Get()) == GROUND.IMPASSABLE then
		return pt
    elseif attemp<20 then
		if theta_delta then
			FindOceanWaterRoG(inst, dst+0.75, attemp+1)
		else
			FindOceanWaterRoG(inst, dst+0.75, attemp+1, theta+PI)			
		end
	else
		return
	end
	
end

function cwater:NewBottleNoChange(item, owner, nopickup, cleansalt, cleanbad)
	local newbottle = item.components.cwater:givenewbottle(item, owner, item.components.cwater.current, item.components.finiteuses.current, item.components.cwater.salt, nopickup,  item.components.cwater.filled, item.components.cwater.bad)
	return newbottle
end



function cwater:DroppedBottle(inst, fillmax, forcedtarget, forced_nopickup, forced_snow, forced_ocean)
	local player = nil
	local bottle = inst
	local sip = TUNING.THIRST_WATER_PER_SIP
	
	
    if TheSim:GetGameID() == "DST" then
	    for _, playerf in pairs(AllPlayers) do
	        if (not playerf:HasTag("playerghost")) and (not playerf:HasTag("ghost")) and inst:GetDistanceSqToInst(playerf)< .25*.25 then
				player = playerf
            end
	    end
	else
	    local playerf = GetPlayer()
		if inst:GetDistanceSqToInst(playerf)< .25*.25 then
			player = playerf
        end
    end
	
	if not player then return end

	
	
	local nopickup = forced_nopickup or false
	
	inst:DoTaskInTime(0.1, function()
	
	local target = forcedtarget or nil--- FindEntity(inst, 4, function(guy) return guy:HasTag("water_sourse") end)
	local snow_cover = TheWorld.state and TheWorld.state.snowlevel or 0

	
	if forced_ocean then
		-----handle water_streams here
			local water_stream = FindEntity(inst, 3, function(guy) return guy:HasTag("des_river_water_sourse") end)
			if inst ~= nil and water_stream ~= nil and water_stream:HasTag("water_sourse_nolimit") and not water_stream:HasTag("fire") and inst:HasTag("bottle") then
				inst.components.cwater:DroppedBottle(inst, nil, water_stream, true)
				return
			end
	
	
			
	
	
			local offest = Vector3(player.Transform:GetWorldPosition())
			if player.components.driver then
				offest = FindWaterOffset(inst:GetPosition(), math.random() * 2*PI, 10, 10)
			else
			----c'mon there must be water around here!
				offest = FindOceanWaterRoG(inst, 3, -40, nil)
			end
		
			print("ocean offest?")
			if offest then

					---player.sg:GoToState("dolongaction")
					if player.components.moisture then player.components.moisture:DoDelta(math.random(7, 15)) end

					inst.components.cwater:DoDelta(inst.components.cwater.max, inst, inst.components.cwater.max)
					
					if snow_cover > 0.05 then
						TemperatureDeltaFix(player, -10)
					else
						TemperatureDeltaFix(player, -5)
					end
					if inst:HasTag("des_bucket") then
						inst.components.finiteuses:Use(1)
					end
			end
			
		bottle:DoTaskInTime(0.1, function()
			if bottle.components.cwater.current < 1 then
				local word = TUNING.THIRST_FIND_OCEAN_STREAM_PHRASES[math.random(#TUNING.THIRST_FIND_OCEAN_STREAM_PHRASES)]
				player.components.talker:Say(word)
			end
		end)
			
			
		return
	end
	
	if forced_snow or forced_ocean then 
		target = nil
	end
	if forced_snow then forced_ocean = nil end
	
	if (not target) and (not forced_ocean) then
		if snow_cover > 0.05 then
			player.components.talker:Say("我把瓶子装满雪。")
			
			bottle.components.cwater:EmptyBottle()
			inst.components.cwater:DoDelta(1000)	
			
			TemperatureDeltaFix(player, -10)
			
			if inst:HasTag("des_bucket") then
				inst.components.finiteuses:Use(1)
			end
	elseif not TheWorld:HasTag("cave") then
			local offest = Vector3(player.Transform:GetWorldPosition())
			if player.components.driver then
				offest = FindWaterOffset(inst:GetPosition(), math.random() * 2*PI, 10, 10)
			else
				offest = FindOceanWaterRoG(inst)
			end
		
			print("ocean offest?")
			if offest then

					player.sg:GoToState("dolongaction")
					if player.components.moisture then player.components.moisture:DoDelta(math.random(7, 15)) end
					print("之前在瓶子中盐的浓度 = "..inst.components.cwater.salt)

					inst.components.cwater:DoDelta(inst.components.cwater.max, inst, inst.components.cwater.max)
					print("现在在瓶子中盐的浓度 = "..inst.components.cwater.salt)
					
					if snow_cover > 0.05 then
						TemperatureDeltaFix(player, -10)
					else
						TemperatureDeltaFix(player, -5)
					end
					if inst:HasTag("des_bucket") then
						inst.components.finiteuses:Use(1)
					end
			end
		end

		return
	end

	if not target then
		return
	end
	
	if target and target:HasTag("galun") then
		return
	end

	if (not inst.components.cwater) or (not player) or (target.frozen and target.frozen == true) or (inst.driedup and inst.driedup == true) then
		return
	end

	
	if target:HasTag("water_sourse_no_limit") then
		bottle.components.cwater:EmptyBottle()

		player.components.talker:Say("我的瓶子已经满了")
		bottle.components.cwater:DoDelta(1000)	
		if target:HasTag("water_sourse_salty") then
			bottle.components.cwater:DoDelta(0, nil, bottle.components.cwater.current, 0)
			player.components.talker:Say("我的瓶子已经满了\n 但也是咸的")
		end
		if target:HasTag("water_sourse_bad") then
			bottle.components.cwater:DoDelta(0, nil, 0, bottle.components.cwater.current*0.25)
		end
		
		if target:HasTag("water_sourse_poisoned") then
			bottle.components.cwater:DoDelta(0, nil, bottle.components.cwater.current*0.5, 1)
		end

		if inst:HasTag("des_bucket") then
			inst.components.finiteuses:Use(1)
		end
	end


	
	if nopickup==false and (not player:HasTag("ghost")) and (not player:HasTag("playerghost")) and player.components.health and not player.components.health:IsDead() then
		player.components.inventory:GiveItem(bottle, nil, nil, true)
		bottle:DoTaskInTime(0.1, function()
			if bottle.components.cwater.current < 1 then
				local word = TUNING.THIRST_FIND_OCEAN_STREAM_PHRASES[math.random(#TUNING.THIRST_FIND_OCEAN_STREAM_PHRASES)]
				player.components.talker:Say(word)
			end
		end)
	else
	--	player.components.talker:Say("I will leave the bottle here.")
	end
	end)
end



function cwater:EmptyBottle()
	self:DoDelta(-self.current, nil, -self.salt, -self.bad)
	self.special_drink = ""
end





function cwater:DoDelta(dlt, nst, sltdlt, baddy, fill)
	local delta = dlt or 0
	local saltdelta = sltdlt or 0
	local bad = baddy or 0
	local filler = fill or ""
	
	local inst = nst
    if self.inst then
		inst = self.inst
	end
	
	if not self.salt then self.salt = 0 end
	
    local old = self.current
    self.current = self.current + delta
	self.salt = self.salt + saltdelta
	self.bad = self.bad + bad
	
    if self.current < 0 then 
        self.current = 0
    elseif self.current > self.max then
        self.current = self.max
    end
	
	
	if self.current < 1 and self.special_drink ~= "" then 
		self.special_drink = ""
	end
	
	
	if	self.salt < 0 then 
        self.salt = 0
    elseif self.salt>self.current then
		self.salt = self.current
	end
	
	if self.bad < 0 then 
        self.bad = 0
    elseif self.bad>self.current then
		self.bad = self.current
	end
	
	
    self.inst:PushEvent("cwaterdelta", {oldpercent = old/self.max, newpercent = self.current/self.max})





	local drinks = math.ceil(self.inst.components.cwater.current/TUNING.THIRST_WATER_PER_SIP)
	if inst:HasTag("bottle") then
		self:GetDisc(inst,drinks)
	end
end

function cwater:GetPercent()
    return self.current / self.max
end





function cwater:SetPercent(p)
    local old = self.current
    self.current  = p*self.max
    self.inst:PushEvent("cwaterdelta", {oldpercent = old/self.max, newpercent = p})
	if self.inst:HasTag("bottle") then
		local drinks = math.ceil(self.inst.components.cwater.current/TUNING.THIRST_WATER_PER_SIP)
		self:GetDisc(self.inst,drinks)
	end
end



function cwater:ShareWater(trgt, giver, wtr, times)
	local target = trgt or self.addedbottle or giver
	if target==giver then return end
	local water = wtr or giver.components.cwater.current
	if water>giver.components.cwater.current then water = giver.components.cwater.current end
	if (water+target.components.cwater.current)>target.components.cwater.max then water = (target.components.cwater.max-target.components.cwater.current) end
	if target.components.cwater and target.components.cwater:GetPercent()<1 then
		target.components.cwater:DoDelta(water)
		giver.components.cwater:DoDelta(-water)
	end
end


function cwater:GroundPour(trgt, ps, pourwater)
	---self:DoDelta()
	local x, y, z = ps or self.inst.Transform:GetWorldPosition()
	if self.inst.components.inventoryitem and self.inst.components.inventoryitem:GetGrandOwner() then
		x, y, z = self.inst.components.inventoryitem:GetGrandOwner().Transform:GetWorldPosition()
	else
		x, y, z = self.inst.Transform:GetWorldPosition()
	end
	
    local splash = SpawnPrefab("waterballoon_splash")
	local maxwater = pourwater or 250
	
	--if water
	local water = self.inst.components.cwater.current
	if water > maxwater then water = maxwater end
	local water_percent = water/250
	
	local slt = self:GetRealSaltPercent()*water
	local bad = self:GetRealBadPercent()*water

	self:DoDelta(-water, nil, -slt, -bad)	
	
	if self.inst.components.finiteuses and self.inst.components.finiteuses.current then self.inst.components.finiteuses:Use(1) end
	
	splash.Transform:SetPosition(x, y, z)

	local scale = water_percent*0.85+0.33
	splash.Transform:SetScale(scale, scale, scale)	

	if water > 50 then
		self.inst.components.wateryprotection.extinguishheatpercent = TUNING.WATERBALLOON_EXTINGUISH_HEAT_PERCENT*water_percent
		self.inst.components.wateryprotection.temperaturereduction = TUNING.WATERBALLOON_TEMP_REDUCTION*water_percent
		self.inst.components.wateryprotection.witherprotectiontime = TUNING.WATERBALLOON_PROTECTION_TIME*water_percent
		self.inst.components.wateryprotection.addwetness = TUNING.WATERBALLOON_ADD_WETNESS*water_percent
		self.inst.components.wateryprotection:SpreadProtection(splash)
	end
	return true
end



function cwater:Transfuse(trgt, giver, wtr, salt, baddy)
	local target = trgt or self.addedbottle or giver

	local replace_drink_flag = nil
	
	if giver and target and (target==giver) then
		---NO YOU CAN NOT FEED FIREFIGHTER WITH TEA!
		---To-do if we add alcohol make it so firefigter ignites shit if loaded with alco
		return
	end

	
	if giver and giver.components.cwater.special_drink=="water" then
		 giver.components.cwater.special_drink = ""
	end
	if target and target.components.cwater.special_drink=="water" then
		 target.components.cwater.special_drink = ""
	end
	
	--if giver and target and target.components.des_chainik_c. then
	--	 target.components.cwater.special_drink = ""
	--end
	
	
	if giver and target and target.components.des_chainik_c and target.components.des_chainik_c.boiling then
		local player2 = target.components.inventoryitem and target.components.inventoryitem:GetGrandOwner() and target.components.inventoryitem:GetGrandOwner():HasTag("player")
		
		local word = TUNING.THIRST_TRANSFUSE_CHAINIK_BOILS[math.random(#TUNING.THIRST_TRANSFUSE_CHAINIK_BOILS)]
		
		
		if player2 then
			player2 = target.components.inventoryitem:GetGrandOwner()
			player2.components.talker:Say(word)
		end
		
		return
	end
	
	if giver and target and ((target.components.des_chainik_c and target.components.des_chainik_c.boiling) or (giver.components.des_chainik_c and giver.components.des_chainik_c.boiling)) then
		local player5 = nil
		if giver.components.inventoryitem and giver.components.inventoryitem:GetGrandOwner() and giver.components.inventoryitem:GetGrandOwner():HasTag("player") then
			player5 = giver.components.inventoryitem:GetGrandOwner()
		elseif target.components.inventoryitem and target.components.inventoryitem:GetGrandOwner() and target.components.inventoryitem:GetGrandOwner():HasTag("player") then
			player5 = target.components.inventoryitem:GetGrandOwner()
		elseif TheSim:GetGameID() == "DST" then
			for _, playerf in pairs(AllPlayers) do
				if (not playerf:HasTag("playerghost")) and (not playerf:HasTag("ghost")) and target:GetDistanceSqToInst(playerf)<4*4 then
					player5 = playerf
				end
				if (not playerf:HasTag("playerghost")) and (not playerf:HasTag("ghost")) and giver:GetDistanceSqToInst(playerf)<4*4 then
					player5 = playerf
				end
			end
		end

		if player5 and player5.components.talker then
			local word = TUNING.THIRST_TRANSFUSE_CHAINIK_BOILS[math.random(#TUNING.THIRST_TRANSFUSE_CHAINIK_BOILS)]
			player5.components.talker:Say(word)
		end
		
		return		
		
	end
	
	if giver and target and (giver.components.cwater.special_drink ~= target.components.cwater.special_drink)
		and target.components.cwater.special_drink ~= "" and 
		(giver.components.inventoryitem and giver.components.inventoryitem:GetGrandOwner() and giver.components.inventoryitem:GetGrandOwner():HasTag("player")
		or
		target.components.inventoryitem and target.components.inventoryitem:GetGrandOwner() and target.components.inventoryitem:GetGrandOwner():HasTag("player"))
		then
		
		
		local player = giver.components.inventoryitem and giver.components.inventoryitem:GetGrandOwner() and giver.components.inventoryitem:GetGrandOwner():HasTag("player")
		local player2 = target.components.inventoryitem and target.components.inventoryitem:GetGrandOwner() and target.components.inventoryitem:GetGrandOwner():HasTag("player")
		
		local word = TUNING.THIRST_TRANSFUSE_DIFFERENT_DRINKS[math.random(#TUNING.THIRST_TRANSFUSE_DIFFERENT_DRINKS)]
		
		print("===========TRANSFUSE FAIL===============")
		print(giver.components.cwater.special_drink, target.components.cwater.special_drink)
		print("========================================")
		
		if player then
			player = giver.components.inventoryitem:GetGrandOwner()
			player.components.talker:Say(word)
		elseif player2 then
			player2 = target.components.inventoryitem:GetGrandOwner()
			player2.components.talker:Say(word)
		end
	
		return true
	end

	if giver and target and (giver.components.cwater.special_drink ~= target.components.cwater.special_drink)
		and target.components.cwater.special_drink == "" then
		replace_drink_flag = true
		
		target.components.cwater:EmptyBottle()
		--target.components.cwater.special_drink = 
		
		print("====-cwater:Transfuse-=====")
		print(giver.prefab, target.prefab)
		print(giver.components.cwater.special_drink, target.components.cwater.special_drink)
	end

	if giver and target and (giver.components.cwater.special_drink ~= target.components.cwater.special_drink)
		and giver.components.cwater.special_drink == "" then

		
		
		local player = giver.components.inventoryitem and giver.components.inventoryitem:GetGrandOwner() and giver.components.inventoryitem:GetGrandOwner():HasTag("player")
		local player2 = target.components.inventoryitem and target.components.inventoryitem:GetGrandOwner() and target.components.inventoryitem:GetGrandOwner():HasTag("player")
		
		local word = TUNING.THIRST_TRANSFUSE_DIFFERENT_DRINKS[math.random(#TUNING.THIRST_TRANSFUSE_DIFFERENT_DRINKS)]
		
		print("===========TRANSFUSE FAIL===============")
		print(giver.components.cwater.special_drink, target.components.cwater.special_drink)
		print("========================================")
		
		if player then
			player = giver.components.inventoryitem:GetGrandOwner()
			player.components.talker:Say(word)
		elseif player2 then
			player2 = target.components.inventoryitem:GetGrandOwner()
			player2.components.talker:Say(word)
		end
	
		return true
		
		
		
		
	end


	
	local water = wtr or giver.components.cwater.current
	if water>giver.components.cwater.current then water = giver.components.cwater.current end
	if (water+target.components.cwater.current)>target.components.cwater.max then water = (target.components.cwater.max-target.components.cwater.current) end
	
	local slt = 0
	local bad = 0
	if salt then slt = giver.components.cwater:GetRealSaltPercent()*water end
	if baddy then bad = giver.components.cwater:GetRealBadPercent()*water end

	if target.components.cwater and target.components.cwater:GetPercent()<1 then
		-----DoDelta removes drink if current drops to zero
		
		print("=====================---=======================")
		print("=====================---=======================")
		print("=====================---=======================")
		print("=====================---=======================")
		print("=====================---=======================")
		print("=====================---=======================")
		print("==================Transfuse====================")
		print("giver", giver.components.cwater.current, giver.components.cwater.bad, giver.components.cwater.salt)
		print("target", target.components.cwater.current, target.components.cwater.bad, target.components.cwater.salt)
		
		
		target.components.cwater:DoDelta(water, nil, slt, bad)
		if replace_drink_flag then
			target.components.cwater.special_drink = giver.components.cwater.special_drink
			
			if giver:HasTag("des_chainik_update_discr") then
				giver.components.cwater:GetDiscCatcher()
			end
			
		end	
		
		
			local player5 = nil
			if giver.components.inventoryitem and giver.components.inventoryitem:GetGrandOwner() and giver.components.inventoryitem:GetGrandOwner():HasTag("player") then
				player5 = giver.components.inventoryitem:GetGrandOwner()
			elseif target.components.inventoryitem and target.components.inventoryitem:GetGrandOwner() and target.components.inventoryitem:GetGrandOwner():HasTag("player") then
				player5 = target.components.inventoryitem:GetGrandOwner()
			elseif TheSim:GetGameID() == "DST" then
				for _, playerf in pairs(AllPlayers) do
					if (not playerf:HasTag("playerghost")) and (not playerf:HasTag("ghost")) and target:GetDistanceSqToInst(playerf)<4*4 then
						player5 = playerf
					end
					if (not playerf:HasTag("playerghost")) and (not playerf:HasTag("ghost")) and giver:GetDistanceSqToInst(playerf)<4*4 then
						player5 = playerf
					end
				end
			end
			
			
		if target.components.des_chainik_c then
			if player5 and player5.components.talker then
				local word8 = TUNING.THIRST_TRANSFUSE_CHAINIK_INTO[math.random(#TUNING.THIRST_TRANSFUSE_CHAINIK_INTO)]
				player5.components.talker:Say(word8)
			end
		elseif giver.components.des_chainik_c then
			if player5 and player5.components.talker then
				local word8 = TUNING.THIRST_TRANSFUSE_CHAINIK_FROM[math.random(#TUNING.THIRST_TRANSFUSE_CHAINIK_FROM)]
				player5.components.talker:Say(word8)
			end		
		end
		
		
		
		giver.components.cwater:DoDelta(-water, nil, -slt, -bad)
		
		print(giver, "=>", target, water, slt, bad)
		
		print("giver", giver.components.cwater.current, giver.components.cwater.bad, giver.components.cwater.salt)
		print("target", target.components.cwater.current, target.components.cwater.bad, target.components.cwater.salt)
		print("=====================---=======================")
		print("=====================---=======================")
		print("=====================---=======================")
		print("=====================---=======================")
		print("=====================---=======================")
		print("=====================---=======================")
		print("=====================---=======================")


		target:PushEvent("des_thirst_transfuse", { giver = giver })
	end
	return true
end









function cwater:GetFilled(trgt, giver, wtr, times)


end


local lightstates =
{
    new                 = {override=0.00,   enabled=false,  radius=0.00},
    quarter             = {override=0.20,   enabled=false,  radius=0.00},
    half                = {override=0.45,   enabled=true,   radius=0.70},
    threequarter        = {override=0.75,   enabled=true,   radius=1.50},
    full                = {override=1,   enabled=true,   radius=5.00},
}


local function TagInvSlotRemoveAdd(inst, tag)
	inst:RemoveTag("des_cwater_empty")
	inst:RemoveTag("des_cwater_quoter")
	inst:RemoveTag("des_cwater_half")
	inst:RemoveTag("des_cwater_third")
	inst:RemoveTag("des_cwater_full")



	inst:AddTag(tag)
end

function cwater:DoDec(dt)
	local is_rain = TheWorld.state.israining
	if self.inst:HasTag("water_gain_overtime") then
            if is_rain then
                local rain_delta = self.watergainspeed*0.5 + TUNING.CAMPFIRE_RAIN_RATE*TheWorld.state.precipitationrate*0.5
				self:DoDelta(rain_delta*dt)
				self.inst.components.finiteuses:Use(1)
				----(self.current)
				
            else
                local rain_delta = self.watergainspeed
				self:DoDelta(rain_delta*dt)
				----(self.current)
			end
			local c =self.current/self.max
			
			if self.inst.decor then
				for i,item in ipairs(self.inst.decor) do
					item.AnimState:SetMultColour(c,c,c,c-0.1)
				end
			end
			
	
	
	elseif self.inst:HasTag("water_gain_rain") and not self.inst:HasTag("bottle") and not self.inst:HasTag("water_dest_coal") then
            if is_rain then
                local rain_delta = (self.watergainspeed*(-15) + TUNING.CAMPFIRE_RAIN_RATE*TheWorld.state.precipitationrate*5)*0.1				self:DoDelta(rain_delta*dt)
            else
                --local rain_delta = self.watergainspeed*0.75
				--self:DoDelta(rain_delta*dt)
			end
			--local c =self.current/self.max+0.25
	
	--[[elseif self.inst:HasTag("bottle") and self.inst.components.inventory:GetEquippedItem(EQUIPSLOTS.BODY)
	and self.inst.components.inventory and self.inst.components.inventory:GetEquippedItem(EQUIPSLOTS.BODY).prefab=="waterback"
	and self.inst.components.inventoryitem.owner == self.inst.components.inventory:GetEquippedItem(EQUIPSLOTS.BODY) then
			if is_rain then
				local rain_delta = self.watergainspeed*(-4) + TUNING.CAMPFIRE_RAIN_RATE*TheWorld.state.precipitationrate
				self:DoDelta(rain_delta*dt)
			end--]]
	end
	----inst.components.cwater.watergainmoon_maxspeed = TUNING.WATERBOTTLEMOON_SPEED
	---bottle_moonlightfiller
	
	if self.inst:HasTag("bottle_moonlightfiller") and TheWorld.state.isnight and TheWorld.state.moonphase then
		local moondeltamult = 1
		local moondelta = TUNING.DES_MOONBOTTLE_FILL
		
		if TheWorld.state.moonphase == "满的" then
			moondeltamult = 1
			
		elseif TheWorld.state.moonphase == "四分之三" then
			moondeltamult = 0.75
			
		elseif TheWorld.state.moonphase == "一半" then
			moondeltamult = 0.5
			
		elseif TheWorld.state.moonphase == "四分之一" then		
			moondeltamult = 0.25
			
		elseif TheWorld.state.moonphase == "新的" then
			moondeltamult = 0
		end
		
		self:DoDelta(moondelta*moondeltamult*dt)
	end	

	if self.inst:HasTag("bottle_insanityfiller") and self.inst.components.inventoryitem:GetGrandOwner() and self.inst.components.inventoryitem:GetGrandOwner().components.sanity then
		local thuldeltamult = 0
		local thuldelta = TUNING.DES_MOONBOTTLE_FILL	
		local ownersanity = self.inst.components.inventoryitem:GetGrandOwner().components.sanity:GetPercent()
		if ownersanity < 0.6 then
			------- 1.66 water per second on 0 sanity
			------- some fishy math here
			thuldeltamult = (2*((1-ownersanity+0.2)^5)+0.1)/3
			thuldelta = thuldeltamult*thuldelta*dt
			local thulcleardelta = thuldelta/2
			self:DoDelta(thuldelta, nil, -thulcleardelta, -thulcleardelta)
	
		elseif ownersanity > 0.8 and self:GetPercent()>0.2 then
			---- too sane, only clear water
			---- also clear it
			self:DoDelta(0, nil, -1, -1)
			
		end
		
	end
	
	
	
	if self.inst:HasTag("water_dest_new") then

		self:Transfuse(nil, self.inst, self.destspeed*dt)
		if (not self.addedbottle) and self.inst:HasTag("water_dest_coal") then
			self:DoDelta(-self.destspeed*dt)
		end
	end	
	
	if self.inst:HasTag("des_instant_transfuse") and self.addedbottle then
		self:Transfuse(self.addedbottle, self.inst, nil, true, true)
	end
	

	if self.inst:HasTag("des_chainik_update_discr") or self.inst:HasTag("water_trap_or_dest") or self.inst:HasTag("water_dest_barrel") then
		self:GetDiscCatcher()
	end
	
	if not self.inst.components.perishable and self.inst:HasTag("des_water_spoiling") and self.spoilspeed>0 then
		if self.current>1 then
		
			local spoilspeed_special_drink = 1	
			if self.special_drink and self.special_drink ~= "" and TUNING.BOTTLE_DRINKS_TYPE[self.special_drink] and TUNING.BOTTLE_DRINKS_TYPE[self.special_drink]["spoilspeed"] then
				spoilspeed_special_drink = TUNING.BOTTLE_DRINKS_TYPE[self.special_drink]["spoilspeed"]
			end
			---print("SPOIL ",self.inst, spoilspeed_special_drink, spoilspeed_special_drink*self.spoilspeed*self.current/100)
		
			self:DoDelta(0, self.inst, 0, spoilspeed_special_drink*self.spoilspeed*self.current/100)
		elseif self.current<1 then
			--self.inst.components.perishable:SetPercent(0.99)
		end
		
	end
	
	

	if self.inst.components.perishable and self.inst:HasTag("des_water_spoiling") and self.spoilspeed>0 then
		--
		if self.current>1 then
		
			local spoilspeed_special_drink = 1	
			if self.special_drink and TUNING.BOTTLE_DRINKS_TYPE[self.special_drink] and TUNING.BOTTLE_DRINKS_TYPE[self.special_drink]["spoilspeed"] then
				spoilspeed_special_drink = TUNING.BOTTLE_DRINKS_TYPE[self.special_drink]["spoilspeed"]
			end
			self:DoDelta(0, self.inst, 0, spoilspeed_special_drink*self.spoilspeed*self.current/100)
		elseif self.current<1 then
			--self.inst.components.perishable:SetPercent(0.99)
		end
	end
	--]]	
	if self.inst:HasTag("show_spoilage") and self.current > 1 then

		
		local perishpercent = 0.99-self:GetBadPercent()
		if perishpercent>0.98 then perishpercent = 0.98
		elseif perishpercent<0.15 then perishpercent = 0.15	end
		
		self.inst.components.perishable:SetPercent(perishpercent)
	--
	end

	
	
	
	if self.inst.components.inventoryitem then
		if self:GetPercent() > 0.9 then
			TagInvSlotRemoveAdd(self.inst, "des_cwater_full")
		elseif self:GetPercent() > 0.65 then
			TagInvSlotRemoveAdd(self.inst, "des_cwater_third")
		elseif self:GetPercent() > 0.45 then
			TagInvSlotRemoveAdd(self.inst, "des_cwater_half")
		elseif self:GetPercent() > 0.15 then
			TagInvSlotRemoveAdd(self.inst, "des_cwater_quoter")
		else
			TagInvSlotRemoveAdd(self.inst, "des_cwater_empty")
		end
	end
	
	
	if self.inst:HasTag("bottle") and (self.destspeed>0 or self.cleanspeed>0) and self.inst.components.cwater then
		
		--[[local clean = -self.inst.components.cwater.cleanspeed
		if TUNING.BOTTLE_DRINKS_TYPE[self.filled] then
			clean = clean + TUNING.BOTTLE_DRINKS_TYPE[self.filled]["spoilspeed"]
		end--]]
		self:DoDelta(0, self.inst, -self.destspeed, -self.cleanspeed)
	end


end
--GetSlotNum










function cwater:SetKillRate(rate)
    self.hurtrate = rate
end

function cwater:SetRate(rate)
    self.cwaterrate = rate
end



return cwater
