local des_easy_code = Class(function(self, inst)
    self.inst = inst
	self.thirst_poisoned = false
end)


function des_easy_code:OnSave()
	return {thirst_poisoned = self.thirst_poisoned}
end

function des_easy_code:OnLoad(data)
    if data.thirst_poisoned then
        self.thirst_poisoned = data.thirst_poisoned
		if self.thirst_poisoned == false then
			self:SetUpClear(self.inst)
		else
			self:SetUpPoisoned(self.inst)
		end
    end
end


function des_easy_code:SetUpPoisoned(inst)
	local c = {0.5, 0.2, 1}
	inst.AnimState:SetMultColour(c[1],c[2],c[3],1)
	inst:AddTag("water_sourse_poisoned")
end
function des_easy_code:SetUpClear(inst)
	local c = {1, 1, 1}
	inst.AnimState:SetMultColour(c[1],c[2],c[3],1)
	inst:RemoveTag("water_sourse_poisoned")	
end


function des_easy_code:AddTabletOrPoisoner(target, tablet, player)
		if tablet:HasTag("des_well_watercleaner") then
			self.thirst_poisoned = false
			
			if self.inst:HasTag("water_sourse_nolimit") then
				self:SetUpClear(self.inst)
			end
			if self.inst.components.cwater then self.inst.components.cwater:ClearPoison() end
		
		elseif tablet:HasTag("des_water_poisoner") then
			self.thirst_poisoned = true
			
			if self.inst:HasTag("water_sourse_nolimit") then
				self:SetUpPoisoned(self.inst)
			end			
			if self.inst.components.cwater then self.inst.components.cwater:Poison() end
		
		end
		
	self:UseAndDrop(1, 1, tablet, player)
end





----- Use X items from stack, drop unused items ----
function des_easy_code:UseAndDrop(ammount, maximum, bucket, player, owner)
	local inst = owner or self.inst

	local removeflag = nil

		local stacksz = bucket.components.stackable.stacksize
		local touse = ammount	
		if touse > maximum then
			touse = maximum
		end
		stacksz = stacksz - touse
		if (stacksz <= 0) or (bucket.components.stackable.stacksize==1) then
			removeflag = true
			stacksz = 1
		end		
		if inst.components.container then
			inst.components.container:Close()
		end
		--inst.components.container:ConsumeByName(bucket.prefab, touse)
		bucket.components.stackable:SetStackSize(stacksz)
		if removeflag and bucket then
			bucket:Remove()
		elseif bucket then
			if inst.components.container then
				inst.components.container:DropItem(bucket)
				if player then
					player.sg:GoToState("give")
					player.components.inventory:GiveItem(bucket, nil, nil, true)
				end
			end
		end
		
		
		
		return touse
end


return des_easy_code