

require "prefabutil"



local assetsbottles=
{
	Asset("ANIM", "anim/des_bottle.zip"),

	Asset("ATLAS", "images/inventoryimages/bottlegold.xml"),
	Asset("ATLAS", "images/inventoryimages/bottlewood.xml"),
	Asset("ATLAS", "images/inventoryimages/bottlecup.xml"),
	Asset("ATLAS", "images/inventoryimages/bottleswglass.xml")

}

local assetbottleswglass=
{
	Asset("ANIM", "anim/bottleswglass.zip"),
	Asset("ATLAS", "images/inventoryimages/bottlegold.xml"),
	Asset("ATLAS", "images/inventoryimages/bottlewood.xml"),
	Asset("ATLAS", "images/inventoryimages/bottlecup.xml"),
	Asset("ATLAS", "images/inventoryimages/bottleswglass.xml")	
}

local assetsbuckets=
{
	Asset("ANIM", "anim/des_bucket.zip"),
	Asset("ATLAS", "images/inventoryimages/bottlegold.xml"),
	Asset("ATLAS", "images/inventoryimages/bottlewood.xml"),
	Asset("ATLAS", "images/inventoryimages/bottlecup.xml"),
	Asset("ATLAS", "images/inventoryimages/bottleswglass.xml"),
	
	
	Asset("ATLAS", "images/inventoryimages/des_bucket_steel_empty.xml"),
	Asset("IMAGE", "images/inventoryimages/des_bucket_steel_empty.tex"),

	Asset("ATLAS", "images/inventoryimages/des_bucket_steel_full.xml"),
	Asset("IMAGE", "images/inventoryimages/des_bucket_steel_full.tex"),
	
	Asset("ATLAS", "images/inventoryimages/des_bucket_wood_full.xml"),
	Asset("IMAGE", "images/inventoryimages/des_bucket_wood_full.tex"),
	
	Asset("ATLAS", "images/inventoryimages/des_bucket_wood_empty.xml"),
	Asset("IMAGE", "images/inventoryimages/des_bucket_wood_empty.tex"),
	
}

local assetbottlemoon=
{
	
	Asset("ANIM", "anim/des_moon_bottle.zip"),
	Asset("ATLAS", "images/inventoryimages/bottlegold.xml"),
	Asset("ATLAS", "images/inventoryimages/bottlewood.xml"),
	Asset("ATLAS", "images/inventoryimages/bottlecup.xml"),
	Asset("ATLAS", "images/inventoryimages/bottleswglass.xml"),	
	
	Asset("ATLAS", "images/inventoryimages/des_new_thulbottle.xml"),
	Asset("IMAGE", "images/inventoryimages/des_new_thulbottle.tex"),
	
	Asset("ATLAS", "images/inventoryimages/des_new_moonbottle.xml"),
	Asset("IMAGE", "images/inventoryimages/des_new_moonbottle.tex"),
}

local assetspotato =
{
    Asset("ANIM", "anim/trinkets.zip"),
}


local function oneaten(inst, eater)
	if eater:HasTag("player") then
		--eater.AnimState:PlayAnimation("horn")
		inst.components.cwater:Drink(inst,eater)
		

	else
		local newbottle = inst.components.cwater:givenewbottle(inst, eater, inst.components.cwater.current, inst.components.finiteuses.current, inst.components.cwater.salt, true)
	
		---newbottle.components.edible.foodtype = ""
		
		return
	end
end


local function onfinished(inst)
    inst:Remove()
end



local function FixImageAndAnim(inst)
	local adding = "_empty"
	if inst.components.cwater:GetPercent()>0.49 then
		adding = "_full"
	end
	
	if inst:HasTag("des_bucket") then
		inst.animnumber = inst.prefab..adding
		inst.components.inventoryitem.imagename = inst.prefab..adding
		inst.components.inventoryitem.atlasname = "images/inventoryimages/"..inst.prefab..adding..".xml"
	end
	inst.AnimState:PlayAnimation(inst.animnumber)

end


local function SetOnPickupFn(inst)
	if inst:HasTag("des_bucket") then
		FixImageAndAnim(inst)
	end
end









---idle  bottleswglass
local function OnDropped(inst)
	if inst.prefab == "bottleswglass" then
		inst.AnimState:PlayAnimation("idle")
	else
		inst.AnimState:PlayAnimation(inst.animnumber)
	end
	
	---inst.components.cwater:DroppedBottle(inst)

	if inst:HasTag("des_bucket") then
		FixImageAndAnim(inst)
	end
	
end




--------------- https://brashmonkey.com/forum/applications/core/interface/imageproxy/imageproxy.php?img=http://i.imgur.com/g30pt55.gif&key=73324a5d0db03501e97e9bd315f1103a1934860e52731d035a6f12e8861ab375











-------bottleswglass
local function cleanonfire(inst, cooker, chef)
	local newbottle = inst.components.cwater:NewBottleNoChange(inst, chef, nil, true, true)
	local prct = newbottle.components.cwater.current/newbottle.components.cwater.max
	local waterdelta = newbottle.components.cwater.max*prct*0.5 - 50
	local salt = newbottle.components.cwater.salt
	
	if salt > 50 then
		---print("should be salt drops meh")
	end

	newbottle.components.finiteuses:Use(3)
	newbottle.components.cwater:DoDelta(-waterdelta, newbottle)
	newbottle.components.cwater.salt = 0
	newbottle.components.cwater.bad = 0
end

local function defaultfn(bottle)
    local inst = CreateEntity()
    inst.entity:AddTransform()
    inst.entity:AddAnimState()
	MakeInventoryPhysics(inst)
	inst.entity:AddNetwork()
	
	
	if TUNING.DES_BOTTLE_GREENFONT==true then
	   -- inst:AddTag("show_spoilage")
	end
	
	inst:AddTag("bottle")
	inst:AddTag("des_fillable_on_catcher")
	inst:AddTag("des_water_spoiling")

	if bottle == "bottleswglass" then
		inst.AnimState:SetBank("bottleswglass")
		inst.AnimState:SetBuild("bottleswglass")	
		local s = 2.5
		inst.Transform:SetScale(s,s,s )
	elseif bottle == "bottlemoon" or bottle == "bottlethul" then
		inst.AnimState:SetBank("des_moon_bottle")
		inst.AnimState:SetBuild("des_moon_bottle")
		
		local s = 2.1	
		inst.Transform:SetScale(s,s,s )
	elseif bottle == "des_bucket_steel" or bottle == "des_bucket_wood" then
		inst.AnimState:SetBank("des_bucket")
		inst.AnimState:SetBuild("des_bucket")
	
		local s = 2.8
		inst.Transform:SetScale(s,s,s )
	elseif bottle == "des_potato_cup" then
	
        inst.AnimState:SetBank("trinkets")
        inst.AnimState:SetBuild("trinkets")
        inst.AnimState:PlayAnimation("26")
		inst.animnumber="26"
	else
	
	
		inst.AnimState:SetBank("des_bottle")
		inst.AnimState:SetBuild("des_bottle")
		
		local s = 1.6	
		inst.Transform:SetScale(s,s,s )
	end
	
	if bottle =="bottlecup" then
		inst:AddTag("bottlecup")
		inst.AnimState:PlayAnimation(1)
		inst.animnumber="1"
	elseif bottle == "gold" then
		inst:AddTag("bottlegold")
		inst.AnimState:PlayAnimation(3)
		inst.animnumber="3"
	elseif bottle =="wood" then
		inst:AddTag("bottlewood")
		inst.AnimState:PlayAnimation(2)
		inst.animnumber="2"
	elseif bottle =="bottlehot" then
		inst:AddTag("bottlehot")
		inst.AnimState:PlayAnimation(4)
		inst.animnumber="4"
	elseif bottle =="bottlecold" then
		inst:AddTag("bottlecold")
		inst.AnimState:PlayAnimation(5)
		inst.animnumber="5"
	elseif bottle == "bottleswglass" then
		inst:AddTag("bottleswglass")
		inst.animnumber="idle"
		inst.AnimState:PlayAnimation("idle")
	elseif bottle == "bottlemoon" then
		inst:AddTag("bottlemoon")
		inst:AddTag("bottle_moonlightfiller")
		inst.animnumber="moon"
		inst.AnimState:PlayAnimation("moon")
	elseif bottle == "bottlethul" then
		inst:AddTag("bottlethul")
		inst:AddTag("bottle_insanityfiller")

		
		inst.animnumber="thul"
		inst.AnimState:PlayAnimation("thul")	
		
	elseif bottle == "des_bucket_steel" then
		inst:AddTag("des_bucket_steel")
		inst:AddTag("des_bucket")
		inst:AddTag("des_drop_fromcatcher")

		
		inst:RemoveTag("bottle")
		inst.animnumber="des_bucket_steel_empty"
		inst.AnimState:PlayAnimation(inst.animnumber)	
		
	elseif bottle == "des_bucket_wood" then
		inst:AddTag("des_bucket_wood")
		inst:AddTag("des_bucket")
		inst:AddTag("des_drop_fromcatcher")

		inst:RemoveTag("bottle")
		inst.animnumber="des_bucket_wood_empty"
		inst.AnimState:PlayAnimation(inst.animnumber)		
		
	end
	inst.AnimState:SetRayTestOnBB(true) 


	
	inst:AddTag("bottle")
	inst:AddTag("des_bottle")
	inst:AddTag("des_can_pour_to")

	
	if not TheWorld.ismastersim then
       return inst
    end
	
	inst.entity:SetPristine()

	
	inst:AddComponent("cwater")
	inst:AddComponent("finiteuses")
	inst.components.finiteuses:SetOnFinished( onfinished)
	
	inst:AddComponent("inventoryitem")  
    inst.components.inventoryitem:SetOnDroppedFn(OnDropped)
    inst.components.inventoryitem:SetOnPickupFn(SetOnPickupFn)
	
	inst.components.inventoryitem.nobounce = true
	
	
    inst:AddComponent("inspectable")
 	inst:AddComponent("named")
    inst.components.named:SetName("Empty bottle")
	   	
	inst.components.cwater.cleanspeed = TUNING.WATER_SPOIL_SPEED
	
	----badness per second per 100 water inside of container
	inst.components.cwater.spoilspeed = TUNING.DES_WATER_SPOIL_SPEED
		
	if bottle =="bottlecup" then
		inst.components.cwater:SetMax(TUNING.BOTTLE_CUP_WATER)
		inst.components.finiteuses:SetMaxUses(TUNING.BOTTLE_CUP_USES)
		inst.components.finiteuses:SetUses(TUNING.BOTTLE_CUP_USES)
		inst.components.inventoryitem.atlasname = "images/inventoryimages/bottlecup.xml"
		
		inst.components.named:SetName("Empty cup")
	elseif bottle == "gold" then
		inst.components.cwater:SetMax(TUNING.BOTTLE_GOLD_WATER)
		inst.components.finiteuses:SetMaxUses(TUNING.BOTTLE_GOLD_USES)
		inst.components.finiteuses:SetUses(TUNING.BOTTLE_GOLD_USES)
		inst.components.inventoryitem.atlasname = "images/inventoryimages/bottlegold.xml"
		inst.components.cwater.destspeed = 0.5*TUNING.THIRST_DIFFILCULTY_GAIN_SPEED_MULT
		inst.components.cwater.cleanspeed = 0.5*TUNING.THIRST_DIFFILCULTY_GAIN_SPEED_MULT

		inst.components.cwater.spoilspeed = 0
	
	elseif bottle =="wood" then
		inst.components.cwater:SetMax(TUNING.BOTTLE_WOOD_WATER)
		inst.components.finiteuses:SetMaxUses(TUNING.BOTTLE_WOOD_USES)
		inst.components.finiteuses:SetUses(TUNING.BOTTLE_WOOD_USES)
		inst.components.inventoryitem.atlasname = "images/inventoryimages/bottlewood.xml"
	elseif bottle =="bottlehot" then
		inst.components.cwater:SetMax(TUNING.BOTTLE_GOLD_WATER)
		inst.components.finiteuses:SetMaxUses(TUNING.BOTTLE_GOLD_USES*1.5)
		inst.components.finiteuses:SetUses(TUNING.BOTTLE_GOLD_USES*1.5)
		inst.components.cwater.bottletempdelta = 30
		inst.components.inventoryitem.atlasname = "images/inventoryimages/bottlehot.xml"
		inst.components.cwater.destspeed = 1*TUNING.THIRST_DIFFILCULTY_GAIN_SPEED_MULT
		inst.components.cwater.cleanspeed = 1*TUNING.THIRST_DIFFILCULTY_GAIN_SPEED_MULT

		inst.components.cwater.spoilspeed = 0
		
	elseif bottle =="bottlecold" then
		inst.components.cwater:SetMax(TUNING.BOTTLE_GOLD_WATER)
		inst.components.finiteuses:SetMaxUses(TUNING.BOTTLE_GOLD_USES*1.5)
		inst.components.finiteuses:SetUses(TUNING.BOTTLE_GOLD_USES*1.5)
		inst.components.cwater.bottletempdelta = -30
		inst.components.inventoryitem.atlasname = "images/inventoryimages/bottlecold.xml"
		inst.components.cwater.destspeed = 1*TUNING.THIRST_DIFFILCULTY_GAIN_SPEED_MULT
		inst.components.cwater.cleanspeed = 1*TUNING.THIRST_DIFFILCULTY_GAIN_SPEED_MULT
	
		inst.components.cwater.spoilspeed = 0
	
	elseif bottle =="bottleswglass" then
		inst.components.cwater:SetMax(TUNING.BOTTLE_GLASS_WATER)
		inst.components.finiteuses:SetMaxUses(TUNING.BOTTLE_GLASS_USES)
		inst.components.finiteuses:SetUses(TUNING.BOTTLE_GLASS_USES)
		inst.components.inventoryitem.atlasname = "images/inventoryimages/bottleswglass.xml"

		inst.components.cwater.spoilspeed = TUNING.DES_WATER_SPOIL_GLASS


	elseif bottle == "bottlemoon" then
		inst.components.cwater:SetMax(TUNING.BOTTLE_MOON_WATER)
		inst.components.finiteuses:SetMaxUses(TUNING.BOTTLE_MOON_USES)
		inst.components.finiteuses:SetUses(TUNING.BOTTLE_MOON_USES)
		inst.components.inventoryitem.imagename = "des_new_moonbottle"
		inst.components.inventoryitem.atlasname = "images/inventoryimages/des_new_moonbottle.xml"
			
		inst.components.cwater.watergainmoon_maxspeed = TUNING.WATERBOTTLEMOON_SPEED
	
		inst.components.cwater.destspeed = 1*TUNING.THIRST_DIFFILCULTY_GAIN_SPEED_MULT
		inst.components.cwater.cleanspeed = 1*TUNING.THIRST_DIFFILCULTY_GAIN_SPEED_MULT
		inst.components.cwater.spoilspeed = 0
		
	elseif bottle == "bottlethul" then
		inst.components.cwater:SetMax(TUNING.BOTTLE_GLASS_WATER)
		inst.components.finiteuses:SetMaxUses(TUNING.BOTTLE_THUL_USES)
		inst.components.finiteuses:SetUses(TUNING.BOTTLE_THUL_USES)
		
		inst.components.cwater.destspeed = 0.33*TUNING.THIRST_DIFFILCULTY_GAIN_SPEED_MULT
		inst.components.cwater.cleanspeed = 0.33*TUNING.THIRST_DIFFILCULTY_GAIN_SPEED_MULT
		
		
		inst.components.inventoryitem.imagename = "des_new_thulbottle"
		inst.components.inventoryitem.atlasname = "images/inventoryimages/des_new_thulbottle.xml"
	
	elseif bottle == "des_bucket_steel" then
		inst.components.cwater:SetMax(TUNING.DES_BUCKET_STEEL)
		inst.components.finiteuses:SetMaxUses(TUNING.DES_BUCKET_STEEL_USES)
		inst.components.finiteuses:SetUses(TUNING.DES_BUCKET_STEEL_USES)
		inst.components.inventoryitem.atlasname = "images/inventoryimages/symbol0-6new.xml"
		
		inst.components.cwater.spoilspeed = TUNING.DES_WATER_SPOIL_BUCKET*0.75

	elseif bottle == "des_bucket_wood" then
		inst.components.cwater:SetMax(TUNING.DES_BUCKET_WOOD)
		inst.components.finiteuses:SetMaxUses(TUNING.DES_BUCKET_WOOD_USES)
		inst.components.finiteuses:SetUses(TUNING.DES_BUCKET_WOOD_USES)
		inst.components.inventoryitem.atlasname = "images/inventoryimages/symbol0-6new.xml"
	
		inst.components.cwater.spoilspeed = TUNING.DES_WATER_SPOIL_BUCKET
		
	elseif bottle == "des_potato_cup" then	
		inst.components.cwater:SetMax(100)
		inst.components.finiteuses:SetMaxUses(6)
		inst.components.finiteuses:SetUses(6)
		inst.components.inventoryitem.atlasname = "images/inventoryimages/des_potato_cup.xml"
		
		inst:AddComponent("tradable")
        inst.components.tradable.goldvalue = TUNING.GOLD_VALUES.TRINKETS[26] or 3
		
		inst.components.cwater.destspeed = 1*TUNING.THIRST_DIFFILCULTY_GAIN_SPEED_MULT
		inst.components.cwater.cleanspeed = 1*TUNING.THIRST_DIFFILCULTY_GAIN_SPEED_MULT

		inst.components.cwater.spoilspeed = 0
		
		
		inst.components.named:SetName("Potato cup")
	end	
	
	
	
	
	inst:AddComponent("waterproofer")
	inst.components.waterproofer:SetEffectiveness(0)
	inst.no_wet_prefix = true

	
	MakeInventoryPhysics(inst)
    
	
	
    inst:AddComponent("wateryprotection")	
    inst.components.wateryprotection.extinguishheatpercent = TUNING.WATERBALLOON_EXTINGUISH_HEAT_PERCENT
    inst.components.wateryprotection.temperaturereduction = TUNING.WATERBALLOON_TEMP_REDUCTION
    inst.components.wateryprotection.witherprotectiontime = TUNING.WATERBALLOON_PROTECTION_TIME
    inst.components.wateryprotection.addwetness = TUNING.WATERBALLOON_ADD_WETNESS
    inst.components.wateryprotection:AddIgnoreTag("player")

	
	

	
	inst:AddComponent("des_drink")
	inst:AddComponent("des_water_interactor")


	--inst:DoTaskInTime(0.1, function()
	if TUNING.DES_BOTTLE_GREENFONT==true then
		--inst:AddComponent("perishable")
		--inst.components.perishable:SetPerishTime(TUNING.PERISH_SUPERSLOW*100)
	----	inst.components.perishable:SetPercent(1)
	---	inst.components.perishable:StopPerishing()
		--inst.components.perishable.onperishreplacement = "log"
	end
	--end)
	
	if bottle == "gold" or bottle == "bottlehot" or bottle == "bottlecold" then
		inst:AddComponent("edible")
        inst.components.edible.foodtype = FOODTYPE.ELEMENTAL
		inst:AddComponent("cookable")
		inst.components.cookable.product = ""	
		inst.components.cookable:SetOnCookedFn(cleanonfire)
	end
	
	
--	if not bottle == "bottleswglass" then
	inst:DoPeriodicTask(2, function()
		inst.AnimState:PlayAnimation(inst.animnumber)
		if inst.components.cwater.current<1 then
			inst:AddTag("cwater_empty")
			inst:RemoveTag("cwater_full")
			
		else
			inst:AddTag("cwater_full")
			inst:RemoveTag("cwater_empty")
		end
	end)
	--end
	
	print("==BOTTLE DUR "..inst.components.finiteuses.current)
    inst.components.cwater:SetPercent(0)
	
	
	return inst
end

return Prefab("common/inventory/bottlegold", function() return defaultfn("gold") end , assetsbottles),
 Prefab("common/inventory/bottlewood", function() return defaultfn("wood") end , assetsbottles),
 Prefab("common/inventory/bottlecup", function() return defaultfn("bottlecup") end , assetsbottles),
 Prefab("common/inventory/bottlehot", function() return defaultfn("bottlehot") end , assetsbottles),
 Prefab("common/inventory/bottlecold", function() return defaultfn("bottlecold") end , assetsbottles),
 Prefab("common/inventory/bottleswglass", function() return defaultfn("bottleswglass") end , assetbottleswglass),
 Prefab("common/inventory/bottleswglass_dummy", function() return defaultfn("bottleswglass") end , assetbottleswglass),
 Prefab("common/inventory/bottlemoon", function() return defaultfn("bottlemoon") end , assetbottlemoon),
 Prefab("common/inventory/bottlethul", function() return defaultfn("bottlethul") end , assetbottlemoon),
 Prefab("common/inventory/des_bucket_steel", function() return defaultfn("des_bucket_steel") end , assetsbuckets),
 Prefab("common/inventory/des_bucket_wood", function() return defaultfn("des_bucket_wood") end , assetsbuckets),
 Prefab("common/inventory/des_potato_cup", function() return defaultfn("des_potato_cup") end , assetspotato)
