local assets =
{
   -- Asset("ANIM", "anim/des_chainik.zip"),
	Asset("ATLAS", "images/inventoryimages/des_chainik.xml"),
	
	Asset("ANIM", "anim/des_ui_chainik3x3.zip"),

	
	Asset("ANIM", "anim/des_chainik_nogi.zip"),
}


local enassets =
{
   -- Asset("ANIM", "anim/des_chainik.zip"),
	Asset("ATLAS", "images/inventoryimages/des_enkettle_empty.xml"),
	Asset("ATLAS", "images/inventoryimages/des_enkettle_water.xml"),
	Asset("ATLAS", "images/inventoryimages/des_enkettle_boil.xml"),
	Asset("ATLAS", "images/inventoryimages/des_enkettle.xml"),

	Asset("ANIM", "anim/des_ui_samovar3x3.zip"),

	
	Asset("ANIM", "anim/des_enkettle.zip"),
}


local function FakeDrop(inst)
	--if true==true then
	--return
	--end
	
	local found = inst.components.container:FindItem(function(find_fakedrop) return find_fakedrop==inst.des_fakedrop end)
	if found then
		return
	elseif not found and inst.des_fakedrop then
		inst.des_fakedrop:Remove()
	end
	

	
	if not found then
		inst.des_fakedrop = SpawnPrefab("des_waterdrop_fake")
		
		inst.des_fakedrop.original_owner = inst
		print("SPAWNED FAKE DROP")
		inst.components.container:GiveItem(inst.des_fakedrop, inst.fakedrop_slot)
	end
end















local function onopen(inst)
	inst.components.des_chainik_c:FixButtons()
	inst:AddTag("des_watercatcher_update_fakedrop")
	--inst.components.cwater:GetDiscCatcher()
	--inst.SoundEmitter:PlaySound("pickle_barrel/pickle_barrel/open", "open")
	if inst.prefab == "des_chainik" then
		inst.AnimState:PlayAnimation("open_ground")
	end
end

local function onclose(inst)
	--inst.SoundEmitter:PlaySound("pickle_barrel/pickle_barrel/close", "close")
	inst.components.des_chainik_c:FixButtons()

	inst:RemoveTag("des_watercatcher_update_fakedrop")
	
	if inst.prefab == "des_chainik" then
		inst.AnimState:PlayAnimation("close_ground")
		inst.AnimState:PushAnimation("idle_ground", false)
	end

end









local function ongetitem(inst)
	inst:DoTaskInTime(0.1, function()
		inst.components.des_chainik_c:FixButtons()
	end)
	inst.components.des_chainik_c:OnGetItem()
end

local function onloseitem(inst)
	inst.components.des_chainik_c:FixButtons()
end








local function AddHighlightChildren(inst, target)
    if target.prefab == "firepit" then
        if target.highlightchildren == nil then
            target.highlightchildren = { inst }
        else
            table.insert(target.highlightchildren, inst)
        end
    end
end
local function OnPotSteam(inst)
    local fx = CreateEntity()

    fx:AddTag("FX")
    fx:AddTag("NOCLICK")
    --[[Non-networked entity]]
    fx.entity:SetCanSleep(false)
    fx.persists = false

    fx.entity:AddTransform()
    fx.entity:AddAnimState()
    fx.entity:AddSoundEmitter()

    fx.AnimState:SetBank("des_chainik_nogi")
    fx.AnimState:SetBuild("des_chainik_nogi")
    fx.AnimState:PlayAnimation("steam")
    fx.AnimState:SetFinalOffset(1)

    fx:ListenForEvent("animover", fx.Remove)

    fx.Transform:SetPosition(inst.Transform:GetWorldPosition())
    fx.SoundEmitter:PlaySound("dontstarve/common/cookingpot_open", nil, .6)
    fx.SoundEmitter:PlaySound("dontstarve/common/cookingpot_close")
end





local function FixImageAndAnim(inst)
	if inst.prefab == "des_enkettle" then
		local adding = "empty"
		if inst.components.cwater:GetPercent()>0.25 then
			adding = "water"
		end
		if inst.components.des_chainik_c and inst.components.des_chainik_c.boiling then
			adding = "boil"
		end
		
		if inst.components.des_chainik_c.boiling and not inst.components.inventoryitem.owner then
			inst.Light:Enable(true)
		else
			inst.Light:Enable(false)
		end
		
		inst.components.inventoryitem.imagename = inst.prefab.."_"..adding
		inst.components.inventoryitem.atlasname = "images/inventoryimages/"..inst.prefab.."_"..adding..".xml"
		inst.AnimState:PlayAnimation(adding)
	end
end

local function SetOnPickupFn(inst)
	if inst.prefab == "des_enkettle" then
		FixImageAndAnim(inst)
	end
end


local function OnDropped(inst)
	if inst.prefab == "des_enkettle" then
		FixImageAndAnim(inst)
	end
end



local function SetUpChainik(inst, data)



	RemovePhysicsColliders(inst)
	
    -- inst.AnimState:SetBank("des_chainik_nogi")
    -- inst.AnimState:SetBuild("des_chainik_nogi")
    inst.AnimState:PlayAnimation("idle")

	
    inst.AnimState:PlayAnimation("place")
	inst.AnimState:PushAnimation("place_pot")
	inst.AnimState:PushAnimation("idle_loop")
	inst.AnimState:SetTime(math.random()*2)
	
	inst:AddTag("des_chainik_onfire")
	
	

	
	inst.components.container:Close()
	inst.components.container.canbeopened = false


	
	
	inst.anim_task = inst:DoPeriodicTask(2, function(inst) 
		 inst.AnimState:PushAnimation("idle_loop")
		 inst.AnimState:SetTime(math.random()*2)
	end)
end


local function SetUpItem(inst, data)
	RemovePhysicsColliders(inst)
    MakeInventoryPhysics(inst)


    inst.AnimState:PlayAnimation("idle_ground")

	inst:RemoveTag("des_chainik_onfire")
	
	
	
	


		
	if inst.components.des_chainik_c.firepit and inst.components.des_chainik_c.firepit.des_chainik_link then
		inst.components.des_chainik_c.firepit.des_chainik_link = nil
	end
	if inst.components.des_chainik_c.firepit then
		inst.components.des_chainik_c.firepit = nil
	end
	if inst.anim_task then
		inst.anim_task:Cancel()
	end
	inst.components.container.canbeopened = true

end

local function OnPickupFn(inst)
	inst.components.des_chainik_c:TryToFinishBrewing()

	inst:PushEvent("des_placechainik_item", { target = nil, player = nil })
end



local function SetUpBoiling(inst, data)
	FixImageAndAnim(inst)

	if inst.components.des_chainik_c.boiling and not inst.components.inventoryitem.owner then
		 inst.Light:Enable(true)
		-- print("ENABLE SAMOVAR LIGHT")
	else
		-- print("DISABLE SAMOVAR LIGHT")
		 inst.Light:Enable(false)
	end
end



local function build_chainik(typename)

local function fn()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()
    inst.entity:AddNetwork()

    MakeInventoryPhysics(inst)

   -- inst.AnimState:SetBloomEffectHandle("shaders/anim.ksh")

	inst:AddTag("des_chainik")
	inst:AddTag("des_chainik_nogi")
	

	
	if typename == "des_chainik" then
		inst.AnimState:SetBank("des_chainik_nogi")
		inst.AnimState:SetBuild("des_chainik_nogi")
		inst.AnimState:PlayAnimation("idle_ground")
		
		
			
		inst.AnimState:Hide("mouseover")
		inst.AnimState:Hide("goop")
		inst.AnimState:Hide("goop_small")
		inst.AnimState:Hide("goop_syrup")
			
		
		local s = 0.6
		inst.Transform:SetScale(s,s,s,s)
	elseif typename == "des_enkettle" then
		inst.AnimState:SetBank("des_enkettle")
		inst.AnimState:SetBuild("des_enkettle")
		inst.AnimState:PlayAnimation("empty")
	
		inst.entity:AddLight()
		inst.Light:Enable(false)
		inst.Light:SetRadius(.6)
		inst.Light:SetFalloff(1)
		inst.Light:SetIntensity(.5)
		inst.Light:SetColour(52/255,62/255,200/255)

	
		local s = 1
		inst.Transform:SetScale(s,s,s,s)
	
	
	end
	
	

    inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end

    inst:AddComponent("inspectable")

    inst:AddComponent("inventoryitem")
	inst.components.inventoryitem:SetOnPickupFn(OnPickupFn)
	--inst.components.inventoryitem:SetOnDroppedFn(OnDropped)

	inst:AddTag("des_water_spoiling")
	
	inst:AddComponent("waterproofer")
	inst.components.waterproofer:SetEffectiveness(0)
	inst.no_wet_prefix = true
	
	inst:AddComponent("cwater")

	-----
	inst:AddTag("des_can_pour_to")
	-----
	inst:AddTag("des_watercatcher_update_fakedrop")
	inst:AddTag("des_chainik_update_discr")
	inst:AddTag("des_update_waterdrop_fake_chai")
	
	
	inst:AddComponent("wateryprotection")	
    inst.components.wateryprotection.extinguishheatpercent = TUNING.WATERBALLOON_EXTINGUISH_HEAT_PERCENT
    inst.components.wateryprotection.temperaturereduction = TUNING.WATERBALLOON_TEMP_REDUCTION
    inst.components.wateryprotection.witherprotectiontime = TUNING.WATERBALLOON_PROTECTION_TIME
    inst.components.wateryprotection.addwetness = TUNING.WATERBALLOON_ADD_WETNESS
    inst.components.wateryprotection:AddIgnoreTag("player")



	inst:AddComponent("container")
    inst.components.container.onopenfn = onopen
    inst.components.container.onclosefn = onclose
	inst.components.container:WidgetSetup("des_chainik")
	inst.widgetsetup = "des_chainik"
	inst.fakedrop_slot = 1
	inst.fakedrop_chainik_slot = 3


	inst:AddComponent("des_chainik_c")

	inst:ListenForEvent("itemget", ongetitem)
	inst:ListenForEvent("itemlose", onloseitem)

	if typename == "des_chainik" then
		inst.components.inventoryitem.atlasname = "images/inventoryimages/des_chainik.xml"
		
		inst:AddTag("des_chainik_placable")

		inst.components.cwater:SetMax(TUNING.DES_CHAINIK_SIZE)
		inst.components.cwater:DoDelta(-TUNING.DES_CHAINIK_SIZE)
		
		inst.components.cwater.cleanspeed = TUNING.WATER_SPOIL_SPEED
			----badness per second per 100 water inside of container
		inst.components.cwater.spoilspeed = TUNING.DES_WATER_SPOIL_CHAINIK

			
	
		inst:ListenForEvent("des_placechainik", SetUpChainik)
		inst:ListenForEvent("des_placechainik_item", SetUpItem)
		inst:ListenForEvent("des_chainik_steam", OnPotSteam)
		
		
		inst:DoPeriodicTask(5, function()
			if inst.components.inventoryitem and inst.components.inventoryitem.owner and inst.components.des_chainik_c then
				inst.components.des_chainik_c:SetUpItem(inst)
			end
		end)	
		
		
		
	elseif typename == "des_enkettle" then
		inst.components.inventoryitem.atlasname = "images/inventoryimages/des_enkettle.xml"

		inst.components.inventoryitem:SetOnDroppedFn(OnDropped)
		inst.components.inventoryitem:SetOnPickupFn(SetOnPickupFn)
		
		inst:ListenForEvent("des_start_boil_inner", SetUpBoiling)	

		inst.components.container:WidgetSetup("des_samovar")
		inst.widgetsetup = "des_samovar"
		--DES_ENCHAINIK_SIZE
			

		inst.components.cwater:SetMax(TUNING.DES_ENCHAINIK_SIZE)
		inst.components.cwater:DoDelta(-TUNING.DES_ENCHAINIK_SIZE)
		
		inst.components.cwater.cleanspeed = TUNING.WATER_SPOIL_SPEED
			----badness per second per 100 water inside of container
		inst.components.cwater.spoilspeed = TUNING.DES_WATER_SPOIL_ENCHAINIK

			
		inst:DoTaskInTime(0, function()
			FixImageAndAnim(inst)
		end)

		
		
		
		inst.components.des_chainik_c.inner_fire_force = 5
		inst.components.des_chainik_c.slot_empty_act = 7
		inst.components.des_chainik_c.slot_turn_on_act = 5
		inst.fakedrop_slot = 1
		inst.fakedrop_chainik_slot = 3
		
	end
	
	
	

	
	
	
    return inst
end

if typename == "des_chainik" then
	return Prefab("des_chainik", fn, assets, prefabs)
elseif typename == "des_enkettle" then
	return Prefab("des_enkettle", fn, enassets, prefabs)
end
end



return build_chainik("des_chainik"),
build_chainik("des_enkettle")