local assets =
{
	Asset("ANIM", "anim/des_cleantablets.zip"),
	
	Asset("ATLAS", "images/inventoryimages/des_cleantablets_white.xml"),
    Asset("IMAGE", "images/inventoryimages/des_cleantablets_white.tex"),
	
	Asset("ATLAS", "images/inventoryimages/des_cleantablets_pink.xml"),
    Asset("IMAGE", "images/inventoryimages/des_cleantablets_pink.tex"),
	
	Asset("ATLAS", "images/inventoryimages/des_cleantablets_grey.xml"),
    Asset("IMAGE", "images/inventoryimages/des_cleantablets_grey.tex")
}

local function build_des_tablet(colour)


    local function fn()
        local inst = CreateEntity()

        inst.entity:AddTransform()
        inst.entity:AddAnimState()
        inst.entity:AddSoundEmitter()
        inst.entity:AddNetwork()

        MakeInventoryPhysics(inst)
		
        inst:AddTag("molebait")

        inst.AnimState:SetBank("des_cleantablets")
        inst.AnimState:SetBuild("des_cleantablets")
        inst.AnimState:PlayAnimation(colour)

        inst.entity:SetPristine()
		
		local s = 2	
		inst.Transform:SetScale(s,s,s )
		
        if not TheWorld.ismastersim then
            return inst
        end

		inst:AddTag("des_well_valid")
		if colour == "pink" then
			inst:AddTag("des_well_watercleaner")
		elseif colour == "white" then 
			inst:AddTag("des_water_saltremoveer")
		elseif colour == "grey" then
			inst:AddTag("des_water_poisoner")
		end	
        inst:AddComponent("bait")
		

		

        inst:AddComponent("stackable")
        inst.components.stackable.maxsize = TUNING.STACK_SIZE_SMALLITEM

        inst:AddComponent("inspectable")

        inst:AddComponent("inventoryitem")
		inst.components.inventoryitem.atlasname = "images/inventoryimages/des_cleantablets_"..colour..".xml"
      
	  
		inst:AddTag("des_cleantablet")
        inst:AddComponent("des_throw_in")
			  
	  
	  
		MakeHauntableLaunchAndSmash(inst)

        return inst
    end
    return Prefab("des_cleantablets_"..colour, fn, assets)
end

return build_des_tablet("grey"),
build_des_tablet("pink"),
build_des_tablet("white")