require "prefabutil"
require "recipe"
require "modutil"

local assets=
{
	Asset("ANIM", "anim/des_samovar.zip"),
    Asset("ATLAS", "images/inventoryimages/des_samovar.xml"),
    Asset("IMAGE", "images/inventoryimages/des_samovar.tex"),
	--Asset("SOUNDPACKAGE", "sound/pickle_barrel.fev"),
	--Asset("SOUND", "sound/pickle_barrel_bank.fsb"),
	--Asset("SOUND", "sound/monkey.fsb"),

	Asset("ANIM", "anim/des_ui_samovar3x3.zip"),
	
	
	Asset("ANIM", "anim/des_chainik_nogi.zip"),
	
}






--  Break the pickle barrel when it is hammered upon
local function onhammered(inst, worker)
	if inst.frozen == true then
		inst:RemoveComponent("lootdropper")	
		inst:AddComponent("lootdropper")
		inst.components.lootdropper:SetLoot({ "boards", "rope"})
		inst.components.lootdropper:DropLoot()
		local insert_ice = math.floor(inst.components.cwater.current/100)+1
		inst.components.lootdropper:SetLoot({"ice"})

		local i = 0
		repeat
		i = i + 1
			inst.components.lootdropper:DropLoot()
		until i > insert_ice

	end


	SpawnPrefab("collapse_small").Transform:SetPosition(inst.Transform:GetWorldPosition())
	inst.SoundEmitter:PlaySound("dontstarve/common/destroy_metal")
	inst:Remove()
end

local function FakeDrop(inst)
	--if true==true then
	--return
	--end
	
	local found = inst.components.container:FindItem(function(find_fakedrop) return find_fakedrop==inst.des_fakedrop end)
	if found then
		return
	elseif not found and inst.des_fakedrop then
		inst.des_fakedrop:Remove()
	end
	

	
	if not found then
		inst.des_fakedrop = SpawnPrefab("des_waterdrop_fake")
		
		inst.des_fakedrop.original_owner = inst
		--int("SPAWNED FAKE DROP")
		inst.components.container:GiveItem(inst.des_fakedrop, inst.fakedrop_slot)
	end
end




local function onopen(inst)
	FakeDrop(inst)

	inst:AddTag("des_watercatcher_update_fakedrop")
	inst.components.cwater:GetDiscCatcher()
	inst.SoundEmitter:PlaySound("pickle_barrel/pickle_barrel/open", "open")
	
	--inst.AnimState:PlayAnimation("open")
end

local function onclose(inst)
	inst.SoundEmitter:PlaySound("pickle_barrel/pickle_barrel/close", "close")

	FakeDrop(inst)
	inst:RemoveTag("des_watercatcher_update_fakedrop")
end




local function onbuilt(inst)
	inst.AnimState:PlayAnimation("built")
	inst.AnimState:PushAnimation("idle", false)
end


local function onopen(inst)
	inst.components.des_chainik_c:FixButtons()
	inst:AddTag("des_watercatcher_update_fakedrop")
	--inst.components.cwater:GetDiscCatcher()
	--inst.SoundEmitter:PlaySound("pickle_barrel/pickle_barrel/open", "open")
	
	--inst.AnimState:PlayAnimation("open")
end

local function onclose(inst)
	--inst.SoundEmitter:PlaySound("pickle_barrel/pickle_barrel/close", "close")
	inst.components.des_chainik_c:FixButtons()
	inst:RemoveTag("des_watercatcher_update_fakedrop")
	
	--inst.AnimState:PlayAnimation("close")
	--inst.AnimState:PushAnimation("idle", false)

end









local function ongetitem(inst)
	inst:DoTaskInTime(0.1, function()
		inst.components.des_chainik_c:FixButtons()
	end)
	inst.components.des_chainik_c:OnGetItem()
end

local function onloseitem(inst)
	inst.components.des_chainik_c:FixButtons()
end


local function onhit(inst, worker)
	if inst.components.cwater.current>50 and inst.frozen == false then
		local splash = SpawnPrefab("splash_ocean")
		splash.Transform:SetPosition(inst.Transform:GetWorldPosition())
		inst.components.cwater:GroundPour(nil, nil, 400)
	end
	inst.AnimState:PlayAnimation(inst.hit_anim)
    inst.AnimState:PushAnimation(inst.idle_anim)
end


local function OnFinishedDest(inst)
	SpawnPrefab("boards").Transform:SetPosition(inst.Transform:GetWorldPosition())
	SpawnPrefab("rope").Transform:SetPosition(inst.Transform:GetWorldPosition())
	SpawnPrefab("cutgrass").Transform:SetPosition(inst.Transform:GetWorldPosition())
	inst:Remove()
end



local function OnIsDay(inst, isday)
    if isday or (inst.components.cwater.current>10) or inst.frozen then
       -- inst.components.childspawner:StopSpawning()
    elseif inst.components.cwater.current <=10 then
       -- inst.components.childspawner:StartSpawning()
    end
end



local function OnInit(inst)
	inst.task = nil
   --- inst:WatchWorldState("snowlevel", OnSnowLevel)

end


local function OnPotSteam(inst)
    local fx = CreateEntity()

    fx:AddTag("FX")
    fx:AddTag("NOCLICK")
    --[[Non-networked entity]]
    fx.entity:SetCanSleep(false)
    fx.persists = false

    fx.entity:AddTransform()
    fx.entity:AddAnimState()
    fx.entity:AddSoundEmitter()

    fx.AnimState:SetBank("des_chainik_nogi")
    fx.AnimState:SetBuild("des_chainik_nogi")
    fx.AnimState:PlayAnimation("steam")
    fx.AnimState:SetFinalOffset(1)

    fx:ListenForEvent("animover", fx.Remove)

    fx.Transform:SetPosition(inst.Transform:GetWorldPosition())
    fx.SoundEmitter:PlaySound("dontstarve/common/cookingpot_open", nil, .6)
    fx.SoundEmitter:PlaySound("dontstarve/common/cookingpot_close")
end

local function SetUpBoiling(inst, data)
	if inst.components.des_chainik_c.boiling then
		inst.Light:Enable(true)
		--rint("ENABLE SAMOVAR LIGHT")
	else
		--int("DISABLE SAMOVAR LIGHT")
		inst.Light:Enable(false)
	end
end

local function fn(Sim)
	local inst = CreateEntity()
	inst.entity:AddTransform()
	local anim = inst.entity:AddAnimState()
	inst.entity:AddSoundEmitter()
    inst.entity:AddNetwork()
    inst.entity:AddLight()
	
	
	local minimap = inst.entity:AddMiniMapEntity()
	minimap:SetIcon( "des_samovar.tex" )
    
    inst:AddTag("structure")
	

	inst:AddTag("des_water_spoiling")
	inst:AddTag("des_samovar")

    MakeObstaclePhysics(inst, .5)
    
	inst.Light:Enable(false)
    inst.Light:SetRadius(.6)
    inst.Light:SetFalloff(1)
    inst.Light:SetIntensity(.5)
    inst.Light:SetColour(235/255,62/255,12/255)
	
	
	
    inst.AnimState:SetBank("des_samovar")
    inst.AnimState:SetBuild("des_samovar")
    inst.AnimState:PlayAnimation("idle")

	local s = 0.4
	inst.Transform:SetScale(s,s,s)
	
    if not TheWorld.ismastersim then
        return inst
    end
	
	inst.entity:SetPristine()

	inst:AddComponent("cwater")
	inst.components.cwater:SetMax(TUNING.DES_SAMOVAR_SIZE)
	inst.components.cwater:DoDelta(-TUNING.DES_SAMOVAR_SIZE)
	--inst.components.cwater.watergainspeed = TUNING.WATERTRAP_GAIN_SPEED_GRASS
	--inst:AddTag("water_gain_rain")
	-----
	inst:AddTag("des_can_pour_to")
	-----
	
	
	
	inst.components.cwater.cleanspeed = TUNING.WATER_SPOIL_SPEED
		----badness per second per 100 water inside of container
	inst.components.cwater.spoilspeed = TUNING.DES_WATER_SPOIL_CHAINIK
	
	inst:AddTag("des_watercatcher_update_fakedrop")
	inst:AddTag("des_chainik_update_discr")
	inst:AddTag("des_update_waterdrop_fake_chai")
	
    inst:AddComponent("container")
	inst.components.container:WidgetSetup("des_samovar")
    inst.components.container.onopenfn = onopen
    inst.components.container.onclosefn = onclose
	inst.widgetsetup = "des_samovar"
	inst.fakedrop_slot = 2
	inst:ListenForEvent("itemget", ongetitem)
    inst:ListenForEvent("itemlose", onloseitem)

    inst:AddComponent("inspectable")

	
	
	-- inst:AddComponent("finiteuses")
	-- inst.components.finiteuses:SetMaxUses(900)
	-- inst.components.finiteuses:SetUses(900)
	-- inst.components.finiteuses:SetOnFinished(OnFinishedDest)
	
	


	

    inst.task = inst:DoTaskInTime(0, OnInit)
	
	inst:AddComponent("des_easy_code")

    inst:AddComponent("lootdropper")
    inst:AddComponent("workable")
    inst.components.workable:SetWorkAction(ACTIONS.HAMMER)
    inst.components.workable:SetWorkLeft(5)
	inst.components.workable:SetOnFinishCallback(onhammered)
	inst.components.workable:SetOnWorkCallback(onhit)

	
	inst:ListenForEvent("des_chainik_steam", OnPotSteam)
	
	
	inst:AddComponent("des_chainik_c")

	inst.components.des_chainik_c.inner_fire_force = 5

	inst.components.des_chainik_c.slot_empty_act = 7
	
	inst.components.des_chainik_c.slot_turn_on_act = 5
	
	inst.fakedrop_slot = 1
	inst.fakedrop_chainik_slot = 3

	
	inst:AddComponent("wateryprotection")	
    inst.components.wateryprotection.extinguishheatpercent = TUNING.WATERBALLOON_EXTINGUISH_HEAT_PERCENT
    inst.components.wateryprotection.temperaturereduction = TUNING.WATERBALLOON_TEMP_REDUCTION
    inst.components.wateryprotection.witherprotectiontime = TUNING.WATERBALLOON_PROTECTION_TIME
    inst.components.wateryprotection.addwetness = TUNING.WATERBALLOON_ADD_WETNESS
    inst.components.wateryprotection:AddIgnoreTag("player")
	
	
	inst:DoPeriodicTask(1, function()
		if inst.components.des_chainik_c.boiling then
			inst.AnimState:PlayAnimation("idle_boil")
			inst.AnimState:PushAnimation("idle", false)
		end
	end)
	inst.hit_anim = "hit"
    inst.idle_anim = "idle"

	
	--MakeSnowCovered(inst, .01)  

	inst:ListenForEvent("des_start_boil_inner", SetUpBoiling)	
	inst:ListenForEvent("onbuilt", onbuilt)
    return inst
end


return Prefab( "common/des_samovar", fn, assets, prefabs),
		MakePlacer( "common/des_samovar_placer", "des_samovar", "des_samovar", "placer" ) 
