local assets =
{
    Asset("ANIM", "anim/des_fsp_grand_final_fix.zip"),

    Asset("ATLAS", "images/inventoryimages/des_statue_charlie.xml"),
    Asset("IMAGE", "images/inventoryimages/des_statue_charlie.tex"),
	
}

local prefabs =
{

}


--[[
local function Counter(inst)
	inst:DoPeriodicTask(0.1, function()
			inst.timeof = inst.timeof+0.1
			if inst.timeof > 18 then return end
	 end)
	
	
end--]]

local PETALSPERDAY = 2
local MAXPETALS = 12
local childtype = "flower"

-------local COOLDOWN = 20 --delay between uses by different players




local function PlantFlower(inst)
	local minrad=1.5
	local maxrad=4
	
	--inst exists
	if not inst then return end
	local pt = inst:GetPosition()
	
	--not too many children
	local ents = TheSim:FindEntities(pt.x, pt.y, pt.z, maxrad)
	local count=0
	for k,v in pairs(ents) do
		if v.prefab == childtype or v.prefab == "flower_rose" or v.prefab == "flower" then
			count = count + 1
		end
	end
	if count>=MAXPETALS then return end
	if math.random()<0.33 then childtype = "flower_evil" end
	if math.random()<0.2 then childtype = "flower_rose" end
	
	
	--Find spot for new child and spawn
	local angle=math.random()*2*PI
	local radius=math.random()*(maxrad-minrad)+minrad
	local offset, check_angle, deflected=FindWalkableOffset(pt, angle, radius, 8, true, false)
	if(not check_angle) then return end
	angle=check_angle
	pt.x=pt.x+radius*math.cos(angle)
	pt.z=pt.z-radius*math.sin(angle)
	
	SpawnPrefab(childtype).Transform:SetPosition(pt:Get())
end


local function Animation(inst)


	if inst.currentanim == "work" then
		if math.random()<0.33 then
			inst.AnimState:PlayAnimation("fsp_cycle",true)
			inst.AnimState:SetTime((math.random() * 2)/2)
		else

			inst.AnimState:PlayAnimation("fsp_idle",true)
		end
	else

		inst.AnimState:PlayAnimation("fsp_dry",true)
	end
end


local function Dry(inst)
	inst.currentanim = "fsp_dry"
	inst.state = "DRY"
	inst:AddTag("water_sourse_dry")
	inst:RemoveTag("water_sourse")
	inst:RemoveTag("water_sourse_nolimit")
	inst:RemoveTag("water_sourse_no_limit")
end

local function Fill(inst)
	inst.currentanim = "work"
	inst.state = "FULL"
	inst:RemoveTag("water_sourse_dry")
	inst:AddTag("water_sourse")
	inst:AddTag("water_sourse_nolimit")
	inst:AddTag("water_sourse_no_limit")
end

local function OnSave(inst, data)
	data.burnt = inst.state
	data.daysleft = inst.daysleft
end

local function OnLoad(inst, data)
	if data and data.state then
		inst.state = data.state
		inst.daysleft = data.daysleft or 2
		if inst.state == "FULL" then
			Fill(inst)
		else
			Dry(inst)
		end
	end
end

local function inspect_stat(inst)
    return (inst:HasTag("water_sourse_nolimit") and "FULL")
        or (inst:HasTag("water_sourse_dry") and "DRY")
        --#DISEASE or (inst:HasTag("diseased") and "DISEASED")
        or nil
end

local function fn()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()
    inst.entity:AddMiniMapEntity()
    inst.entity:AddNetwork()

   -- inst:AddTag("maxwell")
    --inst.entity:AddTag("statue")

    MakeObstaclePhysics(inst, 0.75)

    inst:AddTag("structure")
	
	local minimap = inst.entity:AddMiniMapEntity()
	minimap:SetIcon( "des_statue_charlie.tex" )

    inst.AnimState:SetBank("des_fsp_grand_final_fix")
    inst.AnimState:SetBuild("des_fsp_grand_final_fix")
	inst.AnimState:PlayAnimation("fsp_cycle",true)

	
	inst:AddTag("antlion_sinkhole_blocker")
	
	inst.state = "FULL"
	inst:AddTag("water_sourse")
	inst:AddTag("water_sourse_nolimit")
	inst:AddTag("water_sourse_no_limit")
	inst:AddTag("des_statue_charlie")

	local scale = 1
	inst.Transform:SetScale(scale, scale, scale)
	
    inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end

	inst:DoPeriodicTask(18, function()
		Animation(inst)
	end)
	
	inst.daysleft = 5
	inst.currentanim = "work"
	---------------Growing details
	local growth_stages = {
		{name="only",
		time=function(inst) return TUNING.TOTAL_DAY_TIME/PETALSPERDAY end,
		fn=function(inst) PlantFlower(inst) end},
	}
	inst:AddComponent("growable")
	inst.components.growable.stages = growth_stages
	inst.components.growable:SetStage(1)
	inst.components.growable.loopstages = true
	inst.components.growable:StartGrowing()

	
	
	--[[
	inst:AddComponent("cooldown")
    inst.components.cooldown.cooldown_duration = COOLDOWN
    inst.components.cooldown.onchargedfn = OnCharged
    inst.components.cooldown.startchargingfn = OnStartCharging
    inst.components.cooldown.charged = true--]]
	
	
    inst:AddComponent("inspectable")
	inst.components.inspectable.getstatus = inspect_stat
	
		
	local function OnStartDay(inst)
		inst.daysleft = inst.daysleft - 1
		if inst.daysleft < 1 and inst.state == "FULL" then
			Dry(inst)
			inst.daysleft = TUNING.THIRST_DES_FOUNTAIN_DRYDAYS + math.random(2,4)
		elseif inst.daysleft < 1 and inst.state == "DRY" then
			Fill(inst)
			inst.daysleft = TUNING.THIRST_DES_FOUNTAIN_FULLDAYS + math.random(1,3)
		end
	end

    inst:WatchWorldState("startday", OnStartDay)

	
	inst.OnSave = OnSave
	inst.OnLoad = OnLoad

    return inst
end

return Prefab("des_statue_charlie", fn, assets, prefabs)
