
local assets=
{
    Asset("ANIM", "anim/des_stone_well.zip"),
    Asset("ATLAS", "images/inventoryimages/des_water_well.xml"),
    Asset("IMAGE", "images/inventoryimages/des_water_well.tex"),
----	Asset("ATLAS", "images/watertab.xml"),
  --  Asset("IMAGE", "images/watertab.tex"),
}

local function onhammered(inst, worker)
	if inst.components.container ~= nil then
		inst.components.container:DropEverything()
	end
	local fx = SpawnPrefab("collapse_big")
	
	inst:AddComponent("finiteuses")
	inst.components.finiteuses:SetPercent(0)

	inst:RemoveComponent("lootdropper")	
    inst:AddComponent("lootdropper")
    inst.components.lootdropper:SetLoot({ "cutstone", "cutstone", "cutstone", "rocks", "rocks" , "rocks" , "rocks" })
    inst.components.lootdropper:DropLoot()

	local hole = SpawnPrefab("des_well_hole")
	hole:RemoveComponent("workable")
	hole.AnimState:PlayAnimation("dug")
	hole.Transform:SetPosition(inst.Transform:GetWorldPosition())
	
	fx.Transform:SetPosition(inst.Transform:GetWorldPosition())
	fx:SetMaterial("stone")
	inst:Remove()
end

local function onhammeredrack(inst, worker)
	if inst.components.container ~= nil then
		inst.components.container:DropEverything()
	end
	local fx = SpawnPrefab("collapse_big")
	
	inst:AddComponent("finiteuses")
	inst.components.finiteuses:SetPercent(0)
	
	inst:RemoveComponent("lootdropper")
    inst:AddComponent("lootdropper")
    inst.components.lootdropper:SetLoot({ "boards", "rope", "boards", "rope" })
    inst.components.lootdropper:DropLoot()


	fx.Transform:SetPosition(inst.Transform:GetWorldPosition())
	fx:SetMaterial("wood")
	
	SetUpEmpty(inst)
end

local function onhammeredburnt(inst, worker)
	if inst.components.container ~= nil then
		inst.components.container:DropEverything()
	end
	local fx = SpawnPrefab("collapse_big")
	
	inst:AddComponent("finiteuses")
	inst.components.finiteuses:SetPercent(0)
	
	inst:RemoveComponent("lootdropper")
    inst:AddComponent("lootdropper")
    inst.components.lootdropper:SetLoot({ "boards", "rope", "ash", "ash", "charcoal" })
    inst.components.lootdropper:DropLoot()


	fx.Transform:SetPosition(inst.Transform:GetWorldPosition())
	fx:SetMaterial("wood")
	
	SetUpEmpty(inst)
end






local function onhit(inst, worker)
	FixBrokenAnim(inst)
end

local function turnon(inst)
if not inst.AnimState:IsCurrentAnimation("onwinter") then
	inst.AnimState:PlayAnimation("water")
	inst.AnimState:PushAnimation("idle_full", true)
	inst:DoTaskInTime(1.75, function(inst)
	inst.SoundEmitter:PlaySound("dontstarve_DLC001/common/HUD_wet_open")
	end)
end
end

local function turnoff(inst)
if not inst.AnimState:IsCurrentAnimation("onwinter") then
	inst.AnimState:PlayAnimation("reset_to_idle")
	inst.AnimState:PushAnimation("idle_empty", true)
end
end

local function ShouldAcceptItem(inst, item, giver)
	if item.prefab == ("bucket") and inst.AnimState:IsCurrentAnimation("idle_full") then 
		    return true
	    else
			return false
    end
end









local function onopen(inst)

end

local function onclose(inst)


end


local function ongetitem(inst)
	local bucket = inst.components.container:GetItemInSlot(1)
	local player = nil	
	local anim = "idle_stone"
	local work_anim = "default"
	local water = 0.5
	
	if TheSim:GetGameID() == "DST" then
			for _, playerf in pairs(AllPlayers) do
				if (not playerf:HasTag("playerghost")) and (not playerf:HasTag("ghost")) and inst:GetDistanceSqToInst(playerf)< 6*6 then
					player = playerf
				end
			end
	end	
		
	
	if inst:HasTag("well_broken") and not (bucket:HasTag("des_well_watercleaner") or bucket:HasTag("des_well_poisoner") or (bucket.prefab == "cutstone") and inst.state == "GENERIC" and inst.components.workable.workleft<11) then
        local word = TUNING.THIRST_WELLBROKEN_PHRASES[math.random(#TUNING.THIRST_WELLBROKEN_PHRASES)]
		if player then
			player.components.talker:Say(word, 4, false)
			inst.components.container:DropItem(bucket)
		end
		return
	end




		
	---------	
		
	---------------------------------------------
	if bucket:HasTag("des_well_poisoner") then
        local word = TUNING.THIRST_POISON_PHRASES[math.random(#TUNING.THIRST_POISON_PHRASES)]
		if player then
			player.components.talker:Say(word, 4, false)
		end
		inst.water_poison = true
		--UseAndDrop(ammount, maximum, bucket, player)
		inst.components.des_easy_code:UseAndDrop(1, 1, bucket, player)
		
		return
	end	
	if bucket:HasTag("des_well_watercleaner") then
        local word = TUNING.THIRST_CLEARPOISON_PHRASES[math.random(#TUNING.THIRST_CLEARPOISON_PHRASES)]
		if player then
			player.components.talker:Say(word, 4, false)
		end
		inst.water_poison = false
		--UseAndDrop(ammount, maximum, bucket, player)
		inst.components.des_easy_code:UseAndDrop(1, 1, bucket, player)
		
		return
	end
	if bucket.prefab == "cutstone" and inst.state == "GENERIC" and inst.components.workable.workleft<11 then
        local word = TUNING.THIRST_WELLREPAIR_PHRASES[math.random(#TUNING.THIRST_WELLREPAIR_PHRASES)]
		if player then
			player.components.talker:Say(word, 4, false)
		end
		local tofix = bucket.components.stackable.stacksize
		local neededrepair = 11 - inst.components.workable.workleft
		
		local fixingpower = inst.components.des_easy_code:UseAndDrop(tofix, neededrepair, bucket, player)
		inst.components.workable:SetWorkLeft(inst.components.workable.workleft+fixingpower)
		FixBrokenAnim(inst)
		
		
		return
	end	
		
	--------- A water mod shit---------
	if bucket.prefab == "bucket" then
		bucket:Remove()
		local newbucket = SpawnPrefab("bucketfull")
		inst.components.container:GiveItem(newbucket, nil, nil, true)
		inst.components.container:DropItem(newbucket)
		inst.components.container:Close()
		
		return
	end
	----------------------------------
		
	if inst:HasTag("well_rack") then
		anim = "idle_rack"
		work_anim = "idle_rack_do_work"
		water = 1
	end
		
	if inst.water_poison == true then
		water = water*0.7
	end	
	
	
	
		if bucket:HasTag("des_bucket") then
			----start bucket sequance
			inst.components.container:Close()
			inst.components.container.canbeopened = false
			
			if work_anim == "default" then 
				if bucket:HasTag("des_bucket_wood") then
					inst.AnimState:PlayAnimation("idle_stone_do_work_wood")
				else
					inst.AnimState:PlayAnimation("idle_stone_do_work_steel")
				end
			elseif work_anim == "idle_rack_do_work" then 
				inst.AnimState:PlayAnimation("idle_rack_do_work")
			end
			
			inst:DoTaskInTime(2, function(inst)
				bucket.components.cwater:DoDelta(bucket.components.cwater.max * water)
				bucket.components.finiteuses:Use(1)
				
				if inst.water_poison == true then
					bucket.components.cwater:Poison()
				end
				
				inst.components.container:DropItem(bucket)
				inst.components.container.canbeopened = true
				
				if TheSim:GetGameID() == "DST" then
					for _, playerf in pairs(AllPlayers) do
						if (not playerf:HasTag("playerghost")) and (not playerf:HasTag("ghost")) and inst:GetDistanceSqToInst(playerf)< 1.5*1.5 then
							player = playerf
						end
					end
				end	
				if player then
					player.sg:GoToState("give")
					player.components.inventory:GiveItem(bucket, nil, nil, true)
				end
				
				inst.AnimState:PlayAnimation(anim)

			end)	
			
			inst:DoTaskInTime(2, function(inst)

			end)
		end
end

local function onloseitem(inst)

end




local function onsnowcovered(inst, covered)
	if TheWorld.state.issnowcovered then
	inst.AnimState:PlayAnimation("onwinter", false)
    else 
	inst.AnimState:PlayAnimation("idle_empty", true)
    end
end
--------------------------
local function GetStatus(inst)
	return inst.state
end


local function onbuilt(inst)
	local hole = FindEntity(inst, 3, function(guy) return (guy.prefab=="des_well_hole" and not guy.workable) end)
	if hole then
		inst.Transform:SetPosition(hole.Transform:GetWorldPosition())
		inst.AnimState:PlayAnimation("build")
		hole:Remove()
	end

end













local params = {}
local containers = require "containers"
local prev_widgetsetup=containers.widgetsetup

local function mywidgetsetup(container, prefab, data)
    local t = data or params[prefab or container.inst.prefab]
    if t ~= nil then
        for k, v in pairs(t) do
            container[k] = v
        end
        container:SetNumSlots(container.widget.slotpos ~= nil and #container.widget.slotpos or 0)
    end
end

--------------------------------------------------------------------------
--[[ wool_sack ]]
--------------------------------------------------------------------------

params.wool_sack =
{
    widget =
    {
        slotpos = {},
        animbank = "ui_piggyback_2x6",
        animbuild = "ui_piggyback_2x6",
        pos = Vector3(-5, -50, 0),
    },
    issidewidget = true,
    type = "chest",
}

for y = 0, 5 do
    table.insert(params.wool_sack.widget.slotpos, Vector3(-162, -75 * y + 170, 0))
    table.insert(params.wool_sack.widget.slotpos, Vector3(-162 + 75, -75 * y + 170, 0))
end
for k, v in pairs(params) do
    containers.MAXITEMSLOTS = math.max(containers.MAXITEMSLOTS, v.widget.slotpos ~= nil and #v.widget.slotpos or 0)
end







local function inspect_stat(inst)
	return (inst:HasTag("well_rack") and "FRAME")
        or (inst:HasTag("well_burnt") and "BURNT")
        --#DISEASE or (inst:HasTag("diseased") and "DISEASED")
        or "GENERIC"
end


local function tree_startburn(inst)
    if inst.components.pickable ~= nil then
        inst.components.pickable.caninteractwith = false
    end
end


function SetUpRack(inst)
	inst.state = "FRAME"
	inst:AddTag("well_rack")
	inst:RemoveTag("well_burnt")
	inst:RemoveTag("well_empty")
	inst.des_idle_anim = "idle_rack"
	inst.des_work_anim = "idle_rack_do_work"
	inst.AnimState:PlayAnimation(inst.des_idle_anim)
	
	inst.components.container:Close()
	
    inst:RemoveComponent("workable")	
    inst:AddComponent("workable")
	inst.components.workable:SetWorkAction(ACTIONS.HAMMER)
	inst.components.workable:SetWorkLeft(2)
	inst.components.workable:SetOnFinishCallback(onhammeredrack)
	inst.components.workable:SetOnWorkCallback(onhit)	
	
	if inst.components.burnable then
		inst:RemoveComponent("burnable")
	end
    MakeLargeBurnable(inst, nil, nil, true)
    MakeLargePropagator(inst)
	--inst.components.burnable:SetOnIgniteFn(tree_startburn)
    inst.components.burnable:SetOnBurntFn(SetUpBurnt)
end

function SetUpEmpty(inst)
	inst.state = "GENERIC"
	inst:RemoveTag("well_rack")
	inst:RemoveTag("well_burnt")
	inst:AddTag("well_empty")
	inst.des_idle_anim = "idle_stone"
	inst.des_work_anim = "default"	
	inst.AnimState:PlayAnimation(inst.des_idle_anim)
	
	inst.components.container:Close()
	
	if inst.components.burnable then
		inst:RemoveComponent("burnable")
	end
	
    inst:RemoveComponent("workable")		
    inst:AddComponent("workable")
	inst.components.workable:SetWorkAction(ACTIONS.MINE)
	inst.components.workable:SetWorkLeft(11)
	inst.components.workable:SetOnFinishCallback(onhammered)
	inst.components.workable:SetOnWorkCallback(onhit)	
end

function FixBrokenAnim(inst)
	--inst.components.container.canbeopened = true
	if inst.state == "GENERIC" and inst.components.workable.workleft > 8 then
		inst.components.container:Close()
		inst.components.container.canbeopened = true
		inst.des_idle_anim = "idle_stone"
		inst:RemoveTag("well_broken")

		
	elseif inst.state == "GENERIC" and inst.components.workable.workleft <= 8 then
		inst:AddTag("well_broken")
		inst.components.container:Close()
		---inst.components.container.canbeopened = false

		if inst.components.workable.workleft > 6 then
			inst.des_idle_anim = "idle_stone_full"
		elseif inst.components.workable.workleft >3 then
			inst.des_idle_anim = "idle_stone_med"
		elseif inst.components.workable.workleft <=3 then
			inst.des_idle_anim = "idle_stone_low"
		end
	end
	inst.AnimState:PlayAnimation(inst.des_idle_anim)
end
	
function SetUpBurnt(inst)
	inst.state = "BURNT"
	inst:RemoveTag("well_rack")
	inst:AddTag("well_burnt")
	inst:RemoveTag("well_empty")
	inst.des_idle_anim = "idle_burnt"
	inst.des_work_anim = "idle_burnt"		
	inst.AnimState:PlayAnimation(inst.des_idle_anim)
	
	inst.components.container:Close()
	inst.components.container.canbeopened = false
	
	if inst.components.burnable then
		inst:RemoveComponent("burnable")
	end
	
    inst:RemoveComponent("workable")	
    inst:AddComponent("workable")
	inst.components.workable:SetWorkAction(ACTIONS.HAMMER)
	inst.components.workable:SetWorkLeft(2)
	inst.components.workable:SetOnFinishCallback(onhammeredburnt)
	inst.components.workable:SetOnWorkCallback(onhit)	
end



local function OnSave(inst, data)
	data.state = inst.state
	data.water_poison = inst.water_poison
	data.works_left = inst.components.workable.workleft or 11
end

local function OnLoad(inst, data)
	if data and data.state then
		inst.state = data.state
		inst.water_poison = data.water_poison
		inst.daysleft = data.daysleft or 2
		if inst.state == "GENERIC" then
			SetUpEmpty(inst)
		elseif inst.state == "BURNT" then
			SetUpBurnt(inst)
		else
			SetUpRack(inst)
		end
		inst.components.workable.workleft = data.works_left
		FixBrokenAnim(inst)
	end
end

local function fn()
    local inst = CreateEntity()
    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()
    inst.entity:AddMiniMapEntity()
    inst.entity:AddNetwork()
	
	-----inst.MiniMapEntity:SetIcon("waterwell.tex")

    MakeObstaclePhysics(inst, 1.1)

    inst:AddTag("structure")
	
	local minimap = inst.entity:AddMiniMapEntity()
	minimap:SetIcon( "des_water_well.tex" )

    inst.AnimState:SetBank("des_stone_well")
    inst.AnimState:SetBuild("des_stone_well")
    inst.AnimState:PlayAnimation("idle_stone", true)
	local s = 0.95
	inst.Transform:SetScale(s, s, s)


    if not TheWorld.ismastersim then
        return inst
    end


    inst:AddComponent("inspectable")
    inst.components.inspectable.getstatus = GetStatus

    inst:AddComponent("workable")
	inst.components.workable:SetWorkAction(ACTIONS.MINE)
	inst.components.workable:SetWorkLeft(11)
	inst.components.workable:SetOnFinishCallback(onhammered)
	inst.components.workable:SetOnWorkCallback(onhit)
	
	--inst:AddComponent("lootdropper")

	--
	inst:AddComponent("container")

    inst.components.container:WidgetSetup("des_water_well")--]]
	

	--inst:AddComponent("container")
--	containers.widgetsetup = mywidgetsetup        
	--inst.components.container:WidgetSetup("wool_sack")	
	--containers.widgetsetup = prev_widgetsetup
	
	
    inst.components.container.onopenfn = onopen
    inst.components.container.onclosefn = onclose
	inst:ListenForEvent("itemget", ongetitem)
    inst:ListenForEvent("itemlose", onloseitem)
	
	
	inst:ListenForEvent("onbuilt", onbuilt)
	inst.components.inspectable.getstatus = inspect_stat

	inst:AddComponent("des_easy_code")

	
	--inst.status = "" --- BURNT --- FRAME
	inst.state = "GENERIC"
	
	inst.SetUpRack = SetUpRack
	SetUpEmpty(inst)

	
	inst.OnSave = OnSave
	inst.OnLoad = OnLoad	
	
	--------inst:WatchWorldState("issnowcovered", onsnowcovered)

    return inst
end

return Prefab( "common/des_water_well", fn, assets, prefabs)