-- Source modified from prefabs/icebox.lua

require "prefabutil"

local assets =
{
	Asset("ANIM", "anim/water_capasitor.zip"),
	Asset("ANIM", "anim/waterdestcoal.zip"),
	Asset("ANIM", "anim/water_dest_metal.zip"),
	
    Asset("SOUND", "sound/common.fsb"),
	
	
	------traps
	Asset("ATLAS", "images/inventoryimages/watertrap_grass.xml"),
	Asset("IMAGE", "images/inventoryimages/watertrap_grass.tex"),

	Asset("ATLAS", "images/inventoryimages/watertrap_silk.xml"),
	Asset("IMAGE", "images/inventoryimages/watertrap_silk.tex"),
	
	Asset("ATLAS", "images/inventoryimages/watertrap_gem.xml"),
	Asset("IMAGE", "images/inventoryimages/watertrap_gem.tex"),
	
	
	-----dests
	Asset("ATLAS", "images/inventoryimages/watertrap_dest.xml"),
	Asset("IMAGE", "images/inventoryimages/watertrap_dest.tex"),
	
	Asset("ATLAS", "images/inventoryimages/watertrap_dest2.xml"),
	Asset("IMAGE", "images/inventoryimages/watertrap_dest2.tex"),
	
	
	---UI
	
	Asset("ANIM", "anim/des_ui_wcatcher1x2.zip"),
	Asset("ANIM", "anim/des_ui_wcatcher1x3.zip"),
}

local function onhammered(inst, worker)
    inst.components.lootdropper:DropLoot()
    inst.components.container:DropEverything()
    local fx = SpawnPrefab("collapse_small")
    fx.Transform:SetPosition(inst.Transform:GetWorldPosition())
    fx:SetMaterial("wood")
    inst:Remove()
end

local function onhit(inst, worker)
   -- inst.AnimState:PlayAnimation("hit")
    inst.components.container:DropEverything()
    inst.components.container:Close()
end

local function onbuilt(inst)
  --  inst.AnimState:PlayAnimation("place")
  --  inst.AnimState:PushAnimation("closed", false)
  --  inst.SoundEmitter:PlaySound("dontstarve/common/icebox_craft")
end



local function SetOnPickupFn(inst)
    inst.components.finiteuses:Use(2)
    inst.components.cwater:DoDelta(-inst.components.cwater.max)
	inst.components.container.canbeopened = false
end
local function SetOnDropFn(inst)
			--t("68 SetOnDropFn INVENTORYITEM")

	inst.components.container.canbeopened = true
    inst.components.cwater:DoDelta(-inst.components.cwater.max)
		inst:DoTaskInTime(0.1, function()
		
		if inst.components.inventoryitem then
			--nt("73 REMOVE COMPONENT INVENTORYITEM")
			inst.components.inventoryitem.canbepickedup = nil
			--inst:RemoveComponent("inventoryitem")
		end	
				

			-- end
		end)
end


local function FakeDrop(inst)
--	if true==true then
--	return
	--end
	
	local found = inst.components.container:FindItem(function(find_fakedrop) return find_fakedrop==inst.des_fakedrop end)
	if found then
		return
	elseif not found and inst.des_fakedrop then
		inst.des_fakedrop:Remove()
	end
	
	
	
	
	if not found then
		inst.des_fakedrop = SpawnPrefab("des_waterdrop_fake")
		
		inst.des_fakedrop.original_owner = inst
		print("SPAWNED FAKE DROP")
		inst.components.container:GiveItem(inst.des_fakedrop, inst.fakedrop_slot)
		
		if inst:HasTag("water_dest_new") then
			inst.des_fakedrop:RemoveComponent("des_drink")
		end
		
		--inst.des_fakedrop.components.inventoryitem.canbepickedup = false
	--	inst.des_fakedrop.components.inventoryitem.canbepickedupalive = false --added for minion pickup behaviour, e.g. eyeplants
	--	inst.components.inventoryitem.cangoincontainer = false
	end



end

local function SpawnPlants(inst, plantname)
	FakeDrop(inst)

	if inst.decor then
		for i,item in ipairs(inst.decor) do
			item:Remove()
		end
	end
	inst.decor = {}

	local plant_offsets = {}

	for i=1,math.random(1,1) do
		table.insert(plant_offsets, {0,0,0})
	end

	for k, offset in pairs( plant_offsets ) do
		local plant = SpawnPrefab( plantname )
		plant.entity:SetParent( inst.entity )
		plant.Transform:SetPosition( offset[1], offset[2], offset[3] )
		table.insert( inst.decor, plant )
	end
end


local function onopen(inst)
	FakeDrop(inst)
	inst:AddTag("des_watercatcher_update_fakedrop")
	inst.components.cwater:GetDiscCatcher()
end

local function onclose(inst)
	FakeDrop(inst)
	inst:RemoveTag("des_watercatcher_update_fakedrop")

end


local function ongetitem(inst)
	inst:DoTaskInTime(0.1, function()
		FakeDrop(inst)
	end)
	
	--local dont_add_flag = nil
	
	local player = nil
	if TheSim:GetGameID() == "DST" then
	    for _, playerf in pairs(AllPlayers) do
	        if (not playerf:HasTag("playerghost")) and (not playerf:HasTag("ghost")) and inst:GetDistanceSqToInst(playerf)< 3*3 then
				player = playerf
            end
	    end
	end		
--	if inst:HasTag("des_transfuse_to_2nd_slot") then 
	--if inst:HasTag("water_trap_or_dest") then
		local bottle1 = inst.components.container:GetItemInSlot(1)
		local bottle2 = inst.components.container:GetItemInSlot(2)
		local fakedrop_slot_plus1 = inst.components.container:GetItemInSlot(inst.fakedrop_slot+1)
		if fakedrop_slot_plus1 and (fakedrop_slot_plus1:HasTag("des_drop_fromcatcher") or (fakedrop_slot_plus1.components.cwater.special_drink ~= ""))
		then 
			
			inst.components.container:DropItem(fakedrop_slot_plus1)
			if inst.components.container:IsOpen() == true then
				inst.components.container:Close()
			end
			if player and fakedrop_slot_plus1.components.cwater.special_drink ~= "" then
				player.components.talker:Say("I don't want to spoil my brew.")
			elseif player then
				player.components.talker:Say("It doesn't fit here.")
			end
		end
		
		if bottle2 and bottle2:HasTag("des_fillable_on_catcher") then
			inst.components.cwater:Transfuse(bottle2, inst)
			if player and inst.components.container:IsOpen() == false then
				inst.components.container:DropItem(bottle2)
				player.sg:GoToState("give")
				player.components.inventory:GiveItem(bottle2, nil, nil, true)
			end
		elseif bottle1 and bottle1:HasTag("des_fillable_on_catcher") and inst:HasTag("water_dest_new") then
			bottle1.components.cwater:Transfuse(inst, bottle1)
			if player and inst.components.container:IsOpen() == false and (not player) then
				inst.components.container:DropItem(bottle1)
				player.sg:GoToState("give")
				player.components.inventory:GiveItem(bottle2, nil, nil, true)				
			end
		elseif inst:HasTag("water_dest_new") then
		end
		
	--if not dont_add_flag then
		inst.components.cwater:AddBottle(inst)
	--end
---end
end

local function onloseitem(inst)
	if inst.components.cwater:HasBottle() then
		inst.components.cwater:RemoveBottle()
		inst.components.cwater:AddBottle()
	end
	FakeDrop(inst)
end


local function OnFinished(inst)
    inst:Remove()
end

local function OnFinishedDest(inst)
	SpawnPrefab("twigs").Transform:SetPosition(inst.Transform:GetWorldPosition())
	SpawnPrefab("twigs").Transform:SetPosition(inst.Transform:GetWorldPosition())
	SpawnPrefab("cutgrass").Transform:SetPosition(inst.Transform:GetWorldPosition())
	inst:Remove()
end




--------------------------------------------------------------------------


--------------------------------------------------------------------------
--------------------------------------------------------------------------



local function defaultfn(typeof)
    local inst = CreateEntity()
    
    inst.entity:AddTransform()
    local anim = inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()
    inst.entity:AddMiniMapEntity()
    inst.entity:AddNetwork()

    inst.MiniMapEntity:SetIcon( "birdtrap.png" )
    
    anim:SetBank("water_capasitor")
    anim:SetBuild("water_capasitor")
	-----local  = "gem"
	anim:PlayAnimation(typeof)
	
	inst:AddTag("water_gain_overtime")
	inst:AddTag("water_catcher_new")
	inst:AddTag("water_trap_or_dest")

	
	if	typeof=="grass" then
		inst:AddTag("des_transfuse_to_2nd_slot")
		inst.Transform:SetScale(1.6, 1.6, 1.6)
		inst:AddTag("des_instant_transfuse")
	elseif typeof=="silk" then
		inst:AddTag("des_transfuse_to_2nd_slot")
		inst.Transform:SetScale(1.8, 1.8, 1.8)
		inst:AddTag("des_instant_transfuse")
	elseif typeof=="gem" then
		inst:AddTag("des_transfuse_to_2nd_slot")
		inst:AddTag("des_instant_transfuse")
		inst.Transform:SetScale(1.7, 1.7, 1.7)
	elseif typeof =="dest" then
		inst:AddTag("des_slow_transfuse")
		inst:AddTag("water_dest_new")
		inst:AddTag("water_dest_coal")
		inst:RemoveTag("water_catcher_new")
		inst:RemoveTag("water_share_overtime")
		inst:RemoveTag("water_gain_overtime")
		
		inst.Transform:SetScale(1.7, 1.7, 1.7)
		anim:SetBank("waterdestcoal")
		anim:SetBuild("waterdestcoal")
		anim:PlayAnimation("idle")
	elseif typeof =="dest2" then
		inst:AddTag("des_slow_transfuse")
		inst:AddTag("water_dest_new")
		inst:AddTag("water_dest_metal")
		inst:RemoveTag("water_catcher_new")
		inst:RemoveTag("water_share_overtime")
		inst:RemoveTag("water_gain_overtime")
		
		local scale = 0.9
		inst.Transform:SetScale(scale, scale, scale)
		anim:SetBank("water_dest_metal")
		anim:SetBuild("water_dest_metal")
		anim:PlayAnimation("idle_empty")
	end
	
	inst.no_wet_prefix = true
	
	
    inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end
	
	inst:AddComponent("cwater")

	inst:AddComponent("inventoryitem")
    inst.components.inventoryitem.ondropfn = SetOnDropFn
    inst.components.inventoryitem.onpickupfn = SetOnPickupFn
	inst.components.inventoryitem.imagename = "watertrap_"..typeof
    inst.components.inventoryitem.atlasname = "images/inventoryimages/watertrap_"..typeof..".xml"
    
	
	inst:AddComponent("finiteuses")
    inst.components.finiteuses:SetOnFinished(OnFinished)

	
	
    inst:AddComponent("inspectable")
	inst.fakedrop_slot = 1
	
	
	
	
	-------
	inst:AddComponent("container")
    inst.components.container:WidgetSetup("watercatcher_grass")
	inst.widgetsetup = "des_water_well"
	
    inst.components.container.onopenfn = onopen
    inst.components.container.onclosefn = onclose
	inst:ListenForEvent("itemget", ongetitem)
    inst:ListenForEvent("itemlose", onloseitem)
	
	
	
    inst:AddComponent("lootdropper")
    inst:AddComponent("workable")
    inst.components.workable:SetWorkAction(ACTIONS.HAMMER)
    inst.components.workable:SetWorkLeft(2)
    inst.components.workable:SetOnFinishCallback(onhammered)
    inst.components.workable:SetOnWorkCallback(onhit) 
    

	---
	if	typeof=="grass" then
		inst.components.cwater:SetMax(TUNING.BOTTLE_WOOD_WATER*0.75)
		inst.components.cwater:DoDelta(-TUNING.BOTTLE_WOOD_WATER*0.75)
		inst.components.cwater.watergainspeed = TUNING.WATERTRAP_GAIN_SPEED_GRASS
		inst.components.finiteuses:SetMaxUses(450)
		inst.components.finiteuses:SetUses(450)
	elseif typeof=="silk" then
		inst.components.cwater:SetMax(TUNING.BOTTLE_WOOD_WATER)
		inst.components.cwater:DoDelta(-TUNING.BOTTLE_WOOD_WATER)
		inst.components.cwater.watergainspeed = TUNING.WATERTRAP_GAIN_SPEED_SILK
		inst.components.finiteuses:SetMaxUses(600)
		inst.components.finiteuses:SetUses(600)
	elseif typeof=="gem" then
		inst.components.cwater:SetMax(TUNING.BOTTLE_GOLD_WATER)
		inst.components.cwater:DoDelta(-TUNING.BOTTLE_GOLD_WATER)
		inst.components.cwater.watergainspeed = TUNING.WATERTRAP_GAIN_SPEED_GEM
		inst.components.finiteuses:SetMaxUses(900)
		inst.components.finiteuses:SetUses(900)
	--	inst.Transform:SetScale(1.2, 1.2, 1.2)
	elseif typeof =="dest" then
		inst.components.cwater:SetMax(TUNING.DES_DEST_FILTER_SIZE)
		inst.components.cwater:DoDelta(-TUNING.DES_DEST_FILTER_SIZE)
		inst.components.cwater.watergainspeed = 0
		inst.components.cwater.destspeed = 1.75*TUNING.THIRST_DIFFILCULTY_GAIN_SPEED_MULT
		inst.components.cwater.cleanspeed = 1.75*TUNING.THIRST_DIFFILCULTY_GAIN_SPEED_MULT
		
		inst.components.finiteuses:SetMaxUses(900)
		inst.components.finiteuses:SetUses(900)
		inst.components.finiteuses:SetOnFinished(OnFinishedDest)
		
		
		inst.components.container:WidgetSetup("des_waterdist")
		inst.widgetsetup = "des_waterdist"
		
		inst.fakedrop_slot = 2


		anim:SetBank("waterdestcoal")
		anim:SetBuild("waterdestcoal")
		anim:PlayAnimation("idle")
		
	elseif typeof =="dest2" then
		inst.components.cwater:SetMax(TUNING.DES_DEST_METAL_SIZE)
		inst.components.cwater:DoDelta(-TUNING.DES_DEST_METAL_SIZE)
		inst.components.cwater.watergainspeed = 0
		inst.components.cwater.destspeed = 10*TUNING.THIRST_DIFFILCULTY_GAIN_SPEED_MULT
		inst.components.cwater.cleanspeed = 10*TUNING.THIRST_DIFFILCULTY_GAIN_SPEED_MULT
	
		inst.components.finiteuses:SetMaxUses(1200)
		inst.components.finiteuses:SetUses(1200)
		inst.components.finiteuses:SetOnFinished(OnFinishedDest)

		inst.components.container:WidgetSetup("des_waterdist")
		inst.widgetsetup = "des_waterdist"

		
		inst.fakedrop_slot = 2
		


		
	end


		inst:DoTaskInTime(0.1, function()
			if not (typeof =="dest" or typeof =="dest2") then SpawnPlants(inst, "watertrapsign") end

			if inst.components.inventoryitem and not inst.components.inventoryitem.owner then
				inst.components.container.canbeopened = true
				inst.components.inventoryitem.canbepickedup = nil
				
				
				if inst.components.inventoryitem then
							--int("426 REMOVE COMPONENT INVENTORYITEM")

					--inst:RemoveComponent("inventoryitem")
				end	
			else
				inst.components.container.canbeopened = false
			
			end
			
		end)
		
		
		inst:DoPeriodicTask(5, function()
			if not (typeof =="dest" or typeof =="dest2") then SpawnPlants(inst, "watertrapsign") end

			if inst.components.inventoryitem and not inst.components.inventoryitem.owner then
				inst.components.container.canbeopened = true
				inst.components.inventoryitem.canbepickedup = nil
				if inst.components.inventoryitem then
							---nt("426 REMOVE COMPONENT INVENTORYITEM")

					--inst:RemoveComponent("inventoryitem")
				end	
			else
				inst.components.container.canbeopened = false
			
			end
			
		end)
	
	
    return inst
end

return Prefab("common/inventory/watercatcher_grass", function() return defaultfn("grass") end , assets),
Prefab("common/inventory/watercatcher_silk", function() return defaultfn("silk") end , assets),
Prefab("common/inventory/watercatcher_gem", function() return defaultfn("gem") end , assets),
Prefab("common/inventory/waterdestcoal", function() return defaultfn("dest") end , assets),
Prefab("common/inventory/waterdestmetal", function() return defaultfn("dest2") end , assets)