local assets =
{
	Asset("ANIM", "anim/hmato.zip"),
	
	Asset("ATLAS", "images/inventoryimages/hmato.xml"),
	Asset("IMAGE", "images/inventoryimages/hmato.tex")
}

local function fn()
	local inst = CreateEntity()

	inst.entity:AddTransform()
	inst.entity:AddAnimState()
	inst.entity:AddNetwork()

    MakeInventoryPhysics(inst)

    inst.AnimState:SetBank("hmato")
    inst.AnimState:SetBuild("hmato")
    inst.AnimState:PlayAnimation("drop")

	inst.Transform:SetScale(2.25, 2.25, 2.25)

	if not TheWorld.ismastersim then
       return inst
    end
	
	inst.entity:SetPristine()


    ---------------------       

    inst:AddComponent("inspectable")

    inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.imagename = "hmato"
	inst.components.inventoryitem.atlasname = "images/inventoryimages/hmato.xml"
    
    inst:AddComponent("perishable")
    inst.components.perishable:SetPerishTime(TUNING.PERISH_MED)
    inst.components.perishable:StartPerishing()
    inst.components.perishable.onperishreplacement = "spoiled_food"
	
    inst:AddComponent("edible")
    inst.components.edible.healthvalue = 0
    inst.components.edible.hungervalue = 5
    inst.components.edible.sanityvalue = 5
    inst.components.edible.foodtype = FOODTYPE.GENERIC  ----TUNING.THIRST_BOTTLE_FOODTYPE


    inst:AddComponent("stackable")

    return inst
end

return Prefab("common/inventory/hmato_item", fn, assets)