-- Source modified from prefabs/icebox.lua

require "prefabutil"

local assets=
{
	Asset("ANIM", "anim/water_capasitor.zip"),
	Asset("ANIM", "anim/waterdestcoal.zip"),
	Asset("ANIM", "anim/water_dest_metal.zip"),
	
    Asset("SOUND", "sound/common.fsb"),

	
	Asset("ATLAS", "images/inventoryimages/watertrap_grass.xml"),
	Asset("ATLAS", "images/inventoryimages/watertrap_silk.xml"),
	Asset("ATLAS", "images/inventoryimages/watertrap_gem.xml"),
	Asset("ATLAS", "images/inventoryimages/watertrap_dest.xml"),
	Asset("ATLAS", "images/inventoryimages/watertrap_dest2.xml"),
}



local function onhammered(inst, worker)
    inst.components.lootdropper:DropLoot()
    inst.components.container:DropEverything()
    local fx = SpawnPrefab("collapse_small")
    fx.Transform:SetPosition(inst.Transform:GetWorldPosition())
    fx:SetMaterial("wood")
    inst:Remove()
end

local function onhit(inst, worker)
   -- inst.AnimState:PlayAnimation("hit")
    inst.components.container:DropEverything()
    inst.components.container:Close()
end

local function onbuilt(inst)
  --  inst.AnimState:PlayAnimation("place")
  --  inst.AnimState:PushAnimation("closed", false)
  --  inst.SoundEmitter:PlaySound("dontstarve/common/icebox_craft")
end



local function SetOnPickupFn(inst)
    inst.components.finiteuses:Use(2)
    inst.components.cwater:DoDelta(-inst.components.cwater.max)
	inst.components.container.canbeopened = false
end
local function SetOnDropFn(inst)
	inst.components.container.canbeopened = true
    inst.components.cwater:DoDelta(-inst.components.cwater.max)
		inst:DoTaskInTime(0.1, function()
			if inst.components.inventoryitem.owner==nil then
				if (inst.typeof =="dest" or inst.typeof =="dest2") or TUNING.MOVETRAPS==false then
					inst.components.inventoryitem.canbepickedup = false
				end
			end
		end)
end


local function FakeDrop(inst)

	local found = inst.components.container:FindItem(function(find_fakedrop) return find_fakedrop==inst.des_fakedrop end)
	if found then
		return
	elseif not found and inst.des_fakedrop then
		inst.des_fakedrop:Remove()
	end
	
	
	
	
	if not found then
		inst.des_fakedrop = SpawnPrefab("des_waterdrop_fake")
		inst.des_fakedrop.original_owner = inst
		print("SPAWNED FAKE DROP")
		inst.components.container:GiveItem(inst.des_fakedrop)
		--inst.des_fakedrop.components.inventoryitem.canbepickedup = false
	--	inst.des_fakedrop.components.inventoryitem.canbepickedupalive = false --added for minion pickup behaviour, e.g. eyeplants
	--	inst.components.inventoryitem.cangoincontainer = false
	end



end

local function SpawnPlants(inst, plantname)
	FakeDrop(inst)

	if inst.decor then
		for i,item in ipairs(inst.decor) do
			item:Remove()
		end
	end
	inst.decor = {}

	local plant_offsets = {}

	for i=1,math.random(1,1) do
		table.insert(plant_offsets, {0,0,0})
	end

	for k, offset in pairs( plant_offsets ) do
		local plant = SpawnPrefab( plantname )
		plant.entity:SetParent( inst.entity )
		plant.Transform:SetPosition( offset[1], offset[2], offset[3] )
		table.insert( inst.decor, plant )
	end
end


local function onopen(inst)
	FakeDrop(inst)

end

local function onclose(inst)
	FakeDrop(inst)
end


local function ongetitem(inst)
	FakeDrop(inst)
	
	if inst:HasTag("des_transfuse_to_2nd_slot") then 
		local bottle = inst.components.container:GetItemInSlot(2)
		if bottle and bottle:HasTag("des_fillable_on_catcher") then
			inst.components.cwater:Transfuse(bottle, inst)
		end
	end
end

local function onloseitem(inst)
	FakeDrop(inst)
end


local function OnFinished(inst)
    inst:Remove()
end

local function OnFinishedDest(inst)
	SpawnPrefab("twigs").Transform:SetPosition(inst.Transform:GetWorldPosition())
	SpawnPrefab("twigs").Transform:SetPosition(inst.Transform:GetWorldPosition())
	SpawnPrefab("cutgrass").Transform:SetPosition(inst.Transform:GetWorldPosition())
	inst:Remove()
end



local function defaultfn(typeof)
    local inst = CreateEntity()
    
    inst.entity:AddTransform()
    local anim = inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()
    inst.entity:AddMiniMapEntity()
    inst.entity:AddNetwork()

    inst.MiniMapEntity:SetIcon( "birdtrap.png" )
    
    anim:SetBank("water_capasitor")
    anim:SetBuild("water_capasitor")
	-----local  = "gem"
	anim:PlayAnimation(typeof)
	
	inst:AddTag("water_gain_overtime")
	inst:AddTag("water_catcher_new")
	
	if	typeof=="grass" then
		inst:AddTag("des_transfuse_to_2nd_slot")
	elseif typeof=="silk" then
		inst:AddTag("des_transfuse_to_2nd_slot")
		inst.Transform:SetScale(1.8, 1.8, 1.8)
	elseif typeof=="gem" then
		inst:AddTag("des_transfuse_to_2nd_slot")
		inst.Transform:SetScale(1.6, 1.6, 1.6)
	elseif typeof =="dest" then
		inst:RemoveTag("water_gain_rain")
		inst:RemoveTag("water_sourse")
		inst:RemoveTag("water_share_overtime")
		inst:RemoveTag("water_gain_overtime")
		inst:AddTag("destwatercoal")
		inst.Transform:SetScale(1.7, 1.7, 1.7)

		anim:SetBank("waterdestcoal")
		anim:SetBuild("waterdestcoal")
		anim:PlayAnimation("idle")
		
	elseif typeof =="dest2" then
		inst:AddTag("water_dest_metal")
		inst:RemoveTag("water_gain_rain")
		inst:RemoveTag("water_sourse")
		inst:RemoveTag("water_share_overtime")
		inst:RemoveTag("water_gain_overtime")
		local scale = 0.9
		inst.Transform:SetScale(scale, scale, scale)
		anim:SetBank("water_dest_metal")
		anim:SetBuild("water_dest_metal")
		anim:PlayAnimation("idle_empty")
	end
	
	inst.no_wet_prefix = true
	
	
	
  --  inst:AddTag("fridge")
   -- inst:AddTag("structure")


  ----  inst.SoundEmitter:PlaySound("dontstarve/common/ice_box_LP", "idlesound")

  ----  MakeSnowCoveredPristine(inst)

    inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end
    
	
	inst:AddComponent("cwater")
    inst:AddComponent("inspectable")

    inst:AddComponent("inventoryitem")
    inst.components.inventoryitem:SetOnDroppedFn(SetOnDropFn)
    inst.components.inventoryitem:SetOnPickupFn(SetOnPickupFn)
	inst.components.inventoryitem.atlasname = "images/inventoryimages/watertrap_"..typeof..".xml"

	
	
	inst.paramname = "des_water_trap_param"
	
	
    inst:AddComponent("finiteuses")
    inst.components.finiteuses:SetOnFinished(OnFinished)

	
	
	
	
    inst:AddComponent("container")
    inst.components.container:WidgetSetup("watertrap_grass")
    inst.components.container.onopenfn = onopen
    inst.components.container.onclosefn = onclose
    
	
	inst:ListenForEvent("itemget", ongetitem)
    inst:ListenForEvent("itemlose", onloseitem)
	
	
	
	
    inst:AddComponent("lootdropper")
    inst:AddComponent("workable")
    inst.components.workable:SetWorkAction(ACTIONS.HAMMER)
    inst.components.workable:SetWorkLeft(2)
    inst.components.workable:SetOnFinishCallback(onhammered)
    inst.components.workable:SetOnWorkCallback(onhit) 
    
  --  inst:ListenForEvent("onbuilt", onbuilt)
   -- MakeSnowCovered(inst)   

   
   	if	typeof=="grass" then
		inst.components.cwater:SetMax(TUNING.BOTTLE_WOOD_WATER*0.75)
		inst.components.cwater:DoDelta(-TUNING.BOTTLE_WOOD_WATER*0.75)
		inst.components.cwater.watergainspeed = TUNING.WATERTRAP_GAIN_SPEED_GRASS
		inst.components.finiteuses:SetMaxUses(450)
		inst.components.finiteuses:SetUses(450)
	elseif typeof=="silk" then
		inst.components.cwater:SetMax(TUNING.BOTTLE_WOOD_WATER)
		inst.components.cwater:DoDelta(-TUNING.BOTTLE_WOOD_WATER)
		inst.components.cwater.watergainspeed = TUNING.WATERTRAP_GAIN_SPEED_SILK
		inst.components.finiteuses:SetMaxUses(600)
		inst.components.finiteuses:SetUses(600)
	elseif typeof=="gem" then
		inst.components.cwater:SetMax(TUNING.BOTTLE_GOLD_WATER)
		inst.components.cwater:DoDelta(-TUNING.BOTTLE_GOLD_WATER)
		inst.components.cwater.watergainspeed = TUNING.WATERTRAP_GAIN_SPEED_GEM
		inst.components.finiteuses:SetMaxUses(900)
		inst.components.finiteuses:SetUses(900)
	--	inst.Transform:SetScale(1.2, 1.2, 1.2)
	elseif typeof =="dest" then
		inst.components.cwater:SetMax(TUNING.BOTTLE_GOLD_WATER)
		inst.components.cwater:DoDelta(-TUNING.BOTTLE_GOLD_WATER)
		inst.components.cwater.watergainspeed = 0
		inst.components.cwater.destspeed = 1.75*TUNING.THIRST_DIFFILCULTY_GAIN_SPEED_MULT
		inst.components.cwater.cleanspeed = 1.75*TUNING.THIRST_DIFFILCULTY_GAIN_SPEED_MULT
		
		inst.components.finiteuses:SetMaxUses(900)
		inst.components.finiteuses:SetUses(900)
		inst.components.finiteuses:SetOnFinished(OnFinishedDest)
		inst.components.trader.onaccept = DestGotItem

		---inst.Transform:SetScale(1.7, 1.7, 1.7)

		anim:SetBank("waterdestcoal")
		anim:SetBuild("waterdestcoal")
		anim:PlayAnimation("idle")
		
	elseif typeof =="dest2" then
		inst.components.cwater:SetMax(TUNING.BOTTLE_GOLD_WATER)
		inst.components.cwater:DoDelta(-TUNING.BOTTLE_GOLD_WATER)
		inst.components.cwater.watergainspeed = 0
		inst.components.cwater.destspeed = 0
		
		inst.components.finiteuses:SetMaxUses(1200)
		inst.components.finiteuses:SetUses(1200)
		inst.components.finiteuses:SetOnFinished(OnFinishedDest)
		inst.components.trader.onaccept = DestMetalGotItem
		
		--local scale = 0.7
		--inst.Transform:SetScale(scale, scale, scale)
	end


		inst:DoTaskInTime(0.1, function()
			if not (typeof =="dest" or typeof =="dest2") then SpawnPlants(inst, "watertrapsign") end

			if inst.components.inventoryitem.owner==nil then
				inst.components.container.canbeopened = true
				if (typeof =="dest" or typeof =="dest2") or TUNING.MOVETRAPS==false then
					inst.components.inventoryitem.canbepickedup = false
				end
			end
			
		end)
		

   
   
   
 --   AddHauntableDropItemOrWork(inst)

    return inst
end


return Prefab("common/inventory/watertrap_grass", function() return defaultfn("grass") end , assets),
Prefab("common/inventory/watertrap_silk", function() return defaultfn("silk") end , assets),
Prefab("common/inventory/watertrap_gem", function() return defaultfn("gem") end , assets),
Prefab("common/inventory/waterdestcoal", function() return defaultfn("dest") end , assets),
Prefab("common/inventory/waterdestmetal", function() return defaultfn("dest2") end , assets)