local assets=
{
	Asset("ANIM", "anim/water_capasitor.zip"),
	Asset("ANIM", "anim/waterdestcoal.zip"),
	Asset("ANIM", "anim/water_dest_metal.zip"),
	
    Asset("SOUND", "sound/common.fsb"),

	
	Asset("ATLAS", "images/inventoryimages/watertrap_grass.xml"),
	Asset("ATLAS", "images/inventoryimages/watertrap_silk.xml"),
	Asset("ATLAS", "images/inventoryimages/watertrap_gem.xml"),
	Asset("ATLAS", "images/inventoryimages/watertrap_dest.xml"),
	Asset("ATLAS", "images/inventoryimages/watertrap_dest2.xml"),
}

local prefabs = {
	-- everything it can "produce" and might need symbol swaps from
	"crow",
	"robin",
	"robin_winter",
}


local sounds = 
{
	close = "dontstarve/common/birdtrap_close",
	rustle = "dontstarve/common/birdtrap_rustle",
}

local function OnFinished(inst)
    inst:Remove()
end

local function OnFinishedDest(inst)
	SpawnPrefab("twigs").Transform:SetPosition(inst.Transform:GetWorldPosition())
	SpawnPrefab("twigs").Transform:SetPosition(inst.Transform:GetWorldPosition())
	SpawnPrefab("cutgrass").Transform:SetPosition(inst.Transform:GetWorldPosition())
	inst:Remove()
end



local function OnHarvested(inst)
    if inst.components.finiteuses then
    end
end

local function SetTrappedSymbols(inst, build)
    inst.trappedbuild = build
    inst.AnimState:OverrideSymbol("trapped", build, "trapped")
end

local function OnSpring(inst, target, bait)
    if target.trappedbuild then
        SetTrappedSymbols(inst, target.trappedbuild)
    end
end


local function SpawnPlants(inst, plantname)

	if inst.decor then
		for i,item in ipairs(inst.decor) do
			item:Remove()
		end
	end
	inst.decor = {}

	local plant_offsets = {}

	for i=1,math.random(1,1) do
		table.insert(plant_offsets, {0,0,0})
	end

	for k, offset in pairs( plant_offsets ) do
		local plant = SpawnPrefab( plantname )
		plant.entity:SetParent( inst.entity )
		plant.Transform:SetPosition( offset[1], offset[2], offset[3] )
		table.insert( inst.decor, plant )
	end
end



local function SetOnPickupFn(inst)
    inst.components.finiteuses:Use(2)
    inst.components.cwater:DoDelta(-inst.components.cwater.max)
	inst.components.container.canbeopened = false
end
local function SetOnDropFn(inst)
	inst.components.container.canbeopened = true
    inst.components.cwater:DoDelta(-inst.components.cwater.max)
		inst:DoTaskInTime(0.1, function()
			if inst.components.inventoryitem.owner==nil then
				if (inst.typeof =="dest" or inst.typeof =="dest2") or TUNING.MOVETRAPS==false then
					inst.components.inventoryitem.canbepickedup = false
				end
			end
		end)
end


local function OnActivate(inst)
----print("attemp to drink")
		inst.components.activatable.inactive = true
		
	if inst.components.cwater.current>5 then
		if GetPlayer().components.moisture then
			GetPlayer().components.moisture:DoDelta(math.random(5,10))
		end
	end
	
	if inst.components.cwater.current> TUNING.POND_WATER_RESTORE then	
        GetPlayer().components.thirst:DoDelta(TUNING.POND_WATER_RESTORE)
	elseif inst.components.cwater.current>5 then
        GetPlayer().components.thirst:DoDelta(inst.components.cwater.current)
	else
		GetPlayer().components.talker:Say("This water trap is empty!")
	end
        inst.components.cwater:DoDelta(-TUNING.POND_WATER_RESTORE)
		
		GetPlayer().components.thirst.timetosay = 7
		GetPlayer().components.temperature.current = GetPlayer().components.temperature.current-3


	inst:DoTaskInTime(0.1, function()
		if inst.components.inventoryitem.owner==nil then
			if (inst.typeof =="dest" or inst.typeof =="dest2") or TUNING.MOVETRAPS==false then
				inst.components.inventoryitem.canbepickedup = false
			end
		end
	end)
		
end


local function GetVerb(inst)
	return STRINGS.DRINKFROM
end










local function TrapTestItem(inst, item)
    if item:HasTag("bottle") and not (inst.components.inventoryitem and inst.components.inventoryitem.owner) then
	
		return true
    end
end

local function TrapGotItem(trap, giver, item)
	local newbottle = item.components.cwater:givenewbottle(item, trap, item.components.cwater.current, item.components.finiteuses.current, item.components.cwater.salt, true)
	
	if trap.components.cwater.addedbottle then
		giver.components.inventory:GiveItem(trap.components.cwater.addedbottle, 5, nil, true)
		trap.components.cwater:RemoveBottle()
	end
	trap.components.cwater:AddBottle(newbottle)
	newbottle.components.cwater:DroppedBottle(newbottle, true)

end


local function DestGotItem(trap, giver, item)
	--self:
	trap.components.finiteuses:Use(10)
	local newbottle = item.components.cwater:givenewbottle(item, trap, 0, item.components.finiteuses.current, 0, true)
	trap.components.cwater:DoDelta(item.components.cwater.current)
	print(trap.components.cwater.current)
	print("DestGotItem Start Destilatting...")
	giver.components.talker:Say("It needs time to take salt away...")

	if trap.components.cwater.addedbottle then
		giver.components.inventory:GiveItem(trap.components.cwater.addedbottle, 5, nil, true)
		trap.components.cwater:RemoveBottle()
	end
	trap.components.cwater:AddBottle(newbottle)
	
end


local function DestMetalGotItem(trap, giver, item)
	local newbottle = item.components.cwater:givenewbottle(item, giver, item.components.cwater.current, item.components.finiteuses.current, item.components.cwater.salt, nil, item.components.cwater.filled, item.components.cwater.bad)

	if trap.components.cwater:GetPercent()>0 and newbottle.components.cwater:GetPercent()<1 then
	
		print("DestMetalGotItem Give water...")
		trap.components.cwater:ShareWater(newbottle, trap)
		giver.components.talker:Say("Into my bottle.")
		trap.components.cwater:GetDiscDest()
		if trap.components.cwater:GetPercent()<0.001 then
			trap.AnimState:PlayAnimation("idle_empty",true)
		end
	elseif trap.components.cwater:GetPercent()<1 and newbottle.components.cwater:GetPercent()>0 then 
		trap.AnimState:PlayAnimation("work_fast")
		trap.components.finiteuses:Use(20)
	--	trap.components.cwater:DoDelta(item.components.cwater.current)
		
		trap.components.cwater:ShareWater(trap, newbottle)

		
		print(trap.components.cwater.current)
		print("DestMetalGotItem Start Destilatting...")
		giver.components.talker:Say("Into distillator.")
		trap.components.cwater:GetDiscDest()
		trap:DoTaskInTime(1, function()
			trap.AnimState:PlayAnimation("idle_water",true)
		end)
	end
	
	newbottle.components.cwater:GetDisc()	
	
end

local OnSave = function(inst, data)
--[[
		data.sleeping = true
		--]]
end




local function TrapRefuseItem(inst, item)
--	GetPlayer().components.talker:Say("I cann't put this there.")
end

local function defaultfn(typeof)
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	local anim = inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()
	inst.entity:AddNetwork()
    MakeInventoryPhysics(inst)
    
    inst.entity:AddMiniMapEntity()
    inst.MiniMapEntity:SetIcon( "birdtrap.png" )
    
    anim:SetBank("water_capasitor")
    anim:SetBuild("water_capasitor")
    anim:PlayAnimation(typeof)
    inst.sounds = sounds
	
	
    inst:AddTag("water_gain_overtime")
    inst:AddTag("water_sourse")
    inst:AddTag("water_trap_or_dest")
	inst:AddTag("water_share_overtime")
	inst:AddTag("water_trap_or_dest")
	
	
	
	inst:AddTag("structure")
    inst:AddTag("chest")
	
	
	inst.Transform:SetScale(1.6, 1.6, 1.6)
	
	if	typeof=="grass" then
	elseif typeof=="silk" then
		inst.Transform:SetScale(1.8, 1.8, 1.8)
	elseif typeof=="gem" then
		inst.Transform:SetScale(1.6, 1.6, 1.6)
	elseif typeof =="dest" then
		inst:RemoveTag("water_gain_rain")
		inst:RemoveTag("water_sourse")
		inst:RemoveTag("water_share_overtime")
		inst:RemoveTag("water_gain_overtime")
		inst:AddTag("destwatercoal")
		inst.Transform:SetScale(1.7, 1.7, 1.7)

		anim:SetBank("waterdestcoal")
		anim:SetBuild("waterdestcoal")
		anim:PlayAnimation("idle")
		
	elseif typeof =="dest2" then
		inst:AddTag("water_dest_metal")
		inst:RemoveTag("water_gain_rain")
		inst:RemoveTag("water_sourse")
		inst:RemoveTag("water_share_overtime")
		inst:RemoveTag("water_gain_overtime")
		local scale = 0.9
		inst.Transform:SetScale(scale, scale, scale)
		anim:SetBank("water_dest_metal")
		anim:SetBuild("water_dest_metal")
		anim:PlayAnimation("idle_empty")
	end
	
	inst.no_wet_prefix = true
	
	inst.entity:SetPristine()

    if not TheWorld.ismastersim then
        return inst
    end

	
	inst:AddComponent("cwater")
    inst:AddComponent("inspectable")

    inst:AddComponent("inventoryitem")
    inst.components.inventoryitem:SetOnDroppedFn(SetOnDropFn)
    inst.components.inventoryitem:SetOnPickupFn(SetOnPickupFn)
	inst.components.inventoryitem.atlasname = "images/inventoryimages/watertrap_"..typeof..".xml"

    inst:AddComponent("finiteuses")
    inst.components.finiteuses:SetOnFinished(OnFinished)

	

	inst.AnimState:SetMultColour(0.85,0.85,0.85,1)

	
	inst:AddComponent("container")
    inst.components.container:WidgetSetup("des_water_container")
	inst.components.container.canbeopened = false
	
	
  --  inst.components.container.onopenfn = onopen
  --  inst.components.container.onclosefn = onclose

	
	if	typeof=="grass" then
		inst.components.cwater:SetMax(TUNING.BOTTLE_WOOD_WATER*0.75)
		inst.components.cwater:DoDelta(-TUNING.BOTTLE_WOOD_WATER*0.75)
		inst.components.cwater.watergainspeed = TUNING.WATERTRAP_GAIN_SPEED_GRASS
		inst.components.finiteuses:SetMaxUses(450)
		inst.components.finiteuses:SetUses(450)
	elseif typeof=="silk" then
		inst.components.cwater:SetMax(TUNING.BOTTLE_WOOD_WATER)
		inst.components.cwater:DoDelta(-TUNING.BOTTLE_WOOD_WATER)
		inst.components.cwater.watergainspeed = TUNING.WATERTRAP_GAIN_SPEED_SILK
		inst.components.finiteuses:SetMaxUses(600)
		inst.components.finiteuses:SetUses(600)
	elseif typeof=="gem" then
		inst.components.cwater:SetMax(TUNING.BOTTLE_GOLD_WATER)
		inst.components.cwater:DoDelta(-TUNING.BOTTLE_GOLD_WATER)
		inst.components.cwater.watergainspeed = TUNING.WATERTRAP_GAIN_SPEED_GEM
		inst.components.finiteuses:SetMaxUses(900)
		inst.components.finiteuses:SetUses(900)
		inst.Transform:SetScale(1.2, 1.2, 1.2)
	elseif typeof =="dest" then
		inst.components.cwater:SetMax(TUNING.BOTTLE_GOLD_WATER)
		inst.components.cwater:DoDelta(-TUNING.BOTTLE_GOLD_WATER)
		inst.components.cwater.watergainspeed = 0
		inst.components.cwater.destspeed = 1.75*TUNING.THIRST_DIFFILCULTY_GAIN_SPEED_MULT
		inst.components.cwater.cleanspeed = 1.75*TUNING.THIRST_DIFFILCULTY_GAIN_SPEED_MULT
		
		inst.components.finiteuses:SetMaxUses(900)
		inst.components.finiteuses:SetUses(900)
		inst.components.finiteuses:SetOnFinished(OnFinishedDest)
		inst.components.trader.onaccept = DestGotItem

		inst.Transform:SetScale(1.7, 1.7, 1.7)

		anim:SetBank("waterdestcoal")
		anim:SetBuild("waterdestcoal")
		anim:PlayAnimation("idle")
		
	elseif typeof =="dest2" then
		inst.components.cwater:SetMax(TUNING.BOTTLE_GOLD_WATER)
		inst.components.cwater:DoDelta(-TUNING.BOTTLE_GOLD_WATER)
		inst.components.cwater.watergainspeed = 0
		inst.components.cwater.destspeed = 0
		
		inst.components.finiteuses:SetMaxUses(1200)
		inst.components.finiteuses:SetUses(1200)
		inst.components.finiteuses:SetOnFinished(OnFinishedDest)
		inst.components.trader.onaccept = DestMetalGotItem
		
		local scale = 0.7
		inst.Transform:SetScale(scale, scale, scale)
	end


		inst:DoTaskInTime(0.1, function()
			if inst.components.inventoryitem.owner==nil then
				inst.components.container.canbeopened = true
				if (typeof =="dest" or typeof =="dest2") or TUNING.MOVETRAPS==false then
					inst.components.inventoryitem.canbepickedup = false
				end
			end
			
		end)
		
	if not (typeof =="dest" or typeof =="dest2") then SpawnPlants(inst, "watertrapsign") end
		
    return inst
end

return Prefab("common/inventory/watertrap_grass", function() return defaultfn("grass") end , assets),
Prefab("common/inventory/watertrap_silk", function() return defaultfn("silk") end , assets),
Prefab("common/inventory/watertrap_gem", function() return defaultfn("gem") end , assets),
Prefab("common/inventory/waterdestcoal", function() return defaultfn("dest") end , assets),
Prefab("common/inventory/waterdestmetal", function() return defaultfn("dest2") end , assets)