local Badge = require "widgets/badge"
local UIAnim = require "widgets/uianim"
local Text = require "widgets/text"

return Class(Badge, function(self, owner, bank, build, background_build)
	Badge._ctor(self, background_build, owner)
	-- Start updating the widget.  
    self:StartUpdating()

	self.topperanim = self.underNumber:AddChild(UIAnim())
    self.topperanim:GetAnimState():SetBank("wet")
    self.topperanim:GetAnimState():SetBuild("wet_meter_player")
   ----- self.topperanim:GetAnimState():PlayAnimation(true)
    self.topperanim:SetClickable(true)
	
	
	self:SetOnGainFocus(function()
			self:OnGainFocus()
        end)
	self:SetOnLoseFocus(function()
			self:OnLoseFocus()
        end)

	--self.topperanim:GetAnimState():SetMultColour(0.7,.7,1,0.7)

	
	self.thirstarrow = self.underNumber:AddChild(UIAnim())
	self.thirstarrow:GetAnimState():SetBank("sanity_arrow")
	self.thirstarrow:GetAnimState():SetBuild("sanity_arrow")
	self.thirstarrow:GetAnimState():PlayAnimation("neutral")
	self.thirstarrow:SetClickable(false)
	self.thirstarrow:Hide()
	
    self.bg = self:AddChild(Image("images/thirstmeter_bg.xml", "thirstmeter_bg.tex"))    
    self.fill = self:AddChild(Image("images/thirst_level-20.xml", "thirst_level-20.tex"))
    self.kidney = self:AddChild(Image("images/kidney-0.xml", "kidney-0.tex"))
    self.frame = self:AddChild(Image("images/frame.xml", "frame.tex"))
	
	local fillscale = 0.95
	self.fill:SetScale(fillscale, fillscale, fillscale)
	self.fill:SetPosition(0, -4, 0)
	
	local kidney = 0.95
	self.kidney:SetScale(fillscale, fillscale, fillscale)
	self.kidney:SetPosition(0, -2, 0)

	
	self.num = self:AddChild(Text(BODYTEXTFONT, 33))
    self.num:SetHAlign(ANCHOR_MIDDLE)
    self.num:SetPosition(3.5, 1, 0)
    self.num:Hide()
	
	function self:SetPercent(pct, current, max, penalty)
		current = current or self.tcurrent or 0
		max = max or self.tmax or 200
		pct = pct or (current / max)
		penalty = penalty or self.tpenalty or 0
		Badge.SetPercent(self, pct, max)	
		
		---self.topperanim:GetAnimState():SetPercent("anim", pct)
		local fillImageNumber = math.clamp(math.floor(21 - (21 * pct)),0,21)
		self.fill:SetTexture("images/thirst_level-"..fillImageNumber..".xml", "thirst_level-"..fillImageNumber..".tex")
		self.fill:SetPosition(0, -24*(1-pct), 0)
		
		if pct > 0.75 then
			self.kidney:SetTexture("images/kidney-0.xml", "kidney-0.tex")	
		elseif pct>0.5 then
			self.kidney:SetTexture("images/kidney-1.xml", "kidney-1.tex")	
		elseif pct>0.25 then
			self.kidney:SetTexture("images/kidney-2.xml", "kidney-2.tex")	
		else
			self.kidney:SetTexture("images/kidney-3.xml", "kidney-3.tex")	
		end
	
		self.num:SetString(tostring(math.ceil(pct * max)))
		
		if KnownModIndex:IsModEnabled("workshop-376333686") then
			self.num:Show()
			self.num:SetPosition(2, -40, 0)
			self.num:SetScale(.75, .75, .75)
			if self.show_progress then
				if self.show_remaining then
					self.maxnum:SetString(tostring(math.floor(pct * 200)))
				end
			else
		    		self.maxnum:SetString(tostring(max or 200))
			end
		else
			self.num:SetPosition(3.5, 1, 0)
		end
		
		self.tcurrent = current
		self.tmax = max
		self.tpenalty = penalty
	
	end

	
	function self:OnGainFocus()
		self.num:Show()
	end

	function self:OnLoseFocus()
		self.num:Hide()
	end
	
	
	
	
	function self:OnUpdate(dt)
	
		if self.owner.replica.thirst ~= nil then
			if self.owner.replica.thirst:GetPercent() <= .2 then
				self:StartWarning(1, 145/255, 0.5, 1)
			else
				self:StopWarning()
			end
		end
		
		local up = self.owner ~= nil and
			self.owner.replica.thirst ~= nil and
			self.owner.replica.thirst:GetPercentWithPenalty() < 1

		local anim = up and "arrow_loop_increase" or "neutral"
		if self.arrowdir ~= anim then
			self.arrowdir = anim
			self.thirstarrow:SetPosition(0, -4, 0)
			self.thirstarrow:GetAnimState():PlayAnimation(anim, true)
		end
		
		if self.owner.replica.thirst ~= nil then
			self:SetPercent(
			self.owner.replica.thirst:GetPercent(),
			self.owner.replica.thirst:GetCurrent(),
			self.owner.replica.thirst:Max(),
			self.owner.replica.thirst:GetPenalty())
		end
	end
end)