------------------------------------------------------
-------------------- RECIPES OF CHAIS --------------------
------------------------------------------------------

local seg_time = 30
local total_day_time = seg_time*16
local FIRESUPPRESSOR_MAX_FUEL_TIME = total_day_time*5
local MED_FUEL = seg_time * 1.5 ---- one log

_G = GLOBAL
local Ingredient = GLOBAL.Ingredient
local RECIPETABS = GLOBAL.RECIPETABS
local STRINGS = GLOBAL.STRINGS
local TECH = GLOBAL.TECH

local require = GLOBAL.require
local Ingredient = GLOBAL.Ingredient
local TECH = GLOBAL.TECH
local TUNING = GLOBAL.TUNING
local TheSim = GLOBAL.TheSim
local Vector3 = GLOBAL.Vector3
local ACTIONS = GLOBAL.ACTIONS
local TheNet = GLOBAL.TheNet

-- RECIPES --
local nm,rec,gen, ch = _G.STRINGS.NAMES, _G.STRINGS.RECIPE_DESC, _G.STRINGS.CHARACTERS.GENERIC.DESCRIBE, _G.STRINGS.CHARACTERS

STRINGS.TABS.DES_TAB_CHAI = "茶块"
GLOBAL.RECIPETABS['DES_TAB_CHAI'] = {str = "DES_TAB_CHAI", sort=4, icon = "des_tab_chai.tex", icon_atlas = "images/inventoryimages/des_tab_chai.xml"}


--[[
Activated carbon
Pinecones
Shadow tea
--]]


local des_chai_tabl_green = AddRecipe("des_chai_tabl_green", -- name
	{Ingredient("des_chai_leaf_green", 3,"images/inventoryimages/des_chai_leaf_green.xml", "des_chai_leaf_green.tex")},
	RECIPETABS.DES_TAB_CHAI,
	TECH.NONE,
	nil, -- placer
	nil, -- min_spacing
	nil, -- nounlock
	3, -- numtogive
	nil, -- builder_tag
	"images/inventoryimages/des_chai_tabl_green.xml", -- xml
	"des_chai_tabl_green.tex") -- tex
--des_chai_tabl_green.sortkey = 1

local des_chai_tabl_black = AddRecipe("des_chai_tabl_black", -- name
	{Ingredient("des_chai_leaf_black", 3,"images/inventoryimages/des_chai_leaf_black.xml", "des_chai_leaf_black.tex")},
	RECIPETABS.DES_TAB_CHAI,
	TECH.NONE,
	nil, -- placer
	nil, -- min_spacing
	nil, -- nounlock
	3, -- numtogive
	nil, -- builder_tag
	"images/inventoryimages/des_chai_tabl_black.xml", -- xml
	"des_chai_tabl_black.tex") -- tex
--des_chai_tabl_black.sortkey = 2

local des_chai_tabl_ivan = AddRecipe("des_chai_tabl_ivan", -- name
	{Ingredient("des_chai_leaf_ivan", 3,"images/inventoryimages/des_chai_leaf_ivan.xml", "des_chai_leaf_ivan.tex")},
	RECIPETABS.DES_TAB_CHAI,
	TECH.NONE,
	nil, -- placer
	nil, -- min_spacing
	nil, -- nounlock
	3, -- numtogive
	nil, -- builder_tag
	"images/inventoryimages/des_chai_tabl_ivan.xml", -- xml
	"des_chai_tabl_ivan.tex") -- tex
--des_chai_tabl_ivan.sortkey = 3


local des_chai_tabl_pine = AddRecipe("des_chai_tabl_pine", -- name
	{Ingredient("pinecone", 3)},
	RECIPETABS.DES_TAB_CHAI,
	TECH.NONE,
	nil, -- placer
	nil, -- min_spacing
	nil, -- nounlock
	3, -- numtogive
	nil, -- builder_tag
	"images/inventoryimages/des_chai_tabl_pine.xml", -- xml
	"des_chai_tabl_pine.tex") -- tex
--des_chai_tabl_coffee.sortkey = 4


local des_chai_tabl_coffee = AddRecipe("des_chai_tabl_coffee", -- name
	{Ingredient("des_chai_leaf_black", 3,"images/inventoryimages/des_chai_leaf_black.xml", "des_chai_leaf_black.tex"),
	Ingredient("houndstooth", 2),
	Ingredient("ash", 3)},
	RECIPETABS.DES_TAB_CHAI,
	TECH.NONE,
	nil, -- placer
	nil, -- min_spacing
	nil, -- nounlock
	4, -- numtogive
	nil, -- builder_tag
	"images/inventoryimages/des_chai_tabl_coffee.xml", -- xml
	"des_chai_tabl_coffee.tex") -- tex


local des_chai_tabl_coal = AddRecipe("des_chai_tabl_coal", -- name
	{Ingredient("charcoal", 3),Ingredient("spidergland", 3)},
	RECIPETABS.DES_TAB_CHAI,
	TECH.NONE,
	nil, -- placer
	nil, -- min_spacing
	nil, -- nounlock
	2, -- numtogive
	nil, -- builder_tag
	"images/inventoryimages/des_chai_tabl_coal.xml", -- xml
	"des_chai_tabl_coal.tex") -- tex

local des_chai_tabl_shadow = AddRecipe("des_chai_tabl_shadow", -- name
	{Ingredient("nightmarefuel", 2)},
	RECIPETABS.DES_TAB_CHAI,
	TECH.NONE,
	nil, -- placer
	nil, -- min_spacing
	nil, -- nounlock
	3, -- numtogive
	nil, -- builder_tag
	"images/inventoryimages/des_chai_tabl_shadow.xml", -- xml
	"des_chai_tabl_shadow.tex") -- tex

local des_chai_tabl_stinger = AddRecipe("des_chai_tabl_stinger", -- name
	{Ingredient("stinger", 3)},
	RECIPETABS.DES_TAB_CHAI,
	TECH.NONE,
	nil, -- placer
	nil, -- min_spacing
	nil, -- nounlock
	3, -- numtogive
	nil, -- builder_tag
	"images/inventoryimages/des_chai_tabl_stinger.xml", -- xml
	"des_chai_tabl_stinger.tex") -- tex

local des_chai_tabl_dragonheal = AddRecipe("des_chai_tabl_dragonheal", -- name
	{Ingredient("des_chai_leaf_green", 3,"images/inventoryimages/des_chai_leaf_green.xml", "des_chai_leaf_green.tex"),
	Ingredient("dragonfruit", 1)},
	RECIPETABS.DES_TAB_CHAI,
	TECH.NONE,
	nil, -- placer
	nil, -- min_spacing
	nil, -- nounlock
	4, -- numtogive
	nil, -- builder_tag
	"images/inventoryimages/des_chai_tabl_dragonheal.xml", -- xml
	"des_chai_tabl_dragonheal.tex") -- tex
	
local des_chai_tabl_honeysanity = AddRecipe("des_chai_tabl_honeysanity", -- name
	{Ingredient("des_chai_leaf_black", 3,"images/inventoryimages/des_chai_leaf_black.xml", "des_chai_leaf_black.tex"),
	Ingredient("nightmarefuel", 2),
	Ingredient("honey", 5)},
	RECIPETABS.DES_TAB_CHAI,
	TECH.NONE,
	nil, -- placer
	nil, -- min_spacing
	nil, -- nounlock
	4, -- numtogive
	nil, -- builder_tag
	"images/inventoryimages/des_chai_tabl_honeysanity.xml", -- xml
	"des_chai_tabl_honeysanity.tex") -- tex

	
local des_chai_tabl_glommerhunger = AddRecipe("des_chai_tabl_glommerhunger", -- name
	{Ingredient("des_chai_leaf_ivan", 3,"images/inventoryimages/des_chai_leaf_ivan.xml", "des_chai_leaf_ivan.tex"),
	Ingredient("glommerfuel", 1)},
	RECIPETABS.DES_TAB_CHAI,
	TECH.NONE,
	nil, -- placer
	nil, -- min_spacing
	nil, -- nounlock
	4, -- numtogive
	nil, -- builder_tag
	"images/inventoryimages/des_chai_tabl_glommerhunger.xml", -- xml
	"des_chai_tabl_glommerhunger.tex") -- tex
	
local des_chai_tabl_fishwet = AddRecipe("des_chai_tabl_fishwet", -- name
	{Ingredient("des_chai_leaf_ivan", 3,"images/inventoryimages/des_chai_leaf_ivan.xml", "des_chai_leaf_ivan.tex"),
	Ingredient("fish", 3)},
	RECIPETABS.DES_TAB_CHAI,
	TECH.NONE,
	nil, -- placer
	nil, -- min_spacing
	nil, -- nounlock
	4, -- numtogive
	nil, -- builder_tag
	"images/inventoryimages/des_chai_tabl_fishwet.xml", -- xml
	"des_chai_tabl_fishwet.tex") -- tex


	
	
local keep_recipes_array_unsused =
{
	"tee_s",
	"tea_honey",
	"tee_m",
	"tea_berry",
	"tee_r",
	"tee_r2",
	"tea_carrot",
	"tea_banana",
	"tea_cactus",
	"tee_g",
	
	---
	--"beer_barrle",
	"flour",
	"cup_strang",
	
	---
	"grass_bag",
}


