local require = GLOBAL.require
local STRINGS = GLOBAL.STRINGS
local RECIPETABS = GLOBAL.RECIPETABS
local Ingredient = GLOBAL.Ingredient
local FOODTYPE = GLOBAL.FOODTYPE
local TECH = GLOBAL.TECH
local TUNING = GLOBAL.TUNING
local TheSim = GLOBAL.TheSim
local Vector3 = GLOBAL.Vector3
local ACTIONS = GLOBAL.ACTIONS
local TheNet = GLOBAL.TheNet

----------------------------------------
------------Rename ACTIVATE-------------
----------------------------------------
--[[
STRINGS["ACTIONS"]["EAT"] = {}
STRINGS["ACTIONS"]["EAT"]["DRINK"] = "Drink"
STRINGS["ACTIONS"]["EAT"]["EAT"] = "Eat"

GLOBAL.ACTIONS.EAT.strfn = function(act)
    return act.invobject ~= nil and (act.invobject:HasTag("fili_drink") and "DRINK") or "EAT"
end
--]]

GLOBAL.STRINGS["ACTIONS"]["ACTIVATE"]["DRINK"] = "喝水"

GLOBAL.ACTIONS.ACTIVATE.strfn = function(act)
    if act.target:HasTag("water_sourse") then
        return "DRINK"
    else
        if act.target.GetActivateVerb ~= nil then
            return act.target:GetActivateVerb(act.doer)
        end
    end
end
--]]
----------------------------------------
----------------------------------------
----------------------------------------

AddAction("DES_DRINK", "喝", function(act)

	if act.invobject and act.invobject.components.des_drink then
        return act.invobject.components.des_drink:TeleportAction(act.doer)
    end
end)
	
function SetupBottleDrinkActions(inst, doer, actions)
	table.insert(actions, GLOBAL.ACTIONS.DES_DRINK)
end
AddComponentAction("INVENTORY", "des_drink", SetupBottleDrinkActions)




local State = GLOBAL.State
local TimeEvent = GLOBAL.TimeEvent
local EventHandler = GLOBAL.EventHandler
local FRAMES = GLOBAL.FRAMES
local SpawnPrefab = GLOBAL.SpawnPrefab

local des_waterdrink_state = State({
    name = "des_waterdrink_action",
        tags = { "doing", "playing" },

        onenter = function(inst)
            inst.components.locomotor:Stop()
            inst.AnimState:PlayAnimation("action_uniqueitem_pre")
			inst.AnimState:ClearOverrideSymbol("horn")
		
            inst.AnimState:PushAnimation("horn", false)
			
		
         -------inst.AnimState:OverrideSymbol("horn01", "horn", "horn01")
            --inst.AnimState:Hide("ARM_carry")
            inst.AnimState:Show("ARM_normal")
            inst.components.inventory:ReturnActiveActionItem(inst.bufferedaction ~= nil and inst.bufferedaction.invobject or nil)
        end,

        timeline =
        {
            TimeEvent(21*FRAMES, function(inst)
               ---- inst.SoundEmitter:PlaySound("dontstarve/common/horn_beefalo")
                inst:PerformBufferedAction()
            end),
        },

        events =
        {
            EventHandler("animqueueover", function(inst)
                if inst.AnimState:AnimDone() then
                    inst.sg:GoToState("idle")
                end
            end),
        },

        onexit = function(inst)
            if inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS) then
                inst.AnimState:Show("ARM_carry")
                inst.AnimState:Hide("ARM_normal")
            end
        end,

})

local des_waterdrink_state_client = State({
    name = "des_waterdrink_action",
    tags = { "doing", "busy", "canrotate" },

    onenter = function(inst)
        inst.components.locomotor:Stop()
		inst.AnimState:ClearOverrideSymbol("horn")
		
        inst.AnimState:PlayAnimation("horn")

        inst:PerformPreviewBufferedAction()
        inst.sg:SetTimeout(5)
    end,

    onupdate = function(inst)
        if inst:HasTag("doing") then
            if inst.entity:FlattenMovementPrediction() then
                inst.sg:GoToState("idle", "noanim")
            end
        elseif inst.bufferedaction == nil then
            inst.sg:GoToState("idle")
        end
    end,

    ontimeout = function(inst)
        inst:ClearBufferedAction()
        inst.sg:GoToState("idle")
    end
})

AddStategraphState("wilson", des_waterdrink_state)
AddStategraphState("wilson_client", des_waterdrink_state_client)


local des_waterdrink_ah = GLOBAL.ActionHandler( GLOBAL.ACTIONS.DES_DRINK, "des_waterdrink_action" )
AddStategraphActionHandler("wilson", des_waterdrink_ah)
AddStategraphActionHandler("wilson_client", des_waterdrink_ah)






------------------------------ POUR ACTION ty Star -------------------------
--

-- Custom DES_POUR that applies to firepit etc
local DES_POUR = AddAction("DES_POUR", "倒入", function(act)
	local player = act.doer
	local target = act.target
	local inst = act.invobject
	
	if inst ~= nil and target ~= nil and target:HasTag("water_trap_or_dest") then return end
	
	if inst ~= nil and target ~= nil and target:HasTag("cwater") and inst:HasTag("cwater") and inst.components.cwater.current>0 and target:HasTag("des_can_pour_to") and
		((not target.components.des_chainik_c) or (target.components.des_chainik_c and (target.components.cwater.special_drink == "" or  target.components.cwater.special_drink == "water")))
	then
		return inst.components.cwater:Transfuse(target, inst, nil, true, true) --Перелить inst в target
		
	elseif inst ~= nil and target ~= nil and target:HasTag("cwater") and inst:HasTag("cwater") and target.components.cwater.current>0 and target:HasTag("des_can_pour_to") and 
		target.components.des_chainik_c and target.components.cwater.special_drink ~= ""
	then
		----inverted variant so we can try and get drink portions from the kettle
		return inst.components.cwater:Transfuse(inst, target, nil, true, true) --Перелить target в inst
	end
end)
DES_POUR.priority = 100

-- State to go when entity wants to perform action
local DES_POUR_ah = _G.ActionHandler(ACTIONS.DES_POUR, "doshortaction")
AddStategraphActionHandler("wilson", DES_POUR_ah)
AddStategraphActionHandler("wilson_client", DES_POUR_ah)


------------------------------ GET WATER ACTION based on Star code -------------------------
--

-- Custom THIRST_TAKE_WATER that applies to ponds etc
local THIRST_TAKE_WATER = AddAction("THIRST_TAKE_WATER", "取水", function(act)
	local player = act.doer
	local target = act.target
	local inst = act.invobject
	if inst ~= nil and target ~= nil and target:HasTag("water_sourse_nolimit") and not target:HasTag("fire") and inst:HasTag("bottle")
	then	
			inst.components.cwater:DroppedBottle(inst, nil, target, true)
		return true
	end
	----return false

end)

-- State to go when entity wants to perform action
local ThirstGetWater_ah = _G.ActionHandler(ACTIONS.THIRST_TAKE_WATER, "dolongaction")
AddStategraphActionHandler("wilson", ThirstGetWater_ah)
AddStategraphActionHandler("wilson_client", ThirstGetWater_ah)

-- The THIRST_TAKE_WATER action applies to "oil_puddle" stuff
local function ThirstGetWater_componentaction(inst, doer, target, actions, right)
	if target:HasTag("water_sourse_nolimit") and inst:HasTag("bottle") and inst:HasTag("cwater_des_bottle")
		and not target:HasTag("fire")
	then
		table.insert(actions, ACTIONS.THIRST_TAKE_WATER)
		
	elseif target:HasTag("cwater") and inst:HasTag("bottle") and not target:HasTag("water_trap_or_dest") then
		table.insert(actions, ACTIONS.DES_POUR)
	
	
	end
end

AddComponentAction("USEITEM", "cwater", ThirstGetWater_componentaction)



---------------------------- Poison / clean PONDS --------------------------------------------------
--[[ Custom |Poison / clean| that applies to ponds etc
local THIRST_POISON_POND = AddAction("THIRST_POISON_POND", "Throw In", function(act)
	local player = act.doer
	local target = act.target
	local inst = act.invobject
	if inst ~= nil and target ~= nil and target:HasTag("water_sourse_nolimit") and inst:HasTag("des_cleantablet")
	then	
		print("187 THIRST_POISON_POND")
		--inst.components.cwater:DroppedBottle(inst, nil, target, true)
			--inst.components.cwater:DroppedBottle(inst, nil, target, true)
		return true
	end
	----return false

end)

-- State to go when entity wants to perform action
local ThirstPoisonPond_ah = _G.ActionHandler(ACTIONS.THIRST_POISON_POND, "give")
AddStategraphActionHandler("wilson", ThirstPoisonPond_ah)
AddStategraphActionHandler("wilson_client", ThirstPoisonPond_ah)

-- The THIRST_TAKE_WATER action applies to "oil_puddle" stuff
local function ThirstPoisonPond_componentaction(inst, doer, target, actions, right)
	if target:HasTag("water_sourse_nolimit") and (not target.prefab == "des_statue_charlie") and inst:HasTag("des_cleantablet")
		and not target:HasTag("fire")
	then
			print("206  table.insert THIRST_POISON_POND")
		table.insert(actions, ACTIONS.THIRST_POISON_POND)
			
	end
end

AddComponentAction("USEITEM", "des_throw_in", ThirstPoisonPond_componentaction)
--]]

------------------------------ GET OIL ACTION -------------------------
--

-- Custom THIRST_THROW_IN that applies to firepit etc
local THIRST_THROW_IN = AddAction("THIRST_THROW_IN", "加入", function(act)
	local player = act.doer
	local target = act.target
	local inst = act.invobject
	if inst ~= nil and target ~= nil and not target:HasTag("des_statue_charlie") and target:HasTag("water_sourse_nolimit")
	and not target:HasTag("fire") and (inst:HasTag("des_cleantablet") or inst:HasTag("des_water_poisoner")) and target.components.des_easy_code
	then
	
		target.components.des_easy_code:AddTabletOrPoisoner(target, inst, player)

		
		return true
	end
end)

-- State to go when entity wants to perform action
local THIRST_THROW_IN_ah = _G.ActionHandler(ACTIONS.THIRST_THROW_IN, "放入")
AddStategraphActionHandler("wilson", THIRST_THROW_IN_ah)
AddStategraphActionHandler("wilson_client", THIRST_THROW_IN_ah)



local THIRST_THROW_TEA_TABLET = AddAction("THIRST_THROW_TEA_TABLET", "放入茶块", function(act)
	local player = act.doer
	local target = act.target
	local inst = act.invobject
	if inst ~= nil and target ~= nil and target:HasTag("des_chainik_c") and inst:HasTag("des_zavarka")
	and target.components.des_chainik_c and not target.components.des_chainik_c.boiling and inst.components.des_throw_in
	then
		---(tablet, target, ammount, player, slot)
		inst.components.des_throw_in:ThrowToSlot(inst, target, nil, player, 2)

		return true
	end
end)
THIRST_THROW_TEA_TABLET.priority = 100
-- State to go when entity wants to perform action
local THIRST_THROW_TEA_TABLET_ah = _G.ActionHandler(ACTIONS.THIRST_THROW_TEA_TABLET, "放入")
AddStategraphActionHandler("wilson", THIRST_THROW_TEA_TABLET_ah)
AddStategraphActionHandler("wilson_client", THIRST_THROW_TEA_TABLET_ah)


-- The THIRST_THROW_IN action applies to "oil_puddle" stuff
local function GetOil_componentaction(inst, doer, target, actions, right)
	if target:HasTag("water_sourse_nolimit") and (inst:HasTag("des_cleantablet") or inst:HasTag("des_water_poisoner"))
		and not target:HasTag("fire")
	then
		table.insert(actions, ACTIONS.THIRST_THROW_IN)
		
		
	elseif target:HasTag("des_chainik_c") and inst:HasTag("des_zavarka") then
		table.insert(actions, ACTIONS.THIRST_THROW_TEA_TABLET)
	end
end

-- Stuff to equip or use as item with lighter component with run the check
--AddComponentAction("EQUIPPED", "fuel", GetOil_componentaction)
AddComponentAction("USEITEM", "des_throw_in", GetOil_componentaction)

------------------------------ POUR TO GROUND -------------------------
--


-- Custom DES_POUR that applies to firepit etc
local DES_GROUNDPOUR = AddAction("DES_GROUNDPOUR", "倒掉", function(act)
	-- local player = act.doer
	-- local target = act.target
	 local inst = act.invobject
	if act.doer.components.builder ~= nil and (inst.components.cwater ~= nil) and inst.components.cwater.current>1 and (inst:HasTag("des_bottle") or inst:HasTag("des_bucket")) then
		return inst.components.cwater:GroundPour(target, act.pos) --вылить inst на землю
	end
	
end)

-- State to go when entity wants to perform action
local DES_GROUNDPOUR_ah = _G.ActionHandler(ACTIONS.DES_GROUNDPOUR, "dolongaction")
AddStategraphActionHandler("wilson", DES_GROUNDPOUR_ah)
AddStategraphActionHandler("wilson_client", DES_GROUNDPOUR_ah)



local function FindOceanWaterRoG(inst, dist, atm)
	local attemp = atm or 0
    local dst = dist or 4
	local radius = dst
	local theta = math.random()*2*PI
	local offset = Vector3(radius * math.cos( theta ), 0, -radius * math.sin( theta ) )
	local pt = Vector3(inst.Transform:GetWorldPosition()) + offset  
	
	
	if pt and TheWorld.Map:GetTileAtPoint(pt:Get()) == GROUND.IMPASSABLE then
		return pt
    elseif attemp<20 then
		FindOceanWaterRoG(inst, dst+0.75, attemp+1)
	else
		return
	end
	
end

local DES_OCEAN_WATER = AddAction("DES_OCEAN_WATER", "取水", function(act)
	local player = act.doer
	-- local target = act.target

	local inst = act.invobject
	--local offest = FindOceanWaterRoG(player, nil,)
	if act.doer.components.builder ~= nil and (inst.components.cwater ~= nil) and (inst:HasTag("des_bottle") or inst:HasTag("des_bucket")) then
		-------- bottle, unused, forced target, forced nopickup, forced snow, forced ocean		
		print("DES_OCEAN_WATER")
		inst.components.cwater:DroppedBottle(inst, nil, nil, nil, nil, true)
		
		return true
		---return inst.components.cwater:Dr(target, act.pos) --вылить inst на землю
	end
	
end)

-- State to go when entity wants to perform action
local DES_OCEAN_WATER_ah = _G.ActionHandler(ACTIONS.DES_OCEAN_WATER, "dolongaction")
AddStategraphActionHandler("wilson", DES_OCEAN_WATER_ah)
AddStategraphActionHandler("wilson_client", DES_OCEAN_WATER_ah)

------------------------------ GET SNOW / POUR TO GROUND-------------------------
--
-- Custom DES_POUR that applies to firepit etc
local DES_FILL_SNOW = AddAction("DES_FILL_SNOW", "取雪", function(act)
	-- local player = act.doer
	-- local target = act.target
	 local inst = act.invobject

	if act.doer.components.builder ~= nil and (inst.components.cwater ~= nil) and inst.components.cwater.current<1 and (inst:HasTag("des_bottle") or inst:HasTag("des_bucket")) then
		-------- bottle, unused, forced target, forced nopickup, forced snow
		inst.components.cwater:DroppedBottle(inst, nil, nil, true, true)
		return true
	end
	return false
end)

-- State to go when entity wants to perform action
local DES_DES_FILL_SNOW_ah = _G.ActionHandler(ACTIONS.DES_FILL_SNOW, "dolongaction")
AddStategraphActionHandler("wilson", DES_DES_FILL_SNOW_ah)
AddStategraphActionHandler("wilson_client", DES_DES_FILL_SNOW_ah)



local function DES_DES_FILL_SNOW_ah(inst, doer, pos, actions, right)
	local player = doer
	--local offest = FindOceanWaterRoG(player, 2, 10)
	local savedoffest = TUNING.THIRST_ALWAYS_SHOW_OCEAN  ----- player.saved_ocean_offest or inst:HasTag("saved_ocean_offest")
	
	if right and inst:HasTag("cwater_des_bottle") then
		if inst:HasTag("cwater_empty") and TheWorld.state and TheWorld.state.snowlevel > 0.05 then  
			table.insert(actions, GLOBAL.ACTIONS.DES_FILL_SNOW)
		elseif inst:HasTag("cwater_full") then
			table.insert(actions, GLOBAL.ACTIONS.DES_GROUNDPOUR)	
		elseif inst:HasTag("cwater_empty") and savedoffest then
			table.insert(actions, GLOBAL.ACTIONS.DES_OCEAN_WATER)	
		else
			print("356 no savedoffest")
		end
	end
	
			
end
	

AddComponentAction("POINT", "cwater", DES_DES_FILL_SNOW_ah)




------------------------------ PLACE CHAINIK ON FIREPIT-------------------------

local THIRST_PLACECHAINIK = AddAction("THIRST_PLACECHAINIK", "give", function(act)
	local player = act.doer
	local target = act.target
	local inst = act.invobject
	

	
	if inst ~= nil and target ~= nil and inst:HasTag("des_chainik_placable") and inst:HasTag("des_chainik") and (target.prefab == "firepit" or target.prefab == "campfire")
		and target.components.fueled:GetCurrentSection() >= 1 ----and not target.des_chainik_link
		then

		inst.components.des_chainik_c:PlaceChainik(target, inst, player)

		
		return true
	end
end)

-- State to go when entity wants to perform action
local THIRST_PLACECHAINIK_ah = _G.ActionHandler(ACTIONS.THIRST_PLACECHAINIK, "give")
AddStategraphActionHandler("wilson", THIRST_PLACECHAINIK_ah)
AddStategraphActionHandler("wilson_client", THIRST_PLACECHAINIK_ah)

-- The THIRST_PLACECHAINIK action
local function PlaceChainik_componentaction(inst, doer, target, actions, right)
	if inst:HasTag("des_chainik") and inst:HasTag("des_chainik_placable") and (target.prefab == "firepit" or target.prefab == "campfire") then
		---print("local function PlaceChainik_componentaction(inst, doer, target, actions, right)")
		table.insert(actions, ACTIONS.THIRST_PLACECHAINIK)
	end
end
   -- inst:AddTag("campfire")

    --cooker (from cooker component) added to pristine state for optimization
    --inst:AddTag("cooker")
-- Stuff to equip or use as item with lighter component with run the check
--AddComponentAction("EQUIPPED", "fuel", GetOil_componentaction)
AddComponentAction("USEITEM", "des_chainik_c", PlaceChainik_componentaction)

