
------------------------------------------------------
------------------ PREFABS UPDATES -------------------
------------------------------------------------------

local seg_time = 30
local total_day_time = seg_time*16
local FIRESUPPRESSOR_MAX_FUEL_TIME = total_day_time*5
local MED_FUEL = seg_time * 1.5 ---- one log

_G = GLOBAL
local Ingredient = GLOBAL.Ingredient
local RECIPETABS = GLOBAL.RECIPETABS
local STRINGS = GLOBAL.STRINGS
local TECH = GLOBAL.TECH



local PETALSPERDAY = 0.1
local MAXPETALS = 1
local childtype = "des_ivan_chai_tree"



local function PlantFlower(inst)
	local minrad=1.5
	local maxrad=4
	
	--inst exists
	if not inst then return end
	local pt = inst:GetPosition()
	
	--not too many children
	local ents = TheSim:FindEntities(pt.x, pt.y, pt.z, maxrad)
	local count=0
	for k,v in pairs(ents) do
		if v.prefab == childtype then
			count = count + 1
		end
	end
	if count>=MAXPETALS then return end
	
	
	--Find spot for new child and spawn
	local angle=math.random()*2*PI
	local radius=math.random()*(maxrad-minrad)+minrad
	local offset, check_angle, deflected=FindWalkableOffset(pt, angle, radius, 8, true, false)
	if(not check_angle) then return end
	angle=check_angle
	pt.x=pt.x+radius*math.cos(angle)
	pt.z=pt.z-radius*math.sin(angle)
	
	SpawnPrefab(childtype).Transform:SetPosition(pt:Get())
end


local function BeehiveUpdate(inst)
    if not TheWorld.ismastersim then
        return inst
    end
	
	local growth_stages = {
		{name="only",
		time=function(inst) return TUNING.TOTAL_DAY_TIME/PETALSPERDAY end,
		fn=function(inst) PlantFlower(inst) end},
	}
	inst:AddComponent("growable")
	inst.components.growable.stages = growth_stages
	inst.components.growable:SetStage(1)
	inst.components.growable.loopstages = true
	inst.components.growable:StartGrowing()


end


AddPrefabPostInit("beehive", BeehiveUpdate)
AddPrefabPostInit("wasphive", BeehiveUpdate)


----------------------------------------------------
----------------------------------------------------
----------------------------------------------------
local keep_recipes_array_tee =
{

	----_fili_tee
	"tee_s",
	"tea_honey",
	"tee_m",
	"tea_berry",
	"tee_r",
	"tee_r2",
	"tea_carrot",
	"tea_banana",
	"tea_cactus",
	"tee_g",
	
	---
	--"beer_barrle",
	-- "flour",
	-- "cup_strang",
	
	-- ---
	-- "grass_bag",
}


local function AddTablet(inst)
	inst:AddComponent("des_throw_in")
	inst:AddTag("des_zavarka")
end

for k,v in pairs(keep_recipes_array_tee) do	
	print("Brew added = ".. v)
			AddPrefabPostInit(v,
			function(inst)
				AddTablet(inst)
			end)
end 	

----------------------------------------------------
----------------------------------------------------
----------------------------------------------------

---------------------------------------------------------------------------
----------------COFFEE INIT----------------
local coffe_init_list = 
{
	"coffeebeans",
	"coffeebeans_cooked",
	
	---fili
	"coffe_beans",
	"coffe_beans_raw",
}	

local function SetUpCoffee(inst, replacer)
	inst:AddComponent("des_throw_in")
	inst:AddTag("des_zavarka")
	inst.equals_to = "des_chai_tabl_"..replacer
end

for k,v in pairs(coffe_init_list) do	
			AddPrefabPostInit(v,
			function(inst)
			print("478 Brew added = ".. v)
				SetUpCoffee(inst, "coffee")
			end)
end
-------------------------------------------
---------------------------------------------------------------------------

