



_G = GLOBAL
local Ingredient = GLOBAL.Ingredient
local RECIPETABS = GLOBAL.RECIPETABS
local STRINGS = GLOBAL.STRINGS
local TECH = GLOBAL.TECH

----------------------------------------
------------Rename ACTIVATE-------------
----------------------------------------
GLOBAL.STRINGS["ACTIONS"]["ACTIVATE"]["DRINK"] = "喝水"

local function GetVerb()
    return GLOBAL.STRINGS["ACTIONS"]["ACTIVATE"]["DRINK"]
end
----------------------------------------
----------------------------------------
----------------------------------------


local function OnActivatePondThirst(inst, player)
	local wx = false
	if inst.prefab == "des_statue_charlie" and inst.currentanim and inst.currentanim == "fsp_dry" then return end
		wx = false
	if inst.prefab == "wx78" then
		wx = true
	end
	--print("drink from! special")
	if (inst.frozen == nil or inst.frozen == false) then
			inst.components.activatable.inactive = true
			
		if (inst.components.cwater and inst.components.cwater.current>5) or inst:HasTag("water_sourse_nolimit") then
			player.components.temperature.current =player.components.temperature.current-5
			if player.components.moisture then
				player.components.moisture:DoDelta(math.random(5,10))
			end
		end

		if inst:HasTag("water_sourse_limit") then
			if inst.components.cwater.current>5 and inst.components.finiteuses then
				inst.components.finiteuses:Use(5)
			end
			local waterf = {"清爽!","很好.","现在好多了","我不渴了","我需要瓶子装它"}
			local phrase = waterf[math.random(#waterf)]
			if inst.components.cwater.current> TUNING.POND_WATER_RESTORE then	
				player.components.thirst:DoDelta(TUNING.POND_WATER_RESTORE)
				player.components.talker:Say(phrase)
			elseif inst.components.cwater.current>5 then
				player.components.thirst:DoDelta(inst.components.cwater.current)
				player.components.talker:Say(phrase)
			else
				player.components.talker:Say("It's empty!")
			end
			inst.components.cwater:DoDelta(-TUNING.POND_WATER_RESTORE)
		else
			if wx == false then
				if inst:HasTag("water_sourse_bad")  then
					player.components.sanity:DoDelta(-10)
				end
				if inst:HasTag("water_sourse_poisoned")  then
					player.components.sanity:DoDelta(-15)
					player.components.hunger:DoDelta(-15)
				end
			elseif wx == true and not (inst:HasTag("water_sourse_bad") or inst:HasTag("water_sourse_poisoned")) then
					player.components.sanity:DoDelta(-15)
					player.components.health:DoDelta(-7)
			end
			player.components.thirst:DoDelta(TUNING.POND_WATER_RESTORE)
			if math.random()<TUNING.DES_SNAKE_SPAWN_ONDRINK_CHANCE then 
				local fx = SpawnPrefab("splash_ocean")
				fx.entity:AddAnimState()
				fx.Transform:SetPosition(player.Transform:GetWorldPosition())
				fx.AnimState:SetMultColour(0.4,0.4,1,1)
				fx.Transform:SetScale(.4, .4, .4)
				local snake = SpawnPrefab("des_water_snake")
				snake.Transform:SetPosition(player.Transform:GetWorldPosition())
				snake.components.combat:SuggestTarget(player)
			end
		end
		
		if inst:HasTag("water_sourse_salty") then
			player.components.thirst:DoDelta(-TUNING.POND_WATER_RESTORE*0.35)
			player.components.health:DoDelta(-TUNING.POND_WATER_RESTORE*0.35)
			player.components.talker:Say("Salty!")
		end
			player.components.thirst.timetosay = 20
	end
end


local function GetVerbPondThirst(inst)
	return STRINGS.DRINKFROM
end




local function PondUpdateThirstNoLimit(prefab)
	local inst=prefab
	inst:AddComponent("activatable")
    inst.components.activatable.OnActivate = OnActivatePondThirst
    inst.components.activatable.inactive = true
    inst.GetActivateVerb = GetVerb
	inst.components.activatable.quickaction = false
	inst:AddTag("water_sourse")
	inst:AddTag("water_sourse_nolimit")
	inst:AddTag("water_sourse_no_limit")
	
	inst:AddComponent("des_easy_code")
	
	inst:AddTag("water_sourse_poisonable")
	
	inst:AddTag("water_sourse_bad")
	if (inst=="tidalpool") or (inst=="fishinhole") then
		inst:AddTag("water_sourse_salty")
	end

end

local function PondMakeUnpoisonable(inst)
	inst:RemoveTag("water_sourse_poisonable")
end

local function PondUpdateThirst(prefab)
	local inst=prefab
	inst:AddComponent("activatable")
    inst.components.activatable.OnActivate = OnActivatePondThirst
    inst.components.activatable.inactive = true
    inst.GetActivateVerb = GetVerb
	inst.components.activatable.quickaction = false
	inst:AddTag("water_sourse")
	inst:AddTag("water_sourse_limit")
end


AddPrefabPostInit("pond", PondUpdateThirstNoLimit)
AddPrefabPostInit("pond_mos", PondUpdateThirstNoLimit)
AddPrefabPostInit("pond_cave", PondUpdateThirstNoLimit)
AddPrefabPostInit("tidalpool", PondUpdateThirstNoLimit)
AddPrefabPostInit("fishinhole", PondUpdateThirstNoLimit)
----------------------------------------------------
------------------------RIVER------------------------
AddPrefabPostInit("des_river", PondUpdateThirstNoLimit)
AddPrefabPostInit("des_water_side_idle", PondUpdateThirstNoLimit)
AddPrefabPostInit("des_river_fishinghole", PondUpdateThirstNoLimit)

AddPrefabPostInit("des_river", PondMakeUnpoisonable)
AddPrefabPostInit("des_water_side_idle", PondMakeUnpoisonable)
AddPrefabPostInit("des_river_fishinghole", PondMakeUnpoisonable)

--------------------------------------------------------
----------------------------------------------------

local function PondUpdateThirstNoLimitGoodWater(prefab)
	local inst=prefab
	inst:AddComponent("activatable")
    inst.components.activatable.OnActivate = OnActivatePondThirst
    inst.components.activatable.inactive = true
	inst.GetActivateVerb = GetVerb
	inst.components.activatable.quickaction = false

end
AddPrefabPostInit("des_statue_charlie", PondUpdateThirstNoLimitGoodWater)


--AddPrefabPostInit("watertrap_grass", PondUpdateThirst)
--AddPrefabPostInit("watertrap_silk", PondUpdateThirst)
--AddPrefabPostInit("watertrap_gem", PondUpdateThirst)

AddPrefabPostInit("pondbuild", PondUpdateThirst)




